# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/ActuatorArmed.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class ActuatorArmed(genpy.Message):
  _md5sum = "6d57f10c2a7705d79b513d23e753d7e3"
  _type = "px4_msgs/ActuatorArmed"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp	# time since system start (microseconds)

uint32 armed_time_ms	# Arming timestamp
bool armed		# Set to true if system is armed
bool prearmed		# Set to true if the actuator safety is disabled but motors are not armed
bool ready_to_arm	# Set to true if system is ready to be armed
bool lockdown		# Set to true if actuators are forced to being disabled (due to emergency or HIL)
bool manual_lockdown    # Set to true if manual throttle kill switch is engaged
bool force_failsafe	# Set to true if the actuators are forced to the failsafe position
bool in_esc_calibration_mode # IO/FMU should ignore messages from the actuator controls topics
bool soft_stop # Set to true if we need to ESCs to remove the idle constraint
"""
  __slots__ = ['timestamp','armed_time_ms','armed','prearmed','ready_to_arm','lockdown','manual_lockdown','force_failsafe','in_esc_calibration_mode','soft_stop']
  _slot_types = ['uint64','uint32','bool','bool','bool','bool','bool','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,armed_time_ms,armed,prearmed,ready_to_arm,lockdown,manual_lockdown,force_failsafe,in_esc_calibration_mode,soft_stop

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ActuatorArmed, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.armed_time_ms is None:
        self.armed_time_ms = 0
      if self.armed is None:
        self.armed = False
      if self.prearmed is None:
        self.prearmed = False
      if self.ready_to_arm is None:
        self.ready_to_arm = False
      if self.lockdown is None:
        self.lockdown = False
      if self.manual_lockdown is None:
        self.manual_lockdown = False
      if self.force_failsafe is None:
        self.force_failsafe = False
      if self.in_esc_calibration_mode is None:
        self.in_esc_calibration_mode = False
      if self.soft_stop is None:
        self.soft_stop = False
    else:
      self.timestamp = 0
      self.armed_time_ms = 0
      self.armed = False
      self.prearmed = False
      self.ready_to_arm = False
      self.lockdown = False
      self.manual_lockdown = False
      self.force_failsafe = False
      self.in_esc_calibration_mode = False
      self.soft_stop = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_QI8B().pack(_x.timestamp, _x.armed_time_ms, _x.armed, _x.prearmed, _x.ready_to_arm, _x.lockdown, _x.manual_lockdown, _x.force_failsafe, _x.in_esc_calibration_mode, _x.soft_stop))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 20
      (_x.timestamp, _x.armed_time_ms, _x.armed, _x.prearmed, _x.ready_to_arm, _x.lockdown, _x.manual_lockdown, _x.force_failsafe, _x.in_esc_calibration_mode, _x.soft_stop,) = _get_struct_QI8B().unpack(str[start:end])
      self.armed = bool(self.armed)
      self.prearmed = bool(self.prearmed)
      self.ready_to_arm = bool(self.ready_to_arm)
      self.lockdown = bool(self.lockdown)
      self.manual_lockdown = bool(self.manual_lockdown)
      self.force_failsafe = bool(self.force_failsafe)
      self.in_esc_calibration_mode = bool(self.in_esc_calibration_mode)
      self.soft_stop = bool(self.soft_stop)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_QI8B().pack(_x.timestamp, _x.armed_time_ms, _x.armed, _x.prearmed, _x.ready_to_arm, _x.lockdown, _x.manual_lockdown, _x.force_failsafe, _x.in_esc_calibration_mode, _x.soft_stop))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 20
      (_x.timestamp, _x.armed_time_ms, _x.armed, _x.prearmed, _x.ready_to_arm, _x.lockdown, _x.manual_lockdown, _x.force_failsafe, _x.in_esc_calibration_mode, _x.soft_stop,) = _get_struct_QI8B().unpack(str[start:end])
      self.armed = bool(self.armed)
      self.prearmed = bool(self.prearmed)
      self.ready_to_arm = bool(self.ready_to_arm)
      self.lockdown = bool(self.lockdown)
      self.manual_lockdown = bool(self.manual_lockdown)
      self.force_failsafe = bool(self.force_failsafe)
      self.in_esc_calibration_mode = bool(self.in_esc_calibration_mode)
      self.soft_stop = bool(self.soft_stop)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_QI8B = None
def _get_struct_QI8B():
    global _struct_QI8B
    if _struct_QI8B is None:
        _struct_QI8B = struct.Struct("<QI8B")
    return _struct_QI8B
