# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/AirspeedValidated.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class AirspeedValidated(genpy.Message):
  _md5sum = "5a6d400a36498def4f986eee5aff8eca"
  _type = "px4_msgs/AirspeedValidated"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp			# time since system start (microseconds)

float32 indicated_airspeed_m_s		# indicated airspeed in m/s (IAS), set to NAN if invalid
float32 equivalent_airspeed_m_s     # equivalent airspeed in m/s (accounts for instrumentation errors) (EAS), set to NAN if invalid
float32 true_airspeed_m_s			# true filtered airspeed in m/s (TAS), set to NAN if invalid

float32 true_ground_minus_wind_m_s 		# TAS calculated from groundspeed - windspeed, where windspeed is estimated based on a zero-sideslip assumption, set to NAN if invalid
float32 indicated_ground_minus_wind_m_s # IAS calculated from groundspeed - windspeed, where windspeed is estimated based on a zero-sideslip assumption, set to NAN if invalid

int8 selected_airspeed_index # 0-2: airspeed sensor index, -1: groundspeed-windspeed, -2: airspeed invalid
"""
  __slots__ = ['timestamp','indicated_airspeed_m_s','equivalent_airspeed_m_s','true_airspeed_m_s','true_ground_minus_wind_m_s','indicated_ground_minus_wind_m_s','selected_airspeed_index']
  _slot_types = ['uint64','float32','float32','float32','float32','float32','int8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,indicated_airspeed_m_s,equivalent_airspeed_m_s,true_airspeed_m_s,true_ground_minus_wind_m_s,indicated_ground_minus_wind_m_s,selected_airspeed_index

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AirspeedValidated, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.indicated_airspeed_m_s is None:
        self.indicated_airspeed_m_s = 0.
      if self.equivalent_airspeed_m_s is None:
        self.equivalent_airspeed_m_s = 0.
      if self.true_airspeed_m_s is None:
        self.true_airspeed_m_s = 0.
      if self.true_ground_minus_wind_m_s is None:
        self.true_ground_minus_wind_m_s = 0.
      if self.indicated_ground_minus_wind_m_s is None:
        self.indicated_ground_minus_wind_m_s = 0.
      if self.selected_airspeed_index is None:
        self.selected_airspeed_index = 0
    else:
      self.timestamp = 0
      self.indicated_airspeed_m_s = 0.
      self.equivalent_airspeed_m_s = 0.
      self.true_airspeed_m_s = 0.
      self.true_ground_minus_wind_m_s = 0.
      self.indicated_ground_minus_wind_m_s = 0.
      self.selected_airspeed_index = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q5fb().pack(_x.timestamp, _x.indicated_airspeed_m_s, _x.equivalent_airspeed_m_s, _x.true_airspeed_m_s, _x.true_ground_minus_wind_m_s, _x.indicated_ground_minus_wind_m_s, _x.selected_airspeed_index))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 29
      (_x.timestamp, _x.indicated_airspeed_m_s, _x.equivalent_airspeed_m_s, _x.true_airspeed_m_s, _x.true_ground_minus_wind_m_s, _x.indicated_ground_minus_wind_m_s, _x.selected_airspeed_index,) = _get_struct_Q5fb().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q5fb().pack(_x.timestamp, _x.indicated_airspeed_m_s, _x.equivalent_airspeed_m_s, _x.true_airspeed_m_s, _x.true_ground_minus_wind_m_s, _x.indicated_ground_minus_wind_m_s, _x.selected_airspeed_index))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 29
      (_x.timestamp, _x.indicated_airspeed_m_s, _x.equivalent_airspeed_m_s, _x.true_airspeed_m_s, _x.true_ground_minus_wind_m_s, _x.indicated_ground_minus_wind_m_s, _x.selected_airspeed_index,) = _get_struct_Q5fb().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q5fb = None
def _get_struct_Q5fb():
    global _struct_Q5fb
    if _struct_Q5fb is None:
        _struct_Q5fb = struct.Struct("<Q5fb")
    return _struct_Q5fb
