# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/BatteryStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class BatteryStatus(genpy.Message):
  _md5sum = "9f8f86fcb01c5bc5ccb7901795260ecc"
  _type = "px4_msgs/BatteryStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp		# time since system start (microseconds)
float32 voltage_v		# Battery voltage in volts, 0 if unknown
float32 voltage_filtered_v	# Battery voltage in volts, filtered, 0 if unknown
float32 current_a		# Battery current in amperes, -1 if unknown
float32 current_filtered_a	# Battery current in amperes, filtered, 0 if unknown
float32 average_current_a		# Battery current average in amperes, -1 if unknown
float32 discharged_mah		# Discharged amount in mAh, -1 if unknown
float32 remaining		# From 1 to 0, -1 if unknown
float32 scale		# Power scaling factor, >= 1, or -1 if unknown
float32 temperature         # temperature of the battery. NaN if unknown
int32 cell_count		# Number of cells
bool connected			# Whether or not a battery is connected, based on a voltage threshold
bool system_source		# Whether or not a this battery is the active power source for VDD_5V_IN
uint8 priority        	# Zerro based priority is the connection on the Power Controller V1..Vn AKA BrickN-1
uint16 capacity         # actual capacity of the battery
uint16 cycle_count         # number of discharge cycles the battery has experienced
uint16 run_time_to_empty   # predicted remaining battery capacity based on the present rate of discharge in min
uint16 average_time_to_empty   # predicted remaining battery capacity based on the average rate of discharge in min
uint16 serial_number       # serial number of the battery pack

float32[4] voltage_cell_v   # Battery individual cell voltages
float32 max_cell_voltage_delta   # Max difference between individual cell voltages

bool is_powering_off		# Power off event imminent indication, false if unknown


uint8 BATTERY_WARNING_NONE = 0       # no battery low voltage warning active
uint8 BATTERY_WARNING_LOW = 1        # warning of low voltage
uint8 BATTERY_WARNING_CRITICAL = 2   # critical voltage, return / abort immediately
uint8 BATTERY_WARNING_EMERGENCY = 3   # immediate landing required
uint8 BATTERY_WARNING_FAILED = 4   # the battery has failed completely

uint8 warning    # current battery warning
"""
  # Pseudo-constants
  BATTERY_WARNING_NONE = 0
  BATTERY_WARNING_LOW = 1
  BATTERY_WARNING_CRITICAL = 2
  BATTERY_WARNING_EMERGENCY = 3
  BATTERY_WARNING_FAILED = 4

  __slots__ = ['timestamp','voltage_v','voltage_filtered_v','current_a','current_filtered_a','average_current_a','discharged_mah','remaining','scale','temperature','cell_count','connected','system_source','priority','capacity','cycle_count','run_time_to_empty','average_time_to_empty','serial_number','voltage_cell_v','max_cell_voltage_delta','is_powering_off','warning']
  _slot_types = ['uint64','float32','float32','float32','float32','float32','float32','float32','float32','float32','int32','bool','bool','uint8','uint16','uint16','uint16','uint16','uint16','float32[4]','float32','bool','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,voltage_v,voltage_filtered_v,current_a,current_filtered_a,average_current_a,discharged_mah,remaining,scale,temperature,cell_count,connected,system_source,priority,capacity,cycle_count,run_time_to_empty,average_time_to_empty,serial_number,voltage_cell_v,max_cell_voltage_delta,is_powering_off,warning

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(BatteryStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.voltage_v is None:
        self.voltage_v = 0.
      if self.voltage_filtered_v is None:
        self.voltage_filtered_v = 0.
      if self.current_a is None:
        self.current_a = 0.
      if self.current_filtered_a is None:
        self.current_filtered_a = 0.
      if self.average_current_a is None:
        self.average_current_a = 0.
      if self.discharged_mah is None:
        self.discharged_mah = 0.
      if self.remaining is None:
        self.remaining = 0.
      if self.scale is None:
        self.scale = 0.
      if self.temperature is None:
        self.temperature = 0.
      if self.cell_count is None:
        self.cell_count = 0
      if self.connected is None:
        self.connected = False
      if self.system_source is None:
        self.system_source = False
      if self.priority is None:
        self.priority = 0
      if self.capacity is None:
        self.capacity = 0
      if self.cycle_count is None:
        self.cycle_count = 0
      if self.run_time_to_empty is None:
        self.run_time_to_empty = 0
      if self.average_time_to_empty is None:
        self.average_time_to_empty = 0
      if self.serial_number is None:
        self.serial_number = 0
      if self.voltage_cell_v is None:
        self.voltage_cell_v = [0.] * 4
      if self.max_cell_voltage_delta is None:
        self.max_cell_voltage_delta = 0.
      if self.is_powering_off is None:
        self.is_powering_off = False
      if self.warning is None:
        self.warning = 0
    else:
      self.timestamp = 0
      self.voltage_v = 0.
      self.voltage_filtered_v = 0.
      self.current_a = 0.
      self.current_filtered_a = 0.
      self.average_current_a = 0.
      self.discharged_mah = 0.
      self.remaining = 0.
      self.scale = 0.
      self.temperature = 0.
      self.cell_count = 0
      self.connected = False
      self.system_source = False
      self.priority = 0
      self.capacity = 0
      self.cycle_count = 0
      self.run_time_to_empty = 0
      self.average_time_to_empty = 0
      self.serial_number = 0
      self.voltage_cell_v = [0.] * 4
      self.max_cell_voltage_delta = 0.
      self.is_powering_off = False
      self.warning = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q9fi3B5H().pack(_x.timestamp, _x.voltage_v, _x.voltage_filtered_v, _x.current_a, _x.current_filtered_a, _x.average_current_a, _x.discharged_mah, _x.remaining, _x.scale, _x.temperature, _x.cell_count, _x.connected, _x.system_source, _x.priority, _x.capacity, _x.cycle_count, _x.run_time_to_empty, _x.average_time_to_empty, _x.serial_number))
      buff.write(_get_struct_4f().pack(*self.voltage_cell_v))
      _x = self
      buff.write(_get_struct_f2B().pack(_x.max_cell_voltage_delta, _x.is_powering_off, _x.warning))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 61
      (_x.timestamp, _x.voltage_v, _x.voltage_filtered_v, _x.current_a, _x.current_filtered_a, _x.average_current_a, _x.discharged_mah, _x.remaining, _x.scale, _x.temperature, _x.cell_count, _x.connected, _x.system_source, _x.priority, _x.capacity, _x.cycle_count, _x.run_time_to_empty, _x.average_time_to_empty, _x.serial_number,) = _get_struct_Q9fi3B5H().unpack(str[start:end])
      self.connected = bool(self.connected)
      self.system_source = bool(self.system_source)
      start = end
      end += 16
      self.voltage_cell_v = _get_struct_4f().unpack(str[start:end])
      _x = self
      start = end
      end += 6
      (_x.max_cell_voltage_delta, _x.is_powering_off, _x.warning,) = _get_struct_f2B().unpack(str[start:end])
      self.is_powering_off = bool(self.is_powering_off)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q9fi3B5H().pack(_x.timestamp, _x.voltage_v, _x.voltage_filtered_v, _x.current_a, _x.current_filtered_a, _x.average_current_a, _x.discharged_mah, _x.remaining, _x.scale, _x.temperature, _x.cell_count, _x.connected, _x.system_source, _x.priority, _x.capacity, _x.cycle_count, _x.run_time_to_empty, _x.average_time_to_empty, _x.serial_number))
      buff.write(self.voltage_cell_v.tostring())
      _x = self
      buff.write(_get_struct_f2B().pack(_x.max_cell_voltage_delta, _x.is_powering_off, _x.warning))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 61
      (_x.timestamp, _x.voltage_v, _x.voltage_filtered_v, _x.current_a, _x.current_filtered_a, _x.average_current_a, _x.discharged_mah, _x.remaining, _x.scale, _x.temperature, _x.cell_count, _x.connected, _x.system_source, _x.priority, _x.capacity, _x.cycle_count, _x.run_time_to_empty, _x.average_time_to_empty, _x.serial_number,) = _get_struct_Q9fi3B5H().unpack(str[start:end])
      self.connected = bool(self.connected)
      self.system_source = bool(self.system_source)
      start = end
      end += 16
      self.voltage_cell_v = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=4)
      _x = self
      start = end
      end += 6
      (_x.max_cell_voltage_delta, _x.is_powering_off, _x.warning,) = _get_struct_f2B().unpack(str[start:end])
      self.is_powering_off = bool(self.is_powering_off)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_4f = None
def _get_struct_4f():
    global _struct_4f
    if _struct_4f is None:
        _struct_4f = struct.Struct("<4f")
    return _struct_4f
_struct_Q9fi3B5H = None
def _get_struct_Q9fi3B5H():
    global _struct_Q9fi3B5H
    if _struct_Q9fi3B5H is None:
        _struct_Q9fi3B5H = struct.Struct("<Q9fi3B5H")
    return _struct_Q9fi3B5H
_struct_f2B = None
def _get_struct_f2B():
    global _struct_f2B
    if _struct_f2B is None:
        _struct_f2B = struct.Struct("<f2B")
    return _struct_f2B
