# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/CameraCapture.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class CameraCapture(genpy.Message):
  _md5sum = "4da359d25c3ceb5ba830730fc7fddd26"
  _type = "px4_msgs/CameraCapture"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp		# time since system start (microseconds)
uint64 timestamp_utc		# Capture time in UTC / GPS time
uint32 seq					# Image sequence number
float64 lat					# Latitude in degrees (WGS84)
float64 lon					# Longitude in degrees (WGS84)
float32 alt					# Altitude (AMSL)
float32 ground_distance			# Altitude above ground (meters)
float32[4] q					# Attitude of the camera, zero rotation is facing towards front of vehicle
int8 result					# 1 for success, 0 for failure, -1 if camera does not provide feedback
"""
  __slots__ = ['timestamp','timestamp_utc','seq','lat','lon','alt','ground_distance','q','result']
  _slot_types = ['uint64','uint64','uint32','float64','float64','float32','float32','float32[4]','int8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,timestamp_utc,seq,lat,lon,alt,ground_distance,q,result

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CameraCapture, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.timestamp_utc is None:
        self.timestamp_utc = 0
      if self.seq is None:
        self.seq = 0
      if self.lat is None:
        self.lat = 0.
      if self.lon is None:
        self.lon = 0.
      if self.alt is None:
        self.alt = 0.
      if self.ground_distance is None:
        self.ground_distance = 0.
      if self.q is None:
        self.q = [0.] * 4
      if self.result is None:
        self.result = 0
    else:
      self.timestamp = 0
      self.timestamp_utc = 0
      self.seq = 0
      self.lat = 0.
      self.lon = 0.
      self.alt = 0.
      self.ground_distance = 0.
      self.q = [0.] * 4
      self.result = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2QI2d2f().pack(_x.timestamp, _x.timestamp_utc, _x.seq, _x.lat, _x.lon, _x.alt, _x.ground_distance))
      buff.write(_get_struct_4f().pack(*self.q))
      _x = self.result
      buff.write(_get_struct_b().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 44
      (_x.timestamp, _x.timestamp_utc, _x.seq, _x.lat, _x.lon, _x.alt, _x.ground_distance,) = _get_struct_2QI2d2f().unpack(str[start:end])
      start = end
      end += 16
      self.q = _get_struct_4f().unpack(str[start:end])
      start = end
      end += 1
      (self.result,) = _get_struct_b().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2QI2d2f().pack(_x.timestamp, _x.timestamp_utc, _x.seq, _x.lat, _x.lon, _x.alt, _x.ground_distance))
      buff.write(self.q.tostring())
      _x = self.result
      buff.write(_get_struct_b().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 44
      (_x.timestamp, _x.timestamp_utc, _x.seq, _x.lat, _x.lon, _x.alt, _x.ground_distance,) = _get_struct_2QI2d2f().unpack(str[start:end])
      start = end
      end += 16
      self.q = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=4)
      start = end
      end += 1
      (self.result,) = _get_struct_b().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2QI2d2f = None
def _get_struct_2QI2d2f():
    global _struct_2QI2d2f
    if _struct_2QI2d2f is None:
        _struct_2QI2d2f = struct.Struct("<2QI2d2f")
    return _struct_2QI2d2f
_struct_4f = None
def _get_struct_4f():
    global _struct_4f
    if _struct_4f is None:
        _struct_4f = struct.Struct("<4f")
    return _struct_4f
_struct_b = None
def _get_struct_b():
    global _struct_b
    if _struct_b is None:
        _struct_b = struct.Struct("<b")
    return _struct_b
