# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/DifferentialPressure.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class DifferentialPressure(genpy.Message):
  _md5sum = "0b3b4b0caa7c41a4dd64bfc0d1880ae6"
  _type = "px4_msgs/DifferentialPressure"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp				# time since system start (microseconds)
uint64 error_count				# Number of errors detected by driver
float32 differential_pressure_raw_pa		# Raw differential pressure reading (may be negative)
float32 differential_pressure_filtered_pa	# Low pass filtered differential pressure reading
float32 temperature				# Temperature provided by sensor, -1000.0f if unknown
uint32 device_id				# unique device ID for the sensor that does not change between power cycles
"""
  __slots__ = ['timestamp','error_count','differential_pressure_raw_pa','differential_pressure_filtered_pa','temperature','device_id']
  _slot_types = ['uint64','uint64','float32','float32','float32','uint32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,error_count,differential_pressure_raw_pa,differential_pressure_filtered_pa,temperature,device_id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DifferentialPressure, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.error_count is None:
        self.error_count = 0
      if self.differential_pressure_raw_pa is None:
        self.differential_pressure_raw_pa = 0.
      if self.differential_pressure_filtered_pa is None:
        self.differential_pressure_filtered_pa = 0.
      if self.temperature is None:
        self.temperature = 0.
      if self.device_id is None:
        self.device_id = 0
    else:
      self.timestamp = 0
      self.error_count = 0
      self.differential_pressure_raw_pa = 0.
      self.differential_pressure_filtered_pa = 0.
      self.temperature = 0.
      self.device_id = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2Q3fI().pack(_x.timestamp, _x.error_count, _x.differential_pressure_raw_pa, _x.differential_pressure_filtered_pa, _x.temperature, _x.device_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 32
      (_x.timestamp, _x.error_count, _x.differential_pressure_raw_pa, _x.differential_pressure_filtered_pa, _x.temperature, _x.device_id,) = _get_struct_2Q3fI().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2Q3fI().pack(_x.timestamp, _x.error_count, _x.differential_pressure_raw_pa, _x.differential_pressure_filtered_pa, _x.temperature, _x.device_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 32
      (_x.timestamp, _x.error_count, _x.differential_pressure_raw_pa, _x.differential_pressure_filtered_pa, _x.temperature, _x.device_id,) = _get_struct_2Q3fI().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2Q3fI = None
def _get_struct_2Q3fI():
    global _struct_2Q3fI
    if _struct_2Q3fI is None:
        _struct_2Q3fI = struct.Struct("<2Q3fI")
    return _struct_2Q3fI
