# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/DistanceSensor.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class DistanceSensor(genpy.Message):
  _md5sum = "c2c53d168f72f70542e034d02752e646"
  _type = "px4_msgs/DistanceSensor"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# DISTANCE_SENSOR message data

uint64 timestamp		# time since system start (microseconds)

float32 min_distance		# Minimum distance the sensor can measure (in m)
float32 max_distance		# Maximum distance the sensor can measure (in m)
float32 current_distance	# Current distance reading (in m)
float32 variance		# Measurement variance (in m^2), 0 for unknown / invalid readings
int8 signal_quality		# Signal quality in percent (0...100%), where 0 = invalid signal, 100 = perfect signal, and -1 = unknown signal quality.

uint8 type			# Type from MAV_DISTANCE_SENSOR enum
uint8 MAV_DISTANCE_SENSOR_LASER = 0
uint8 MAV_DISTANCE_SENSOR_ULTRASOUND = 1
uint8 MAV_DISTANCE_SENSOR_INFRARED = 2
uint8 MAV_DISTANCE_SENSOR_RADAR = 3

uint8 id			# Onboard ID of the sensor

float32 h_fov # Sensor horizontal field of view (rad)
float32 v_fov # Sensor vertical field of view (rad)
float32[4] q # Quaterion sensor orientation with respect to the vehicle body frame to specify the orientation ROTATION_CUSTOM

uint8 orientation		# Direction the sensor faces from MAV_SENSOR_ORIENTATION enum

uint8 ROTATION_YAW_0		= 0 # MAV_SENSOR_ROTATION_NONE
uint8 ROTATION_YAW_45		= 1 # MAV_SENSOR_ROTATION_YAW_45
uint8 ROTATION_YAW_90		= 2 # MAV_SENSOR_ROTATION_YAW_90
uint8 ROTATION_YAW_135		= 3 # MAV_SENSOR_ROTATION_YAW_135
uint8 ROTATION_YAW_180		= 4 # MAV_SENSOR_ROTATION_YAW_180
uint8 ROTATION_YAW_225		= 5 # MAV_SENSOR_ROTATION_YAW_225
uint8 ROTATION_YAW_270		= 6 # MAV_SENSOR_ROTATION_YAW_270
uint8 ROTATION_YAW_315		= 7 # MAV_SENSOR_ROTATION_YAW_315

uint8 ROTATION_FORWARD_FACING	= 0 # MAV_SENSOR_ROTATION_NONE
uint8 ROTATION_RIGHT_FACING	= 2 # MAV_SENSOR_ROTATION_YAW_90
uint8 ROTATION_BACKWARD_FACING	= 4 # MAV_SENSOR_ROTATION_YAW_180
uint8 ROTATION_LEFT_FACING	= 6 # MAV_SENSOR_ROTATION_YAW_270

uint8 ROTATION_UPWARD_FACING   = 24 # MAV_SENSOR_ROTATION_PITCH_90
uint8 ROTATION_DOWNWARD_FACING = 25 # MAV_SENSOR_ROTATION_PITCH_270

uint8 ROTATION_CUSTOM          = 100 # MAV_SENSOR_ROTATION_CUSTOM
"""
  # Pseudo-constants
  MAV_DISTANCE_SENSOR_LASER = 0
  MAV_DISTANCE_SENSOR_ULTRASOUND = 1
  MAV_DISTANCE_SENSOR_INFRARED = 2
  MAV_DISTANCE_SENSOR_RADAR = 3
  ROTATION_YAW_0 = 0
  ROTATION_YAW_45 = 1
  ROTATION_YAW_90 = 2
  ROTATION_YAW_135 = 3
  ROTATION_YAW_180 = 4
  ROTATION_YAW_225 = 5
  ROTATION_YAW_270 = 6
  ROTATION_YAW_315 = 7
  ROTATION_FORWARD_FACING = 0
  ROTATION_RIGHT_FACING = 2
  ROTATION_BACKWARD_FACING = 4
  ROTATION_LEFT_FACING = 6
  ROTATION_UPWARD_FACING = 24
  ROTATION_DOWNWARD_FACING = 25
  ROTATION_CUSTOM = 100

  __slots__ = ['timestamp','min_distance','max_distance','current_distance','variance','signal_quality','type','id','h_fov','v_fov','q','orientation']
  _slot_types = ['uint64','float32','float32','float32','float32','int8','uint8','uint8','float32','float32','float32[4]','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,min_distance,max_distance,current_distance,variance,signal_quality,type,id,h_fov,v_fov,q,orientation

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DistanceSensor, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.min_distance is None:
        self.min_distance = 0.
      if self.max_distance is None:
        self.max_distance = 0.
      if self.current_distance is None:
        self.current_distance = 0.
      if self.variance is None:
        self.variance = 0.
      if self.signal_quality is None:
        self.signal_quality = 0
      if self.type is None:
        self.type = 0
      if self.id is None:
        self.id = 0
      if self.h_fov is None:
        self.h_fov = 0.
      if self.v_fov is None:
        self.v_fov = 0.
      if self.q is None:
        self.q = [0.] * 4
      if self.orientation is None:
        self.orientation = 0
    else:
      self.timestamp = 0
      self.min_distance = 0.
      self.max_distance = 0.
      self.current_distance = 0.
      self.variance = 0.
      self.signal_quality = 0
      self.type = 0
      self.id = 0
      self.h_fov = 0.
      self.v_fov = 0.
      self.q = [0.] * 4
      self.orientation = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q4fb2B2f().pack(_x.timestamp, _x.min_distance, _x.max_distance, _x.current_distance, _x.variance, _x.signal_quality, _x.type, _x.id, _x.h_fov, _x.v_fov))
      buff.write(_get_struct_4f().pack(*self.q))
      _x = self.orientation
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 35
      (_x.timestamp, _x.min_distance, _x.max_distance, _x.current_distance, _x.variance, _x.signal_quality, _x.type, _x.id, _x.h_fov, _x.v_fov,) = _get_struct_Q4fb2B2f().unpack(str[start:end])
      start = end
      end += 16
      self.q = _get_struct_4f().unpack(str[start:end])
      start = end
      end += 1
      (self.orientation,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q4fb2B2f().pack(_x.timestamp, _x.min_distance, _x.max_distance, _x.current_distance, _x.variance, _x.signal_quality, _x.type, _x.id, _x.h_fov, _x.v_fov))
      buff.write(self.q.tostring())
      _x = self.orientation
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 35
      (_x.timestamp, _x.min_distance, _x.max_distance, _x.current_distance, _x.variance, _x.signal_quality, _x.type, _x.id, _x.h_fov, _x.v_fov,) = _get_struct_Q4fb2B2f().unpack(str[start:end])
      start = end
      end += 16
      self.q = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=4)
      start = end
      end += 1
      (self.orientation,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_4f = None
def _get_struct_4f():
    global _struct_4f
    if _struct_4f is None:
        _struct_4f = struct.Struct("<4f")
    return _struct_4f
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_Q4fb2B2f = None
def _get_struct_Q4fb2B2f():
    global _struct_Q4fb2B2f
    if _struct_Q4fb2B2f is None:
        _struct_Q4fb2B2f = struct.Struct("<Q4fb2B2f")
    return _struct_Q4fb2B2f
