# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/Ekf2Timestamps.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class Ekf2Timestamps(genpy.Message):
  _md5sum = "53408f415d4fa5e6be10fa6dc6c68cc9"
  _type = "px4_msgs/Ekf2Timestamps"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# this message contains the (relative) timestamps of the sensor inputs used by
# ekf2. It can be used for reproducible replay.

# the timestamp field is the ekf2 reference time and matches the timestamp of
# the sensor_combined topic.

uint64 timestamp			 # time since system start (microseconds)

int16 RELATIVE_TIMESTAMP_INVALID = 32767 # (0x7fff) If one of the relative timestamps
                                         # is set to this value, it means the associated sensor values did not update

# timestamps are relative to the main timestamp and are in 0.1 ms (timestamp +
# *_timestamp_rel = absolute timestamp). For int16, this allows a maximum
# difference of +-3.2s to the sensor_combined topic.

int16 airspeed_timestamp_rel
int16 distance_sensor_timestamp_rel
int16 gps_timestamp_rel
int16 optical_flow_timestamp_rel
int16 vehicle_air_data_timestamp_rel
int16 vehicle_magnetometer_timestamp_rel
int16 visual_odometry_timestamp_rel

# Note: this is a high-rate logged topic, so it needs to be as small as possible
"""
  # Pseudo-constants
  RELATIVE_TIMESTAMP_INVALID = 32767

  __slots__ = ['timestamp','airspeed_timestamp_rel','distance_sensor_timestamp_rel','gps_timestamp_rel','optical_flow_timestamp_rel','vehicle_air_data_timestamp_rel','vehicle_magnetometer_timestamp_rel','visual_odometry_timestamp_rel']
  _slot_types = ['uint64','int16','int16','int16','int16','int16','int16','int16']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,airspeed_timestamp_rel,distance_sensor_timestamp_rel,gps_timestamp_rel,optical_flow_timestamp_rel,vehicle_air_data_timestamp_rel,vehicle_magnetometer_timestamp_rel,visual_odometry_timestamp_rel

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Ekf2Timestamps, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.airspeed_timestamp_rel is None:
        self.airspeed_timestamp_rel = 0
      if self.distance_sensor_timestamp_rel is None:
        self.distance_sensor_timestamp_rel = 0
      if self.gps_timestamp_rel is None:
        self.gps_timestamp_rel = 0
      if self.optical_flow_timestamp_rel is None:
        self.optical_flow_timestamp_rel = 0
      if self.vehicle_air_data_timestamp_rel is None:
        self.vehicle_air_data_timestamp_rel = 0
      if self.vehicle_magnetometer_timestamp_rel is None:
        self.vehicle_magnetometer_timestamp_rel = 0
      if self.visual_odometry_timestamp_rel is None:
        self.visual_odometry_timestamp_rel = 0
    else:
      self.timestamp = 0
      self.airspeed_timestamp_rel = 0
      self.distance_sensor_timestamp_rel = 0
      self.gps_timestamp_rel = 0
      self.optical_flow_timestamp_rel = 0
      self.vehicle_air_data_timestamp_rel = 0
      self.vehicle_magnetometer_timestamp_rel = 0
      self.visual_odometry_timestamp_rel = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q7h().pack(_x.timestamp, _x.airspeed_timestamp_rel, _x.distance_sensor_timestamp_rel, _x.gps_timestamp_rel, _x.optical_flow_timestamp_rel, _x.vehicle_air_data_timestamp_rel, _x.vehicle_magnetometer_timestamp_rel, _x.visual_odometry_timestamp_rel))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 22
      (_x.timestamp, _x.airspeed_timestamp_rel, _x.distance_sensor_timestamp_rel, _x.gps_timestamp_rel, _x.optical_flow_timestamp_rel, _x.vehicle_air_data_timestamp_rel, _x.vehicle_magnetometer_timestamp_rel, _x.visual_odometry_timestamp_rel,) = _get_struct_Q7h().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q7h().pack(_x.timestamp, _x.airspeed_timestamp_rel, _x.distance_sensor_timestamp_rel, _x.gps_timestamp_rel, _x.optical_flow_timestamp_rel, _x.vehicle_air_data_timestamp_rel, _x.vehicle_magnetometer_timestamp_rel, _x.visual_odometry_timestamp_rel))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 22
      (_x.timestamp, _x.airspeed_timestamp_rel, _x.distance_sensor_timestamp_rel, _x.gps_timestamp_rel, _x.optical_flow_timestamp_rel, _x.vehicle_air_data_timestamp_rel, _x.vehicle_magnetometer_timestamp_rel, _x.visual_odometry_timestamp_rel,) = _get_struct_Q7h().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q7h = None
def _get_struct_Q7h():
    global _struct_Q7h
    if _struct_Q7h is None:
        _struct_Q7h = struct.Struct("<Q7h")
    return _struct_Q7h
