# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/EscReport.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class EscReport(genpy.Message):
  _md5sum = "9f3ace0f5087a9a66b76a2b258244fcb"
  _type = "px4_msgs/EscReport"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp					# time since system start (microseconds)
uint32 esc_errorcount					# Number of reported errors by ESC - if supported
int32 esc_rpm						# Motor RPM, negative for reverse rotation [RPM] - if supported
float32 esc_voltage					# Voltage measured from current ESC [V] - if supported
float32 esc_current					# Current measured from current ESC [A] - if supported
uint8 esc_temperature					# Temperature measured from current ESC [degC] - if supported
float32 esc_setpoint					# setpoint of current ESC
uint16 esc_setpoint_raw					# setpoint of current ESC (Value sent to ESC)
uint16 esc_address					# Address of current ESC (in most cases 1-8 / must be set by driver)
uint8 esc_state					# State of ESC - depend on Vendor
"""
  __slots__ = ['timestamp','esc_errorcount','esc_rpm','esc_voltage','esc_current','esc_temperature','esc_setpoint','esc_setpoint_raw','esc_address','esc_state']
  _slot_types = ['uint64','uint32','int32','float32','float32','uint8','float32','uint16','uint16','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,esc_errorcount,esc_rpm,esc_voltage,esc_current,esc_temperature,esc_setpoint,esc_setpoint_raw,esc_address,esc_state

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EscReport, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.esc_errorcount is None:
        self.esc_errorcount = 0
      if self.esc_rpm is None:
        self.esc_rpm = 0
      if self.esc_voltage is None:
        self.esc_voltage = 0.
      if self.esc_current is None:
        self.esc_current = 0.
      if self.esc_temperature is None:
        self.esc_temperature = 0
      if self.esc_setpoint is None:
        self.esc_setpoint = 0.
      if self.esc_setpoint_raw is None:
        self.esc_setpoint_raw = 0
      if self.esc_address is None:
        self.esc_address = 0
      if self.esc_state is None:
        self.esc_state = 0
    else:
      self.timestamp = 0
      self.esc_errorcount = 0
      self.esc_rpm = 0
      self.esc_voltage = 0.
      self.esc_current = 0.
      self.esc_temperature = 0
      self.esc_setpoint = 0.
      self.esc_setpoint_raw = 0
      self.esc_address = 0
      self.esc_state = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_QIi2fBf2HB().pack(_x.timestamp, _x.esc_errorcount, _x.esc_rpm, _x.esc_voltage, _x.esc_current, _x.esc_temperature, _x.esc_setpoint, _x.esc_setpoint_raw, _x.esc_address, _x.esc_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 34
      (_x.timestamp, _x.esc_errorcount, _x.esc_rpm, _x.esc_voltage, _x.esc_current, _x.esc_temperature, _x.esc_setpoint, _x.esc_setpoint_raw, _x.esc_address, _x.esc_state,) = _get_struct_QIi2fBf2HB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_QIi2fBf2HB().pack(_x.timestamp, _x.esc_errorcount, _x.esc_rpm, _x.esc_voltage, _x.esc_current, _x.esc_temperature, _x.esc_setpoint, _x.esc_setpoint_raw, _x.esc_address, _x.esc_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 34
      (_x.timestamp, _x.esc_errorcount, _x.esc_rpm, _x.esc_voltage, _x.esc_current, _x.esc_temperature, _x.esc_setpoint, _x.esc_setpoint_raw, _x.esc_address, _x.esc_state,) = _get_struct_QIi2fBf2HB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_QIi2fBf2HB = None
def _get_struct_QIi2fBf2HB():
    global _struct_QIi2fBf2HB
    if _struct_QIi2fBf2HB is None:
        _struct_QIi2fBf2HB = struct.Struct("<QIi2fBf2HB")
    return _struct_QIi2fBf2HB
