# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/EscStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import px4_msgs.msg

class EscStatus(genpy.Message):
  _md5sum = "7bb39ab81d55dc5865493d752a9328ea"
  _type = "px4_msgs/EscStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp					# time since system start (microseconds)
uint8 CONNECTED_ESC_MAX = 8				# The number of ESCs supported. Current (Q2/2013) we support 8 ESCs

uint8 ESC_CONNECTION_TYPE_PPM = 0			# Traditional PPM ESC
uint8 ESC_CONNECTION_TYPE_SERIAL = 1			# Serial Bus connected ESC
uint8 ESC_CONNECTION_TYPE_ONESHOT = 2			# One Shot PPM
uint8 ESC_CONNECTION_TYPE_I2C = 3			# I2C
uint8 ESC_CONNECTION_TYPE_CAN = 4			# CAN-Bus
uint8 ESC_CONNECTION_TYPE_DSHOT = 5			# DShot

uint16 counter  					# incremented by the writing thread everytime new data is stored

uint8 esc_count						# number of connected ESCs
uint8 esc_connectiontype				# how ESCs connected to the system

uint8 esc_online_flags					# Bitmask indicating which ESC is online/offline
# esc_online_flags bit 0 : Set to 1 if ESC0 is online
# esc_online_flags bit 1 : Set to 1 if ESC1 is online
# esc_online_flags bit 2 : Set to 1 if ESC2 is online
# esc_online_flags bit 3 : Set to 1 if ESC3 is online
# esc_online_flags bit 4 : Set to 1 if ESC4 is online
# esc_online_flags bit 5 : Set to 1 if ESC5 is online
# esc_online_flags bit 6 : Set to 1 if ESC6 is online
# esc_online_flags bit 7 : Set to 1 if ESC7 is online

EscReport[8] esc

================================================================================
MSG: px4_msgs/EscReport
uint64 timestamp					# time since system start (microseconds)
uint32 esc_errorcount					# Number of reported errors by ESC - if supported
int32 esc_rpm						# Motor RPM, negative for reverse rotation [RPM] - if supported
float32 esc_voltage					# Voltage measured from current ESC [V] - if supported
float32 esc_current					# Current measured from current ESC [A] - if supported
uint8 esc_temperature					# Temperature measured from current ESC [degC] - if supported
float32 esc_setpoint					# setpoint of current ESC
uint16 esc_setpoint_raw					# setpoint of current ESC (Value sent to ESC)
uint16 esc_address					# Address of current ESC (in most cases 1-8 / must be set by driver)
uint8 esc_state					# State of ESC - depend on Vendor
"""
  # Pseudo-constants
  CONNECTED_ESC_MAX = 8
  ESC_CONNECTION_TYPE_PPM = 0
  ESC_CONNECTION_TYPE_SERIAL = 1
  ESC_CONNECTION_TYPE_ONESHOT = 2
  ESC_CONNECTION_TYPE_I2C = 3
  ESC_CONNECTION_TYPE_CAN = 4
  ESC_CONNECTION_TYPE_DSHOT = 5

  __slots__ = ['timestamp','counter','esc_count','esc_connectiontype','esc_online_flags','esc']
  _slot_types = ['uint64','uint16','uint8','uint8','uint8','px4_msgs/EscReport[8]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,counter,esc_count,esc_connectiontype,esc_online_flags,esc

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EscStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.counter is None:
        self.counter = 0
      if self.esc_count is None:
        self.esc_count = 0
      if self.esc_connectiontype is None:
        self.esc_connectiontype = 0
      if self.esc_online_flags is None:
        self.esc_online_flags = 0
      if self.esc is None:
        self.esc = [px4_msgs.msg.EscReport() for _ in range(8)]
    else:
      self.timestamp = 0
      self.counter = 0
      self.esc_count = 0
      self.esc_connectiontype = 0
      self.esc_online_flags = 0
      self.esc = [px4_msgs.msg.EscReport() for _ in range(8)]

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_QH3B().pack(_x.timestamp, _x.counter, _x.esc_count, _x.esc_connectiontype, _x.esc_online_flags))
      if len(self.esc) != 8:
        self._check_types(ValueError("Expecting %s items but found %s when writing '%s'" % (8, len(self.esc), 'self.esc')))
      for val1 in self.esc:
        _x = val1
        buff.write(_get_struct_QIi2fBf2HB().pack(_x.timestamp, _x.esc_errorcount, _x.esc_rpm, _x.esc_voltage, _x.esc_current, _x.esc_temperature, _x.esc_setpoint, _x.esc_setpoint_raw, _x.esc_address, _x.esc_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.esc is None:
        self.esc = None
      end = 0
      _x = self
      start = end
      end += 13
      (_x.timestamp, _x.counter, _x.esc_count, _x.esc_connectiontype, _x.esc_online_flags,) = _get_struct_QH3B().unpack(str[start:end])
      self.esc = []
      for i in range(0, 8):
        val1 = px4_msgs.msg.EscReport()
        _x = val1
        start = end
        end += 34
        (_x.timestamp, _x.esc_errorcount, _x.esc_rpm, _x.esc_voltage, _x.esc_current, _x.esc_temperature, _x.esc_setpoint, _x.esc_setpoint_raw, _x.esc_address, _x.esc_state,) = _get_struct_QIi2fBf2HB().unpack(str[start:end])
        self.esc.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_QH3B().pack(_x.timestamp, _x.counter, _x.esc_count, _x.esc_connectiontype, _x.esc_online_flags))
      if len(self.esc) != 8:
        self._check_types(ValueError("Expecting %s items but found %s when writing '%s'" % (8, len(self.esc), 'self.esc')))
      for val1 in self.esc:
        _x = val1
        buff.write(_get_struct_QIi2fBf2HB().pack(_x.timestamp, _x.esc_errorcount, _x.esc_rpm, _x.esc_voltage, _x.esc_current, _x.esc_temperature, _x.esc_setpoint, _x.esc_setpoint_raw, _x.esc_address, _x.esc_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.esc is None:
        self.esc = None
      end = 0
      _x = self
      start = end
      end += 13
      (_x.timestamp, _x.counter, _x.esc_count, _x.esc_connectiontype, _x.esc_online_flags,) = _get_struct_QH3B().unpack(str[start:end])
      self.esc = []
      for i in range(0, 8):
        val1 = px4_msgs.msg.EscReport()
        _x = val1
        start = end
        end += 34
        (_x.timestamp, _x.esc_errorcount, _x.esc_rpm, _x.esc_voltage, _x.esc_current, _x.esc_temperature, _x.esc_setpoint, _x.esc_setpoint_raw, _x.esc_address, _x.esc_state,) = _get_struct_QIi2fBf2HB().unpack(str[start:end])
        self.esc.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_QH3B = None
def _get_struct_QH3B():
    global _struct_QH3B
    if _struct_QH3B is None:
        _struct_QH3B = struct.Struct("<QH3B")
    return _struct_QH3B
_struct_QIi2fBf2HB = None
def _get_struct_QIi2fBf2HB():
    global _struct_QIi2fBf2HB
    if _struct_QIi2fBf2HB is None:
        _struct_QIi2fBf2HB = struct.Struct("<QIi2fBf2HB")
    return _struct_QIi2fBf2HB
