# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/EstimatorStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class EstimatorStatus(genpy.Message):
  _md5sum = "910939f018cb2124f29d537308d667a0"
  _type = "px4_msgs/EstimatorStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp		# time since system start (microseconds)
float32[24] states		# Internal filter states
uint8 n_states		# Number of states effectively used

float32[3] vibe			# IMU vibration metrics in the following array locations
# 0 : Gyro delta angle coning metric = filtered length of (delta_angle x prev_delta_angle)
# 1 : Gyro high frequency vibe = filtered length of (delta_angle - prev_delta_angle)
# 2 : Accel high frequency vibe = filtered length of (delta_velocity - prev_delta_velocity)

float32[24] covariances	# Diagonal Elements of Covariance Matrix

uint16 gps_check_fail_flags     # Bitmask to indicate status of GPS checks - see definition below
# bits are true when corresponding test has failed
uint8 GPS_CHECK_FAIL_GPS_FIX = 0		# 0 : insufficient fix type (no 3D solution)
uint8 GPS_CHECK_FAIL_MIN_SAT_COUNT = 1		# 1 : minimum required sat count fail
uint8 GPS_CHECK_FAIL_MIN_GDOP = 2		# 2 : minimum required GDoP fail
uint8 GPS_CHECK_FAIL_MAX_HORZ_ERR = 3		# 3 : maximum allowed horizontal position error fail
uint8 GPS_CHECK_FAIL_MAX_VERT_ERR = 4		# 4 : maximum allowed vertical position error fail
uint8 GPS_CHECK_FAIL_MAX_SPD_ERR = 5		# 5 : maximum allowed speed error fail
uint8 GPS_CHECK_FAIL_MAX_HORZ_DRIFT = 6		# 6 : maximum allowed horizontal position drift fail - requires stationary vehicle
uint8 GPS_CHECK_FAIL_MAX_VERT_DRIFT = 7		# 7 : maximum allowed vertical position drift fail - requires stationary vehicle
uint8 GPS_CHECK_FAIL_MAX_HORZ_SPD_ERR = 8	# 8 : maximum allowed horizontal speed fail - requires stationary vehicle
uint8 GPS_CHECK_FAIL_MAX_VERT_SPD_ERR = 9	# 9 : maximum allowed vertical velocity discrepancy fail

uint32 control_mode_flags	# Bitmask to indicate EKF logic state
uint8 CS_TILT_ALIGN = 0		# 0 - true if the filter tilt alignment is complete
uint8 CS_YAW_ALIGN = 1		# 1 - true if the filter yaw alignment is complete
uint8 CS_GPS = 2		# 2 - true if GPS measurements are being fused
uint8 CS_OPT_FLOW = 3		# 3 - true if optical flow measurements are being fused
uint8 CS_MAG_HDG = 4		# 4 - true if a simple magnetic yaw heading is being fused
uint8 CS_MAG_3D = 5		# 5 - true if 3-axis magnetometer measurement are being fused
uint8 CS_MAG_DEC = 6		# 6 - true if synthetic magnetic declination measurements are being fused
uint8 CS_IN_AIR = 7		# 7 - true when thought to be airborne
uint8 CS_WIND = 8		# 8 - true when wind velocity is being estimated
uint8 CS_BARO_HGT = 9		# 9 - true when baro height is being fused as a primary height reference
uint8 CS_RNG_HGT = 10		# 10 - true when range finder height is being fused as a primary height reference
uint8 CS_GPS_HGT = 11		# 11 - true when GPS height is being fused as a primary height reference
uint8 CS_EV_POS = 12		# 12 - true when local position data from external vision is being fused
uint8 CS_EV_YAW = 13		# 13 - true when yaw data from external vision measurements is being fused
uint8 CS_EV_HGT = 14		# 14 - true when height data from external vision measurements is being fused
uint8 CS_BETA = 15		# 15 - true when synthetic sideslip measurements are being fused
uint8 CS_MAG_FIELD = 16		# 16 - true when only the magnetic field states are updated by the magnetometer
uint8 CS_FIXED_WING = 17	# 17 - true when thought to be operating as a fixed wing vehicle with constrained sideslip
uint8 CS_MAG_FAULT = 18		# 18 - true when the magnetomer has been declared faulty and is no longer being used
uint8 CS_ASPD = 19		# 19 - true when airspeed measurements are being fused
uint8 CS_GND_EFFECT = 20	# 20 - true when when protection from ground effect induced static pressure rise is active
uint8 CS_RNG_STUCK = 21		# 21 - true when a stuck range finder sensor has been detected
uint8 CS_GPS_YAW = 22		# 22 - true when yaw (not ground course) data from a GPS receiver is being fused
uint8 CS_MAG_ALIGNED = 23	# 23 - true when the in-flight mag field alignment has been completed

uint16 filter_fault_flags	# Bitmask to indicate EKF internal faults
# 0 - true if the fusion of the magnetometer X-axis has encountered a numerical error
# 1 - true if the fusion of the magnetometer Y-axis has encountered a numerical error
# 2 - true if the fusion of the magnetometer Z-axis has encountered a numerical error
# 3 - true if the fusion of the magnetic heading has encountered a numerical error
# 4 - true if the fusion of the magnetic declination has encountered a numerical error
# 5 - true if fusion of the airspeed has encountered a numerical error
# 6 - true if fusion of the synthetic sideslip constraint has encountered a numerical error
# 7 - true if fusion of the optical flow X axis has encountered a numerical error
# 8 - true if fusion of the optical flow Y axis has encountered a numerical error
# 9 - true if fusion of the North velocity has encountered a numerical error
# 10 - true if fusion of the East velocity has encountered a numerical error
# 11 - true if fusion of the Down velocity has encountered a numerical error
# 12 - true if fusion of the North position has encountered a numerical error
# 13 - true if fusion of the East position has encountered a numerical error
# 14 - true if fusion of the Down position has encountered a numerical error
# 15 - true if bad delta velocity bias estimates have been detected

float32 pos_horiz_accuracy # 1-Sigma estimated horizontal position accuracy relative to the estimators origin (m)
float32 pos_vert_accuracy # 1-Sigma estimated vertical position accuracy relative to the estimators origin (m)
uint16 innovation_check_flags # Bitmask to indicate pass/fail status of innovation consistency checks
# 0 - true if velocity observations have been rejected
# 1 - true if horizontal position observations have been rejected
# 2 - true if true if vertical position observations have been rejected
# 3 - true if the X magnetometer observation has been rejected
# 4 - true if the Y magnetometer observation has been rejected
# 5 - true if the Z magnetometer observation has been rejected
# 6 - true if the yaw observation has been rejected
# 7 - true if the airspeed observation has been rejected
# 8 - true if the synthetic sideslip observation has been rejected
# 9 - true if the height above ground observation has been rejected
# 10 - true if the X optical flow observation has been rejected
# 11 - true if the Y optical flow observation has been rejected

float32 mag_test_ratio # ratio of the largest magnetometer innovation component to the innovation test limit
float32 vel_test_ratio # ratio of the largest velocity innovation component to the innovation test limit
float32 pos_test_ratio # ratio of the largest horizontal position innovation component to the innovation test limit
float32 hgt_test_ratio # ratio of the vertical position innovation to the innovation test limit
float32 tas_test_ratio # ratio of the true airspeed innovation to the innovation test limit
float32 hagl_test_ratio # ratio of the height above ground innovation to the innovation test limit
float32 beta_test_ratio # ratio of the synthetic sideslip innovation to the innovation test limit

uint16 solution_status_flags # Bitmask indicating which filter kinematic state outputs are valid for flight control use.
# 0 - True if the attitude estimate is good
# 1 - True if the horizontal velocity estimate is good
# 2 - True if the vertical velocity estimate is good
# 3 - True if the horizontal position (relative) estimate is good
# 4 - True if the horizontal position (absolute) estimate is good
# 5 - True if the vertical position (absolute) estimate is good
# 6 - True if the vertical position (above ground) estimate is good
# 7 - True if the EKF is in a constant position mode and is not using external measurements (eg GPS or optical flow)
# 8 - True if the EKF has sufficient data to enter a mode that will provide a (relative) position estimate
# 9 - True if the EKF has sufficient data to enter a mode that will provide a (absolute) position estimate
# 10 - True if the EKF has detected a GPS glitch
# 11 - True if the EKF has detected bad accelerometer data

float32 time_slip # cumulative amount of time in seconds that the EKF inertial calculation has slipped relative to system time

bool pre_flt_fail # true when estimator has failed pre-flight checks and the vehicle should not be flown regardless of flight mode


# legacy local position estimator (LPE) flags
uint8 health_flags		# Bitmask to indicate sensor health states (vel, pos, hgt)
uint8 timeout_flags		# Bitmask to indicate timeout flags (vel, pos, hgt)
"""
  # Pseudo-constants
  GPS_CHECK_FAIL_GPS_FIX = 0
  GPS_CHECK_FAIL_MIN_SAT_COUNT = 1
  GPS_CHECK_FAIL_MIN_GDOP = 2
  GPS_CHECK_FAIL_MAX_HORZ_ERR = 3
  GPS_CHECK_FAIL_MAX_VERT_ERR = 4
  GPS_CHECK_FAIL_MAX_SPD_ERR = 5
  GPS_CHECK_FAIL_MAX_HORZ_DRIFT = 6
  GPS_CHECK_FAIL_MAX_VERT_DRIFT = 7
  GPS_CHECK_FAIL_MAX_HORZ_SPD_ERR = 8
  GPS_CHECK_FAIL_MAX_VERT_SPD_ERR = 9
  CS_TILT_ALIGN = 0
  CS_YAW_ALIGN = 1
  CS_GPS = 2
  CS_OPT_FLOW = 3
  CS_MAG_HDG = 4
  CS_MAG_3D = 5
  CS_MAG_DEC = 6
  CS_IN_AIR = 7
  CS_WIND = 8
  CS_BARO_HGT = 9
  CS_RNG_HGT = 10
  CS_GPS_HGT = 11
  CS_EV_POS = 12
  CS_EV_YAW = 13
  CS_EV_HGT = 14
  CS_BETA = 15
  CS_MAG_FIELD = 16
  CS_FIXED_WING = 17
  CS_MAG_FAULT = 18
  CS_ASPD = 19
  CS_GND_EFFECT = 20
  CS_RNG_STUCK = 21
  CS_GPS_YAW = 22
  CS_MAG_ALIGNED = 23

  __slots__ = ['timestamp','states','n_states','vibe','covariances','gps_check_fail_flags','control_mode_flags','filter_fault_flags','pos_horiz_accuracy','pos_vert_accuracy','innovation_check_flags','mag_test_ratio','vel_test_ratio','pos_test_ratio','hgt_test_ratio','tas_test_ratio','hagl_test_ratio','beta_test_ratio','solution_status_flags','time_slip','pre_flt_fail','health_flags','timeout_flags']
  _slot_types = ['uint64','float32[24]','uint8','float32[3]','float32[24]','uint16','uint32','uint16','float32','float32','uint16','float32','float32','float32','float32','float32','float32','float32','uint16','float32','bool','uint8','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,states,n_states,vibe,covariances,gps_check_fail_flags,control_mode_flags,filter_fault_flags,pos_horiz_accuracy,pos_vert_accuracy,innovation_check_flags,mag_test_ratio,vel_test_ratio,pos_test_ratio,hgt_test_ratio,tas_test_ratio,hagl_test_ratio,beta_test_ratio,solution_status_flags,time_slip,pre_flt_fail,health_flags,timeout_flags

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EstimatorStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.states is None:
        self.states = [0.] * 24
      if self.n_states is None:
        self.n_states = 0
      if self.vibe is None:
        self.vibe = [0.] * 3
      if self.covariances is None:
        self.covariances = [0.] * 24
      if self.gps_check_fail_flags is None:
        self.gps_check_fail_flags = 0
      if self.control_mode_flags is None:
        self.control_mode_flags = 0
      if self.filter_fault_flags is None:
        self.filter_fault_flags = 0
      if self.pos_horiz_accuracy is None:
        self.pos_horiz_accuracy = 0.
      if self.pos_vert_accuracy is None:
        self.pos_vert_accuracy = 0.
      if self.innovation_check_flags is None:
        self.innovation_check_flags = 0
      if self.mag_test_ratio is None:
        self.mag_test_ratio = 0.
      if self.vel_test_ratio is None:
        self.vel_test_ratio = 0.
      if self.pos_test_ratio is None:
        self.pos_test_ratio = 0.
      if self.hgt_test_ratio is None:
        self.hgt_test_ratio = 0.
      if self.tas_test_ratio is None:
        self.tas_test_ratio = 0.
      if self.hagl_test_ratio is None:
        self.hagl_test_ratio = 0.
      if self.beta_test_ratio is None:
        self.beta_test_ratio = 0.
      if self.solution_status_flags is None:
        self.solution_status_flags = 0
      if self.time_slip is None:
        self.time_slip = 0.
      if self.pre_flt_fail is None:
        self.pre_flt_fail = False
      if self.health_flags is None:
        self.health_flags = 0
      if self.timeout_flags is None:
        self.timeout_flags = 0
    else:
      self.timestamp = 0
      self.states = [0.] * 24
      self.n_states = 0
      self.vibe = [0.] * 3
      self.covariances = [0.] * 24
      self.gps_check_fail_flags = 0
      self.control_mode_flags = 0
      self.filter_fault_flags = 0
      self.pos_horiz_accuracy = 0.
      self.pos_vert_accuracy = 0.
      self.innovation_check_flags = 0
      self.mag_test_ratio = 0.
      self.vel_test_ratio = 0.
      self.pos_test_ratio = 0.
      self.hgt_test_ratio = 0.
      self.tas_test_ratio = 0.
      self.hagl_test_ratio = 0.
      self.beta_test_ratio = 0.
      self.solution_status_flags = 0
      self.time_slip = 0.
      self.pre_flt_fail = False
      self.health_flags = 0
      self.timeout_flags = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.timestamp
      buff.write(_get_struct_Q().pack(_x))
      buff.write(_get_struct_24f().pack(*self.states))
      _x = self.n_states
      buff.write(_get_struct_B().pack(_x))
      buff.write(_get_struct_3f().pack(*self.vibe))
      buff.write(_get_struct_24f().pack(*self.covariances))
      _x = self
      buff.write(_get_struct_HIH2fH7fHf3B().pack(_x.gps_check_fail_flags, _x.control_mode_flags, _x.filter_fault_flags, _x.pos_horiz_accuracy, _x.pos_vert_accuracy, _x.innovation_check_flags, _x.mag_test_ratio, _x.vel_test_ratio, _x.pos_test_ratio, _x.hgt_test_ratio, _x.tas_test_ratio, _x.hagl_test_ratio, _x.beta_test_ratio, _x.solution_status_flags, _x.time_slip, _x.pre_flt_fail, _x.health_flags, _x.timeout_flags))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 8
      (self.timestamp,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 96
      self.states = _get_struct_24f().unpack(str[start:end])
      start = end
      end += 1
      (self.n_states,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 12
      self.vibe = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 96
      self.covariances = _get_struct_24f().unpack(str[start:end])
      _x = self
      start = end
      end += 55
      (_x.gps_check_fail_flags, _x.control_mode_flags, _x.filter_fault_flags, _x.pos_horiz_accuracy, _x.pos_vert_accuracy, _x.innovation_check_flags, _x.mag_test_ratio, _x.vel_test_ratio, _x.pos_test_ratio, _x.hgt_test_ratio, _x.tas_test_ratio, _x.hagl_test_ratio, _x.beta_test_ratio, _x.solution_status_flags, _x.time_slip, _x.pre_flt_fail, _x.health_flags, _x.timeout_flags,) = _get_struct_HIH2fH7fHf3B().unpack(str[start:end])
      self.pre_flt_fail = bool(self.pre_flt_fail)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.timestamp
      buff.write(_get_struct_Q().pack(_x))
      buff.write(self.states.tostring())
      _x = self.n_states
      buff.write(_get_struct_B().pack(_x))
      buff.write(self.vibe.tostring())
      buff.write(self.covariances.tostring())
      _x = self
      buff.write(_get_struct_HIH2fH7fHf3B().pack(_x.gps_check_fail_flags, _x.control_mode_flags, _x.filter_fault_flags, _x.pos_horiz_accuracy, _x.pos_vert_accuracy, _x.innovation_check_flags, _x.mag_test_ratio, _x.vel_test_ratio, _x.pos_test_ratio, _x.hgt_test_ratio, _x.tas_test_ratio, _x.hagl_test_ratio, _x.beta_test_ratio, _x.solution_status_flags, _x.time_slip, _x.pre_flt_fail, _x.health_flags, _x.timeout_flags))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 8
      (self.timestamp,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 96
      self.states = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=24)
      start = end
      end += 1
      (self.n_states,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 12
      self.vibe = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 96
      self.covariances = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=24)
      _x = self
      start = end
      end += 55
      (_x.gps_check_fail_flags, _x.control_mode_flags, _x.filter_fault_flags, _x.pos_horiz_accuracy, _x.pos_vert_accuracy, _x.innovation_check_flags, _x.mag_test_ratio, _x.vel_test_ratio, _x.pos_test_ratio, _x.hgt_test_ratio, _x.tas_test_ratio, _x.hagl_test_ratio, _x.beta_test_ratio, _x.solution_status_flags, _x.time_slip, _x.pre_flt_fail, _x.health_flags, _x.timeout_flags,) = _get_struct_HIH2fH7fHf3B().unpack(str[start:end])
      self.pre_flt_fail = bool(self.pre_flt_fail)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_24f = None
def _get_struct_24f():
    global _struct_24f
    if _struct_24f is None:
        _struct_24f = struct.Struct("<24f")
    return _struct_24f
_struct_3f = None
def _get_struct_3f():
    global _struct_3f
    if _struct_3f is None:
        _struct_3f = struct.Struct("<3f")
    return _struct_3f
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_HIH2fH7fHf3B = None
def _get_struct_HIH2fH7fHf3B():
    global _struct_HIH2fH7fHf3B
    if _struct_HIH2fH7fHf3B is None:
        _struct_HIH2fH7fHf3B = struct.Struct("<HIH2fH7fHf3B")
    return _struct_HIH2fH7fHf3B
_struct_Q = None
def _get_struct_Q():
    global _struct_Q
    if _struct_Q is None:
        _struct_Q = struct.Struct("<Q")
    return _struct_Q
