# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/FwVirtualAttitudeSetpoint.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class FwVirtualAttitudeSetpoint(genpy.Message):
  _md5sum = "7589df6ed48db404fc271691f763cc83"
  _type = "px4_msgs/FwVirtualAttitudeSetpoint"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp		# time since system start (microseconds)

float32 roll_body		# body angle in NED frame (can be NaN for FW)
float32 pitch_body		# body angle in NED frame (can be NaN for FW)
float32 yaw_body		# body angle in NED frame (can be NaN for FW)

float32 yaw_sp_move_rate	# rad/s (commanded by user)

# For quaternion-based attitude control
float32[4] q_d			# Desired quaternion for quaternion control
bool q_d_valid			# Set to true if quaternion vector is valid

# For clarification: For multicopters thrust_body[0] and thrust[1] are usually 0 and thrust[2] is the negative throttle demand.
# For fixed wings thrust_x is the throttle demand and thrust_y, thrust_z will usually be zero.
float32[3] thrust_body		# Normalized thrust command in body NED frame [-1,1]

bool roll_reset_integral	# Reset roll integral part (navigation logic change)
bool pitch_reset_integral	# Reset pitch integral part (navigation logic change)
bool yaw_reset_integral	# Reset yaw integral part (navigation logic change)

bool fw_control_yaw		# control heading with rudder (used for auto takeoff on runway)

uint8 apply_flaps       	# flap config specifier
uint8 FLAPS_OFF = 0     	# no flaps
uint8 FLAPS_LAND = 1    	# landing config flaps
uint8 FLAPS_TAKEOFF = 2 	# take-off config flaps

"""
  # Pseudo-constants
  FLAPS_OFF = 0
  FLAPS_LAND = 1
  FLAPS_TAKEOFF = 2

  __slots__ = ['timestamp','roll_body','pitch_body','yaw_body','yaw_sp_move_rate','q_d','q_d_valid','thrust_body','roll_reset_integral','pitch_reset_integral','yaw_reset_integral','fw_control_yaw','apply_flaps']
  _slot_types = ['uint64','float32','float32','float32','float32','float32[4]','bool','float32[3]','bool','bool','bool','bool','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,roll_body,pitch_body,yaw_body,yaw_sp_move_rate,q_d,q_d_valid,thrust_body,roll_reset_integral,pitch_reset_integral,yaw_reset_integral,fw_control_yaw,apply_flaps

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(FwVirtualAttitudeSetpoint, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.roll_body is None:
        self.roll_body = 0.
      if self.pitch_body is None:
        self.pitch_body = 0.
      if self.yaw_body is None:
        self.yaw_body = 0.
      if self.yaw_sp_move_rate is None:
        self.yaw_sp_move_rate = 0.
      if self.q_d is None:
        self.q_d = [0.] * 4
      if self.q_d_valid is None:
        self.q_d_valid = False
      if self.thrust_body is None:
        self.thrust_body = [0.] * 3
      if self.roll_reset_integral is None:
        self.roll_reset_integral = False
      if self.pitch_reset_integral is None:
        self.pitch_reset_integral = False
      if self.yaw_reset_integral is None:
        self.yaw_reset_integral = False
      if self.fw_control_yaw is None:
        self.fw_control_yaw = False
      if self.apply_flaps is None:
        self.apply_flaps = 0
    else:
      self.timestamp = 0
      self.roll_body = 0.
      self.pitch_body = 0.
      self.yaw_body = 0.
      self.yaw_sp_move_rate = 0.
      self.q_d = [0.] * 4
      self.q_d_valid = False
      self.thrust_body = [0.] * 3
      self.roll_reset_integral = False
      self.pitch_reset_integral = False
      self.yaw_reset_integral = False
      self.fw_control_yaw = False
      self.apply_flaps = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q4f().pack(_x.timestamp, _x.roll_body, _x.pitch_body, _x.yaw_body, _x.yaw_sp_move_rate))
      buff.write(_get_struct_4f().pack(*self.q_d))
      _x = self.q_d_valid
      buff.write(_get_struct_B().pack(_x))
      buff.write(_get_struct_3f().pack(*self.thrust_body))
      _x = self
      buff.write(_get_struct_5B().pack(_x.roll_reset_integral, _x.pitch_reset_integral, _x.yaw_reset_integral, _x.fw_control_yaw, _x.apply_flaps))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 24
      (_x.timestamp, _x.roll_body, _x.pitch_body, _x.yaw_body, _x.yaw_sp_move_rate,) = _get_struct_Q4f().unpack(str[start:end])
      start = end
      end += 16
      self.q_d = _get_struct_4f().unpack(str[start:end])
      start = end
      end += 1
      (self.q_d_valid,) = _get_struct_B().unpack(str[start:end])
      self.q_d_valid = bool(self.q_d_valid)
      start = end
      end += 12
      self.thrust_body = _get_struct_3f().unpack(str[start:end])
      _x = self
      start = end
      end += 5
      (_x.roll_reset_integral, _x.pitch_reset_integral, _x.yaw_reset_integral, _x.fw_control_yaw, _x.apply_flaps,) = _get_struct_5B().unpack(str[start:end])
      self.roll_reset_integral = bool(self.roll_reset_integral)
      self.pitch_reset_integral = bool(self.pitch_reset_integral)
      self.yaw_reset_integral = bool(self.yaw_reset_integral)
      self.fw_control_yaw = bool(self.fw_control_yaw)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q4f().pack(_x.timestamp, _x.roll_body, _x.pitch_body, _x.yaw_body, _x.yaw_sp_move_rate))
      buff.write(self.q_d.tostring())
      _x = self.q_d_valid
      buff.write(_get_struct_B().pack(_x))
      buff.write(self.thrust_body.tostring())
      _x = self
      buff.write(_get_struct_5B().pack(_x.roll_reset_integral, _x.pitch_reset_integral, _x.yaw_reset_integral, _x.fw_control_yaw, _x.apply_flaps))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 24
      (_x.timestamp, _x.roll_body, _x.pitch_body, _x.yaw_body, _x.yaw_sp_move_rate,) = _get_struct_Q4f().unpack(str[start:end])
      start = end
      end += 16
      self.q_d = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=4)
      start = end
      end += 1
      (self.q_d_valid,) = _get_struct_B().unpack(str[start:end])
      self.q_d_valid = bool(self.q_d_valid)
      start = end
      end += 12
      self.thrust_body = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      _x = self
      start = end
      end += 5
      (_x.roll_reset_integral, _x.pitch_reset_integral, _x.yaw_reset_integral, _x.fw_control_yaw, _x.apply_flaps,) = _get_struct_5B().unpack(str[start:end])
      self.roll_reset_integral = bool(self.roll_reset_integral)
      self.pitch_reset_integral = bool(self.pitch_reset_integral)
      self.yaw_reset_integral = bool(self.yaw_reset_integral)
      self.fw_control_yaw = bool(self.fw_control_yaw)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3f = None
def _get_struct_3f():
    global _struct_3f
    if _struct_3f is None:
        _struct_3f = struct.Struct("<3f")
    return _struct_3f
_struct_4f = None
def _get_struct_4f():
    global _struct_4f
    if _struct_4f is None:
        _struct_4f = struct.Struct("<4f")
    return _struct_4f
_struct_5B = None
def _get_struct_5B():
    global _struct_5B
    if _struct_5B is None:
        _struct_5B = struct.Struct("<5B")
    return _struct_5B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_Q4f = None
def _get_struct_Q4f():
    global _struct_Q4f
    if _struct_Q4f is None:
        _struct_Q4f = struct.Struct("<Q4f")
    return _struct_Q4f
