# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/HomePosition.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class HomePosition(genpy.Message):
  _md5sum = "18e3fa503bfecf72b340ccc2d5c74850"
  _type = "px4_msgs/HomePosition"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# GPS home position in WGS84 coordinates.

uint64 timestamp			# time since system start (microseconds)

float64 lat				# Latitude in degrees
float64 lon				# Longitude in degrees
float32 alt				# Altitude in meters (AMSL)

float32 x				# X coordinate in meters
float32 y				# Y coordinate in meters
float32 z				# Z coordinate in meters

float32 yaw				# Yaw angle in radians

bool valid_alt		# true when the altitude has been set
bool valid_hpos		# true when the latitude and longitude have been set

bool manual_home	# true when home position was set manually
"""
  __slots__ = ['timestamp','lat','lon','alt','x','y','z','yaw','valid_alt','valid_hpos','manual_home']
  _slot_types = ['uint64','float64','float64','float32','float32','float32','float32','float32','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,lat,lon,alt,x,y,z,yaw,valid_alt,valid_hpos,manual_home

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(HomePosition, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.lat is None:
        self.lat = 0.
      if self.lon is None:
        self.lon = 0.
      if self.alt is None:
        self.alt = 0.
      if self.x is None:
        self.x = 0.
      if self.y is None:
        self.y = 0.
      if self.z is None:
        self.z = 0.
      if self.yaw is None:
        self.yaw = 0.
      if self.valid_alt is None:
        self.valid_alt = False
      if self.valid_hpos is None:
        self.valid_hpos = False
      if self.manual_home is None:
        self.manual_home = False
    else:
      self.timestamp = 0
      self.lat = 0.
      self.lon = 0.
      self.alt = 0.
      self.x = 0.
      self.y = 0.
      self.z = 0.
      self.yaw = 0.
      self.valid_alt = False
      self.valid_hpos = False
      self.manual_home = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q2d5f3B().pack(_x.timestamp, _x.lat, _x.lon, _x.alt, _x.x, _x.y, _x.z, _x.yaw, _x.valid_alt, _x.valid_hpos, _x.manual_home))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 47
      (_x.timestamp, _x.lat, _x.lon, _x.alt, _x.x, _x.y, _x.z, _x.yaw, _x.valid_alt, _x.valid_hpos, _x.manual_home,) = _get_struct_Q2d5f3B().unpack(str[start:end])
      self.valid_alt = bool(self.valid_alt)
      self.valid_hpos = bool(self.valid_hpos)
      self.manual_home = bool(self.manual_home)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q2d5f3B().pack(_x.timestamp, _x.lat, _x.lon, _x.alt, _x.x, _x.y, _x.z, _x.yaw, _x.valid_alt, _x.valid_hpos, _x.manual_home))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 47
      (_x.timestamp, _x.lat, _x.lon, _x.alt, _x.x, _x.y, _x.z, _x.yaw, _x.valid_alt, _x.valid_hpos, _x.manual_home,) = _get_struct_Q2d5f3B().unpack(str[start:end])
      self.valid_alt = bool(self.valid_alt)
      self.valid_hpos = bool(self.valid_hpos)
      self.manual_home = bool(self.manual_home)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q2d5f3B = None
def _get_struct_Q2d5f3B():
    global _struct_Q2d5f3B
    if _struct_Q2d5f3B is None:
        _struct_Q2d5f3B = struct.Struct("<Q2d5f3B")
    return _struct_Q2d5f3B
