# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/LandingTargetPose.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class LandingTargetPose(genpy.Message):
  _md5sum = "82a78a3abfe06c34356f9fb34083266e"
  _type = "px4_msgs/LandingTargetPose"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Relative position of precision land target in navigation (body fixed, north aligned, NED) and inertial (world fixed, north aligned, NED) frames

uint64 timestamp		# time since system start (microseconds)

bool is_static			# Flag indicating whether the landing target is static or moving with respect to the ground

bool rel_pos_valid		# Flag showing whether relative position is valid
bool rel_vel_valid		# Flag showing whether relative velocity is valid

float32 x_rel			# X/north position of target, relative to vehicle (navigation frame) [meters]
float32 y_rel			# Y/east position of target, relative to vehicle (navigation frame) [meters]
float32 z_rel			# Z/down position of target, relative to vehicle (navigation frame) [meters]

float32 vx_rel			# X/north velocity  of target, relative to vehicle (navigation frame) [meters/second]
float32 vy_rel			# Y/east velocity of target, relative to vehicle (navigation frame) [meters/second]

float32 cov_x_rel		# X/north position variance [meters^2]
float32 cov_y_rel		# Y/east position variance [meters^2]

float32 cov_vx_rel		# X/north velocity variance [(meters/second)^2]
float32 cov_vy_rel		# Y/east velocity variance [(meters/second)^2]

bool abs_pos_valid		# Flag showing whether absolute position is valid
float32 x_abs			# X/north position of target, relative to origin (navigation frame) [meters]
float32 y_abs			# Y/east position of target, relative to origin (navigation frame) [meters]
float32 z_abs			# Z/down position of target, relative to origin (navigation frame) [meters]
"""
  __slots__ = ['timestamp','is_static','rel_pos_valid','rel_vel_valid','x_rel','y_rel','z_rel','vx_rel','vy_rel','cov_x_rel','cov_y_rel','cov_vx_rel','cov_vy_rel','abs_pos_valid','x_abs','y_abs','z_abs']
  _slot_types = ['uint64','bool','bool','bool','float32','float32','float32','float32','float32','float32','float32','float32','float32','bool','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,is_static,rel_pos_valid,rel_vel_valid,x_rel,y_rel,z_rel,vx_rel,vy_rel,cov_x_rel,cov_y_rel,cov_vx_rel,cov_vy_rel,abs_pos_valid,x_abs,y_abs,z_abs

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LandingTargetPose, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.is_static is None:
        self.is_static = False
      if self.rel_pos_valid is None:
        self.rel_pos_valid = False
      if self.rel_vel_valid is None:
        self.rel_vel_valid = False
      if self.x_rel is None:
        self.x_rel = 0.
      if self.y_rel is None:
        self.y_rel = 0.
      if self.z_rel is None:
        self.z_rel = 0.
      if self.vx_rel is None:
        self.vx_rel = 0.
      if self.vy_rel is None:
        self.vy_rel = 0.
      if self.cov_x_rel is None:
        self.cov_x_rel = 0.
      if self.cov_y_rel is None:
        self.cov_y_rel = 0.
      if self.cov_vx_rel is None:
        self.cov_vx_rel = 0.
      if self.cov_vy_rel is None:
        self.cov_vy_rel = 0.
      if self.abs_pos_valid is None:
        self.abs_pos_valid = False
      if self.x_abs is None:
        self.x_abs = 0.
      if self.y_abs is None:
        self.y_abs = 0.
      if self.z_abs is None:
        self.z_abs = 0.
    else:
      self.timestamp = 0
      self.is_static = False
      self.rel_pos_valid = False
      self.rel_vel_valid = False
      self.x_rel = 0.
      self.y_rel = 0.
      self.z_rel = 0.
      self.vx_rel = 0.
      self.vy_rel = 0.
      self.cov_x_rel = 0.
      self.cov_y_rel = 0.
      self.cov_vx_rel = 0.
      self.cov_vy_rel = 0.
      self.abs_pos_valid = False
      self.x_abs = 0.
      self.y_abs = 0.
      self.z_abs = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q3B9fB3f().pack(_x.timestamp, _x.is_static, _x.rel_pos_valid, _x.rel_vel_valid, _x.x_rel, _x.y_rel, _x.z_rel, _x.vx_rel, _x.vy_rel, _x.cov_x_rel, _x.cov_y_rel, _x.cov_vx_rel, _x.cov_vy_rel, _x.abs_pos_valid, _x.x_abs, _x.y_abs, _x.z_abs))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 60
      (_x.timestamp, _x.is_static, _x.rel_pos_valid, _x.rel_vel_valid, _x.x_rel, _x.y_rel, _x.z_rel, _x.vx_rel, _x.vy_rel, _x.cov_x_rel, _x.cov_y_rel, _x.cov_vx_rel, _x.cov_vy_rel, _x.abs_pos_valid, _x.x_abs, _x.y_abs, _x.z_abs,) = _get_struct_Q3B9fB3f().unpack(str[start:end])
      self.is_static = bool(self.is_static)
      self.rel_pos_valid = bool(self.rel_pos_valid)
      self.rel_vel_valid = bool(self.rel_vel_valid)
      self.abs_pos_valid = bool(self.abs_pos_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q3B9fB3f().pack(_x.timestamp, _x.is_static, _x.rel_pos_valid, _x.rel_vel_valid, _x.x_rel, _x.y_rel, _x.z_rel, _x.vx_rel, _x.vy_rel, _x.cov_x_rel, _x.cov_y_rel, _x.cov_vx_rel, _x.cov_vy_rel, _x.abs_pos_valid, _x.x_abs, _x.y_abs, _x.z_abs))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 60
      (_x.timestamp, _x.is_static, _x.rel_pos_valid, _x.rel_vel_valid, _x.x_rel, _x.y_rel, _x.z_rel, _x.vx_rel, _x.vy_rel, _x.cov_x_rel, _x.cov_y_rel, _x.cov_vx_rel, _x.cov_vy_rel, _x.abs_pos_valid, _x.x_abs, _x.y_abs, _x.z_abs,) = _get_struct_Q3B9fB3f().unpack(str[start:end])
      self.is_static = bool(self.is_static)
      self.rel_pos_valid = bool(self.rel_pos_valid)
      self.rel_vel_valid = bool(self.rel_vel_valid)
      self.abs_pos_valid = bool(self.abs_pos_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q3B9fB3f = None
def _get_struct_Q3B9fB3f():
    global _struct_Q3B9fB3f
    if _struct_Q3B9fB3f is None:
        _struct_Q3B9fB3f = struct.Struct("<Q3B9fB3f")
    return _struct_Q3B9fB3f
