# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/LedControl.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class LedControl(genpy.Message):
  _md5sum = "38be95a926c49c99579f3dff6420d0f8"
  _type = "px4_msgs/LedControl"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# LED control: control a single or multiple LED's.
# These are the externally visible LED's, not the board LED's

uint64 timestamp		# time since system start (microseconds)

# colors
uint8 COLOR_OFF = 0 # this is only used in the drivers
uint8 COLOR_RED = 1
uint8 COLOR_GREEN = 2
uint8 COLOR_BLUE = 3
uint8 COLOR_YELLOW = 4
uint8 COLOR_PURPLE = 5
uint8 COLOR_AMBER = 6
uint8 COLOR_CYAN = 7
uint8 COLOR_WHITE = 8

# LED modes definitions
uint8 MODE_OFF = 0 # turn LED off
uint8 MODE_ON = 1  # turn LED on
uint8 MODE_DISABLED = 2  # disable this priority (switch to lower priority setting)
uint8 MODE_BLINK_SLOW = 3
uint8 MODE_BLINK_NORMAL = 4
uint8 MODE_BLINK_FAST = 5
uint8 MODE_BREATHE = 6 # continuously increase & decrease brightness (solid color if driver does not support it)
uint8 MODE_FLASH = 7 # two fast blinks (on/off) with timing as in MODE_BLINK_FAST and then off for a while

uint8 MAX_PRIORITY = 2 # maxium priority (minimum is 0)


uint8 led_mask # bitmask which LED(s) to control, set to 0xff for all
uint8 color # see COLOR_*
uint8 mode # see MODE_*
uint8 num_blinks # how many times to blink (number of on-off cycles if mode is one of MODE_BLINK_*) . Set to 0 for infinite
                 # in MODE_FLASH it is the number of cycles. Max number of blinks: 122 and max number of flash cycles: 20
uint8 priority # priority: higher priority events will override current lower priority events (see MAX_PRIORITY)

uint8 ORB_QUEUE_LENGTH = 4      # needs to match BOARD_MAX_LEDS
"""
  # Pseudo-constants
  COLOR_OFF = 0
  COLOR_RED = 1
  COLOR_GREEN = 2
  COLOR_BLUE = 3
  COLOR_YELLOW = 4
  COLOR_PURPLE = 5
  COLOR_AMBER = 6
  COLOR_CYAN = 7
  COLOR_WHITE = 8
  MODE_OFF = 0
  MODE_ON = 1
  MODE_DISABLED = 2
  MODE_BLINK_SLOW = 3
  MODE_BLINK_NORMAL = 4
  MODE_BLINK_FAST = 5
  MODE_BREATHE = 6
  MODE_FLASH = 7
  MAX_PRIORITY = 2
  ORB_QUEUE_LENGTH = 4

  __slots__ = ['timestamp','led_mask','color','mode','num_blinks','priority']
  _slot_types = ['uint64','uint8','uint8','uint8','uint8','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,led_mask,color,mode,num_blinks,priority

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LedControl, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.led_mask is None:
        self.led_mask = 0
      if self.color is None:
        self.color = 0
      if self.mode is None:
        self.mode = 0
      if self.num_blinks is None:
        self.num_blinks = 0
      if self.priority is None:
        self.priority = 0
    else:
      self.timestamp = 0
      self.led_mask = 0
      self.color = 0
      self.mode = 0
      self.num_blinks = 0
      self.priority = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q5B().pack(_x.timestamp, _x.led_mask, _x.color, _x.mode, _x.num_blinks, _x.priority))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 13
      (_x.timestamp, _x.led_mask, _x.color, _x.mode, _x.num_blinks, _x.priority,) = _get_struct_Q5B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q5B().pack(_x.timestamp, _x.led_mask, _x.color, _x.mode, _x.num_blinks, _x.priority))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 13
      (_x.timestamp, _x.led_mask, _x.color, _x.mode, _x.num_blinks, _x.priority,) = _get_struct_Q5B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q5B = None
def _get_struct_Q5B():
    global _struct_Q5B
    if _struct_Q5B is None:
        _struct_Q5B = struct.Struct("<Q5B")
    return _struct_Q5B
