# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/ManualControlSetpoint.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class ManualControlSetpoint(genpy.Message):
  _md5sum = "8e61afc2ce2c1629d34d5fe948d1d759"
  _type = "px4_msgs/ManualControlSetpoint"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp			# time since system start (microseconds)

uint8 SWITCH_POS_NONE = 0		# switch is not mapped
uint8 SWITCH_POS_ON = 1		# switch activated (value = 1)
uint8 SWITCH_POS_MIDDLE = 2		# middle position (value = 0)
uint8 SWITCH_POS_OFF = 3		# switch not activated (value = -1)
uint8 MODE_SLOT_NONE = 0		# no mode slot assigned
uint8 MODE_SLOT_1 = 1			# mode slot 1 selected
uint8 MODE_SLOT_2 = 2			# mode slot 2 selected
uint8 MODE_SLOT_3 = 3			# mode slot 3 selected
uint8 MODE_SLOT_4 = 4			# mode slot 4 selected
uint8 MODE_SLOT_5 = 5			# mode slot 5 selected
uint8 MODE_SLOT_6 = 6			# mode slot 6 selected
uint8 MODE_SLOT_NUM = 6			# number of slots
uint8 SOURCE_RC = 1			# radio control
uint8 SOURCE_MAVLINK_0 = 2		# mavlink instance 0
uint8 SOURCE_MAVLINK_1 = 3		# mavlink instance 1
uint8 SOURCE_MAVLINK_2 = 4		# mavlink instance 2
uint8 SOURCE_MAVLINK_3 = 5		# mavlink instance 4

# Any of the channels may not be available and be set to NaN
# to indicate that it does not contain valid data.
# The variable names follow the definition of the
# MANUAL_CONTROL mavlink message.
# The default range is from -1 to 1 (mavlink message -1000 to 1000)
# The range for the z variable is defined from 0 to 1. (The z field of
# the MANUAL_CONTROL mavlink message is defined from -1000 to 1000)

float32 x			 # stick position in x direction -1..1
				 # in general corresponds to forward/back motion or pitch of vehicle,
				 # in general a positive value means forward or negative pitch and
				 # a negative value means backward or positive pitch
float32 y			 # stick position in y direction -1..1
				 # in general corresponds to right/left motion or roll of vehicle,
				 # in general a positive value means right or positive roll and
				 # a negative value means left or negative roll
float32 z			 # throttle stick position 0..1
				 # in general corresponds to up/down motion or thrust of vehicle,
				 # in general the value corresponds to the demanded throttle by the user,
				 # if the input is used for setting the setpoint of a vertical position
				 # controller any value > 0.5 means up and any value < 0.5 means down
float32 r			 # yaw stick/twist position, -1..1
				 # in general corresponds to the righthand rotation around the vertical
				 # (downwards) axis of the vehicle
float32 flaps			 # flap position
float32 aux1			 # default function: camera yaw / azimuth
float32 aux2			 # default function: camera pitch / tilt
float32 aux3			 # default function: camera trigger
float32 aux4			 # default function: camera roll
float32 aux5			 # default function: payload drop
float32 aux6

uint8 mode_switch		 # main mode 3 position switch (mandatory): _MANUAL_, ASSIST, AUTO
uint8 return_switch		 # return to launch 2 position switch (mandatory): _NORMAL_, RTL
uint8 rattitude_switch	 # rattitude control 2 position switch (optional): _MANUAL, RATTITUDE
uint8 posctl_switch		 # position control 2 position switch (optional): _ALTCTL_, POSCTL
uint8 loiter_switch		 # loiter 2 position switch (optional): _MISSION_, LOITER
uint8 acro_switch		 # acro 2 position switch (optional): _MANUAL_, ACRO
uint8 offboard_switch	 	 # offboard 2 position switch (optional): _NORMAL_, OFFBOARD
uint8 kill_switch		 # throttle kill: _NORMAL_, KILL
uint8 arm_switch		 # arm/disarm switch: _DISARMED_, ARMED
uint8 transition_switch	 # VTOL transition switch: _HOVER, FORWARD_FLIGHT
uint8 gear_switch	 # landing gear switch: _DOWN_, UP
uint8 mode_slot			 # the slot a specific model selector is in
uint8 data_source		 # where this input is coming from
uint8 stab_switch 		 # stabilize switch (only relevant for fixed wings, optional): _MANUAL, STABILIZED
uint8 man_switch		 # manual switch (only relevant for fixed wings, optional): _STABILIZED_, MANUAL
"""
  # Pseudo-constants
  SWITCH_POS_NONE = 0
  SWITCH_POS_ON = 1
  SWITCH_POS_MIDDLE = 2
  SWITCH_POS_OFF = 3
  MODE_SLOT_NONE = 0
  MODE_SLOT_1 = 1
  MODE_SLOT_2 = 2
  MODE_SLOT_3 = 3
  MODE_SLOT_4 = 4
  MODE_SLOT_5 = 5
  MODE_SLOT_6 = 6
  MODE_SLOT_NUM = 6
  SOURCE_RC = 1
  SOURCE_MAVLINK_0 = 2
  SOURCE_MAVLINK_1 = 3
  SOURCE_MAVLINK_2 = 4
  SOURCE_MAVLINK_3 = 5

  __slots__ = ['timestamp','x','y','z','r','flaps','aux1','aux2','aux3','aux4','aux5','aux6','mode_switch','return_switch','rattitude_switch','posctl_switch','loiter_switch','acro_switch','offboard_switch','kill_switch','arm_switch','transition_switch','gear_switch','mode_slot','data_source','stab_switch','man_switch']
  _slot_types = ['uint64','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,x,y,z,r,flaps,aux1,aux2,aux3,aux4,aux5,aux6,mode_switch,return_switch,rattitude_switch,posctl_switch,loiter_switch,acro_switch,offboard_switch,kill_switch,arm_switch,transition_switch,gear_switch,mode_slot,data_source,stab_switch,man_switch

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ManualControlSetpoint, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.x is None:
        self.x = 0.
      if self.y is None:
        self.y = 0.
      if self.z is None:
        self.z = 0.
      if self.r is None:
        self.r = 0.
      if self.flaps is None:
        self.flaps = 0.
      if self.aux1 is None:
        self.aux1 = 0.
      if self.aux2 is None:
        self.aux2 = 0.
      if self.aux3 is None:
        self.aux3 = 0.
      if self.aux4 is None:
        self.aux4 = 0.
      if self.aux5 is None:
        self.aux5 = 0.
      if self.aux6 is None:
        self.aux6 = 0.
      if self.mode_switch is None:
        self.mode_switch = 0
      if self.return_switch is None:
        self.return_switch = 0
      if self.rattitude_switch is None:
        self.rattitude_switch = 0
      if self.posctl_switch is None:
        self.posctl_switch = 0
      if self.loiter_switch is None:
        self.loiter_switch = 0
      if self.acro_switch is None:
        self.acro_switch = 0
      if self.offboard_switch is None:
        self.offboard_switch = 0
      if self.kill_switch is None:
        self.kill_switch = 0
      if self.arm_switch is None:
        self.arm_switch = 0
      if self.transition_switch is None:
        self.transition_switch = 0
      if self.gear_switch is None:
        self.gear_switch = 0
      if self.mode_slot is None:
        self.mode_slot = 0
      if self.data_source is None:
        self.data_source = 0
      if self.stab_switch is None:
        self.stab_switch = 0
      if self.man_switch is None:
        self.man_switch = 0
    else:
      self.timestamp = 0
      self.x = 0.
      self.y = 0.
      self.z = 0.
      self.r = 0.
      self.flaps = 0.
      self.aux1 = 0.
      self.aux2 = 0.
      self.aux3 = 0.
      self.aux4 = 0.
      self.aux5 = 0.
      self.aux6 = 0.
      self.mode_switch = 0
      self.return_switch = 0
      self.rattitude_switch = 0
      self.posctl_switch = 0
      self.loiter_switch = 0
      self.acro_switch = 0
      self.offboard_switch = 0
      self.kill_switch = 0
      self.arm_switch = 0
      self.transition_switch = 0
      self.gear_switch = 0
      self.mode_slot = 0
      self.data_source = 0
      self.stab_switch = 0
      self.man_switch = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q11f15B().pack(_x.timestamp, _x.x, _x.y, _x.z, _x.r, _x.flaps, _x.aux1, _x.aux2, _x.aux3, _x.aux4, _x.aux5, _x.aux6, _x.mode_switch, _x.return_switch, _x.rattitude_switch, _x.posctl_switch, _x.loiter_switch, _x.acro_switch, _x.offboard_switch, _x.kill_switch, _x.arm_switch, _x.transition_switch, _x.gear_switch, _x.mode_slot, _x.data_source, _x.stab_switch, _x.man_switch))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 67
      (_x.timestamp, _x.x, _x.y, _x.z, _x.r, _x.flaps, _x.aux1, _x.aux2, _x.aux3, _x.aux4, _x.aux5, _x.aux6, _x.mode_switch, _x.return_switch, _x.rattitude_switch, _x.posctl_switch, _x.loiter_switch, _x.acro_switch, _x.offboard_switch, _x.kill_switch, _x.arm_switch, _x.transition_switch, _x.gear_switch, _x.mode_slot, _x.data_source, _x.stab_switch, _x.man_switch,) = _get_struct_Q11f15B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q11f15B().pack(_x.timestamp, _x.x, _x.y, _x.z, _x.r, _x.flaps, _x.aux1, _x.aux2, _x.aux3, _x.aux4, _x.aux5, _x.aux6, _x.mode_switch, _x.return_switch, _x.rattitude_switch, _x.posctl_switch, _x.loiter_switch, _x.acro_switch, _x.offboard_switch, _x.kill_switch, _x.arm_switch, _x.transition_switch, _x.gear_switch, _x.mode_slot, _x.data_source, _x.stab_switch, _x.man_switch))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 67
      (_x.timestamp, _x.x, _x.y, _x.z, _x.r, _x.flaps, _x.aux1, _x.aux2, _x.aux3, _x.aux4, _x.aux5, _x.aux6, _x.mode_switch, _x.return_switch, _x.rattitude_switch, _x.posctl_switch, _x.loiter_switch, _x.acro_switch, _x.offboard_switch, _x.kill_switch, _x.arm_switch, _x.transition_switch, _x.gear_switch, _x.mode_slot, _x.data_source, _x.stab_switch, _x.man_switch,) = _get_struct_Q11f15B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q11f15B = None
def _get_struct_Q11f15B():
    global _struct_Q11f15B
    if _struct_Q11f15B is None:
        _struct_Q11f15B = struct.Struct("<Q11f15B")
    return _struct_Q11f15B
