# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/MissionResult.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class MissionResult(genpy.Message):
  _md5sum = "5b23ef166fad5d1514b73f54774354bd"
  _type = "px4_msgs/MissionResult"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp				# time since system start (microseconds)
uint8 MISSION_EXECUTION_MODE_NORMAL = 0	# Execute the mission according to the planned items
uint8 MISSION_EXECUTION_MODE_REVERSE = 1	# Execute the mission in reverse order, ignoring commands and converting all waypoints to normal ones
uint8 MISSION_EXECUTION_MODE_FAST_FORWARD = 2	# Execute the mission as fast as possible, for example converting loiter waypoints to normal ones

uint32 instance_count		# Instance count of this mission. Increments monotonically whenever the mission is modified

int32 seq_reached		# Sequence of the mission item which has been reached, default -1
uint16 seq_current		# Sequence of the current mission item
uint16 seq_total		# Total number of mission items

bool valid			# true if mission is valid
bool warning			# true if mission is valid, but has potentially problematic items leading to safety warnings
bool finished			# true if mission has been completed
bool failure			# true if the mission cannot continue or be completed for some reason

bool stay_in_failsafe		# true if the commander should not switch out of the failsafe mode
bool flight_termination		# true if the navigator demands a flight termination from the commander app

bool item_do_jump_changed	# true if the number of do jumps remaining has changed
uint16 item_changed_index	# indicate which item has changed
uint16 item_do_jump_remaining	# set to the number of do jumps remaining for that item

uint8 execution_mode	# indicates the mode in which the mission is executed
"""
  # Pseudo-constants
  MISSION_EXECUTION_MODE_NORMAL = 0
  MISSION_EXECUTION_MODE_REVERSE = 1
  MISSION_EXECUTION_MODE_FAST_FORWARD = 2

  __slots__ = ['timestamp','instance_count','seq_reached','seq_current','seq_total','valid','warning','finished','failure','stay_in_failsafe','flight_termination','item_do_jump_changed','item_changed_index','item_do_jump_remaining','execution_mode']
  _slot_types = ['uint64','uint32','int32','uint16','uint16','bool','bool','bool','bool','bool','bool','bool','uint16','uint16','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,instance_count,seq_reached,seq_current,seq_total,valid,warning,finished,failure,stay_in_failsafe,flight_termination,item_do_jump_changed,item_changed_index,item_do_jump_remaining,execution_mode

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MissionResult, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.instance_count is None:
        self.instance_count = 0
      if self.seq_reached is None:
        self.seq_reached = 0
      if self.seq_current is None:
        self.seq_current = 0
      if self.seq_total is None:
        self.seq_total = 0
      if self.valid is None:
        self.valid = False
      if self.warning is None:
        self.warning = False
      if self.finished is None:
        self.finished = False
      if self.failure is None:
        self.failure = False
      if self.stay_in_failsafe is None:
        self.stay_in_failsafe = False
      if self.flight_termination is None:
        self.flight_termination = False
      if self.item_do_jump_changed is None:
        self.item_do_jump_changed = False
      if self.item_changed_index is None:
        self.item_changed_index = 0
      if self.item_do_jump_remaining is None:
        self.item_do_jump_remaining = 0
      if self.execution_mode is None:
        self.execution_mode = 0
    else:
      self.timestamp = 0
      self.instance_count = 0
      self.seq_reached = 0
      self.seq_current = 0
      self.seq_total = 0
      self.valid = False
      self.warning = False
      self.finished = False
      self.failure = False
      self.stay_in_failsafe = False
      self.flight_termination = False
      self.item_do_jump_changed = False
      self.item_changed_index = 0
      self.item_do_jump_remaining = 0
      self.execution_mode = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_QIi2H7B2HB().pack(_x.timestamp, _x.instance_count, _x.seq_reached, _x.seq_current, _x.seq_total, _x.valid, _x.warning, _x.finished, _x.failure, _x.stay_in_failsafe, _x.flight_termination, _x.item_do_jump_changed, _x.item_changed_index, _x.item_do_jump_remaining, _x.execution_mode))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 32
      (_x.timestamp, _x.instance_count, _x.seq_reached, _x.seq_current, _x.seq_total, _x.valid, _x.warning, _x.finished, _x.failure, _x.stay_in_failsafe, _x.flight_termination, _x.item_do_jump_changed, _x.item_changed_index, _x.item_do_jump_remaining, _x.execution_mode,) = _get_struct_QIi2H7B2HB().unpack(str[start:end])
      self.valid = bool(self.valid)
      self.warning = bool(self.warning)
      self.finished = bool(self.finished)
      self.failure = bool(self.failure)
      self.stay_in_failsafe = bool(self.stay_in_failsafe)
      self.flight_termination = bool(self.flight_termination)
      self.item_do_jump_changed = bool(self.item_do_jump_changed)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_QIi2H7B2HB().pack(_x.timestamp, _x.instance_count, _x.seq_reached, _x.seq_current, _x.seq_total, _x.valid, _x.warning, _x.finished, _x.failure, _x.stay_in_failsafe, _x.flight_termination, _x.item_do_jump_changed, _x.item_changed_index, _x.item_do_jump_remaining, _x.execution_mode))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 32
      (_x.timestamp, _x.instance_count, _x.seq_reached, _x.seq_current, _x.seq_total, _x.valid, _x.warning, _x.finished, _x.failure, _x.stay_in_failsafe, _x.flight_termination, _x.item_do_jump_changed, _x.item_changed_index, _x.item_do_jump_remaining, _x.execution_mode,) = _get_struct_QIi2H7B2HB().unpack(str[start:end])
      self.valid = bool(self.valid)
      self.warning = bool(self.warning)
      self.finished = bool(self.finished)
      self.failure = bool(self.failure)
      self.stay_in_failsafe = bool(self.stay_in_failsafe)
      self.flight_termination = bool(self.flight_termination)
      self.item_do_jump_changed = bool(self.item_do_jump_changed)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_QIi2H7B2HB = None
def _get_struct_QIi2H7B2HB():
    global _struct_QIi2H7B2HB
    if _struct_QIi2H7B2HB is None:
        _struct_QIi2H7B2HB = struct.Struct("<QIi2H7B2HB")
    return _struct_QIi2H7B2HB
