# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/ObstacleDistanceFused.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class ObstacleDistanceFused(genpy.Message):
  _md5sum = "0749df3add7185fbe502cb1fcf11cdf9"
  _type = "px4_msgs/ObstacleDistanceFused"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Obstacle distances in front of the sensor.
uint64 timestamp		# time since system start (microseconds)

uint8 frame		#Coordinate frame of reference for the yaw rotation and offset of the sensor data. Defaults to MAV_FRAME_GLOBAL, which is North aligned. For body-mounted sensors use MAV_FRAME_BODY_FRD, which is vehicle front aligned.
uint8 MAV_FRAME_GLOBAL = 0
uint8 MAV_FRAME_LOCAL_NED = 1
uint8 MAV_FRAME_BODY_FRD = 12

uint8 sensor_type # Type from MAV_DISTANCE_SENSOR enum.
uint8 MAV_DISTANCE_SENSOR_LASER = 0
uint8 MAV_DISTANCE_SENSOR_ULTRASOUND = 1
uint8 MAV_DISTANCE_SENSOR_INFRARED = 2
uint8 MAV_DISTANCE_SENSOR_RADAR = 3

uint16[72] distances # Distance of obstacles around the UAV with index 0 corresponding to local North. A value of 0 means that the obstacle is right in front of the sensor. A value of max_distance +1 means no obstacle is present. A value of UINT16_MAX for unknown/not used. In a array element, one unit corresponds to 1cm.

float32 increment # Angular width in degrees of each array element.

uint16 min_distance # Minimum distance the sensor can measure in centimeters.
uint16 max_distance # Maximum distance the sensor can measure in centimeters.

float32 angle_offset # Relative angle offset of the 0-index element in the distances array. Value of 0 corresponds to forward. Positive values are offsets to the right.

"""
  # Pseudo-constants
  MAV_FRAME_GLOBAL = 0
  MAV_FRAME_LOCAL_NED = 1
  MAV_FRAME_BODY_FRD = 12
  MAV_DISTANCE_SENSOR_LASER = 0
  MAV_DISTANCE_SENSOR_ULTRASOUND = 1
  MAV_DISTANCE_SENSOR_INFRARED = 2
  MAV_DISTANCE_SENSOR_RADAR = 3

  __slots__ = ['timestamp','frame','sensor_type','distances','increment','min_distance','max_distance','angle_offset']
  _slot_types = ['uint64','uint8','uint8','uint16[72]','float32','uint16','uint16','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,frame,sensor_type,distances,increment,min_distance,max_distance,angle_offset

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ObstacleDistanceFused, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.frame is None:
        self.frame = 0
      if self.sensor_type is None:
        self.sensor_type = 0
      if self.distances is None:
        self.distances = [0] * 72
      if self.increment is None:
        self.increment = 0.
      if self.min_distance is None:
        self.min_distance = 0
      if self.max_distance is None:
        self.max_distance = 0
      if self.angle_offset is None:
        self.angle_offset = 0.
    else:
      self.timestamp = 0
      self.frame = 0
      self.sensor_type = 0
      self.distances = [0] * 72
      self.increment = 0.
      self.min_distance = 0
      self.max_distance = 0
      self.angle_offset = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q2B().pack(_x.timestamp, _x.frame, _x.sensor_type))
      buff.write(_get_struct_72H().pack(*self.distances))
      _x = self
      buff.write(_get_struct_f2Hf().pack(_x.increment, _x.min_distance, _x.max_distance, _x.angle_offset))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 10
      (_x.timestamp, _x.frame, _x.sensor_type,) = _get_struct_Q2B().unpack(str[start:end])
      start = end
      end += 144
      self.distances = _get_struct_72H().unpack(str[start:end])
      _x = self
      start = end
      end += 12
      (_x.increment, _x.min_distance, _x.max_distance, _x.angle_offset,) = _get_struct_f2Hf().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q2B().pack(_x.timestamp, _x.frame, _x.sensor_type))
      buff.write(self.distances.tostring())
      _x = self
      buff.write(_get_struct_f2Hf().pack(_x.increment, _x.min_distance, _x.max_distance, _x.angle_offset))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 10
      (_x.timestamp, _x.frame, _x.sensor_type,) = _get_struct_Q2B().unpack(str[start:end])
      start = end
      end += 144
      self.distances = numpy.frombuffer(str[start:end], dtype=numpy.uint16, count=72)
      _x = self
      start = end
      end += 12
      (_x.increment, _x.min_distance, _x.max_distance, _x.angle_offset,) = _get_struct_f2Hf().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_72H = None
def _get_struct_72H():
    global _struct_72H
    if _struct_72H is None:
        _struct_72H = struct.Struct("<72H")
    return _struct_72H
_struct_Q2B = None
def _get_struct_Q2B():
    global _struct_Q2B
    if _struct_Q2B is None:
        _struct_Q2B = struct.Struct("<Q2B")
    return _struct_Q2B
_struct_f2Hf = None
def _get_struct_f2Hf():
    global _struct_f2Hf
    if _struct_f2Hf is None:
        _struct_f2Hf = struct.Struct("<f2Hf")
    return _struct_f2Hf
