# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/OpticalFlow.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class OpticalFlow(genpy.Message):
  _md5sum = "6574f19ab9ed0588573d4e2bf932a76b"
  _type = "px4_msgs/OpticalFlow"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Optical flow in XYZ body frame in SI units.
# http://en.wikipedia.org/wiki/International_System_of_Units

uint64 timestamp		# time since system start (microseconds)

uint8 sensor_id			# id of the sensor emitting the flow value
float32 pixel_flow_x_integral	# accumulated optical flow in radians where a positive value is produced by a RH rotation about the X body axis
float32 pixel_flow_y_integral	# accumulated optical flow in radians where a positive value is produced by a RH rotation about the Y body axis
float32 gyro_x_rate_integral	# accumulated gyro value in radians where a positive value is produced by a RH rotation about the X body axis. Set to NaN if flow sensor does not have 3-axis gyro data.
float32 gyro_y_rate_integral	# accumulated gyro value in radians where a positive value is produced by a RH rotation about the Y body axis. Set to NaN if flow sensor does not have 3-axis gyro data.
float32 gyro_z_rate_integral	# accumulated gyro value in radians where a positive value is produced by a RH rotation about the Z body axis. Set to NaN if flow sensor does not have 3-axis gyro data.
float32 ground_distance_m	# Altitude / distance to ground in meters
uint32 integration_timespan	# accumulation timespan in microseconds
uint32 time_since_last_sonar_update	# time since last sonar update in microseconds
uint16 frame_count_since_last_readout	# number of accumulated frames in timespan
int16 gyro_temperature	# Temperature * 100 in centi-degrees Celsius
uint8 quality	# Average of quality of accumulated frames, 0: bad quality, 255: maximum quality

float32 max_flow_rate # Magnitude of maximum angular which the optical flow sensor can measure reliably
float32 min_ground_distance # Minimum distance from ground at which the optical flow sensor operates reliably
float32 max_ground_distance # Maximum distance from ground at which the optical flow sensor operates reliably
"""
  __slots__ = ['timestamp','sensor_id','pixel_flow_x_integral','pixel_flow_y_integral','gyro_x_rate_integral','gyro_y_rate_integral','gyro_z_rate_integral','ground_distance_m','integration_timespan','time_since_last_sonar_update','frame_count_since_last_readout','gyro_temperature','quality','max_flow_rate','min_ground_distance','max_ground_distance']
  _slot_types = ['uint64','uint8','float32','float32','float32','float32','float32','float32','uint32','uint32','uint16','int16','uint8','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,sensor_id,pixel_flow_x_integral,pixel_flow_y_integral,gyro_x_rate_integral,gyro_y_rate_integral,gyro_z_rate_integral,ground_distance_m,integration_timespan,time_since_last_sonar_update,frame_count_since_last_readout,gyro_temperature,quality,max_flow_rate,min_ground_distance,max_ground_distance

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(OpticalFlow, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.sensor_id is None:
        self.sensor_id = 0
      if self.pixel_flow_x_integral is None:
        self.pixel_flow_x_integral = 0.
      if self.pixel_flow_y_integral is None:
        self.pixel_flow_y_integral = 0.
      if self.gyro_x_rate_integral is None:
        self.gyro_x_rate_integral = 0.
      if self.gyro_y_rate_integral is None:
        self.gyro_y_rate_integral = 0.
      if self.gyro_z_rate_integral is None:
        self.gyro_z_rate_integral = 0.
      if self.ground_distance_m is None:
        self.ground_distance_m = 0.
      if self.integration_timespan is None:
        self.integration_timespan = 0
      if self.time_since_last_sonar_update is None:
        self.time_since_last_sonar_update = 0
      if self.frame_count_since_last_readout is None:
        self.frame_count_since_last_readout = 0
      if self.gyro_temperature is None:
        self.gyro_temperature = 0
      if self.quality is None:
        self.quality = 0
      if self.max_flow_rate is None:
        self.max_flow_rate = 0.
      if self.min_ground_distance is None:
        self.min_ground_distance = 0.
      if self.max_ground_distance is None:
        self.max_ground_distance = 0.
    else:
      self.timestamp = 0
      self.sensor_id = 0
      self.pixel_flow_x_integral = 0.
      self.pixel_flow_y_integral = 0.
      self.gyro_x_rate_integral = 0.
      self.gyro_y_rate_integral = 0.
      self.gyro_z_rate_integral = 0.
      self.ground_distance_m = 0.
      self.integration_timespan = 0
      self.time_since_last_sonar_update = 0
      self.frame_count_since_last_readout = 0
      self.gyro_temperature = 0
      self.quality = 0
      self.max_flow_rate = 0.
      self.min_ground_distance = 0.
      self.max_ground_distance = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_QB6f2IHhB3f().pack(_x.timestamp, _x.sensor_id, _x.pixel_flow_x_integral, _x.pixel_flow_y_integral, _x.gyro_x_rate_integral, _x.gyro_y_rate_integral, _x.gyro_z_rate_integral, _x.ground_distance_m, _x.integration_timespan, _x.time_since_last_sonar_update, _x.frame_count_since_last_readout, _x.gyro_temperature, _x.quality, _x.max_flow_rate, _x.min_ground_distance, _x.max_ground_distance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 58
      (_x.timestamp, _x.sensor_id, _x.pixel_flow_x_integral, _x.pixel_flow_y_integral, _x.gyro_x_rate_integral, _x.gyro_y_rate_integral, _x.gyro_z_rate_integral, _x.ground_distance_m, _x.integration_timespan, _x.time_since_last_sonar_update, _x.frame_count_since_last_readout, _x.gyro_temperature, _x.quality, _x.max_flow_rate, _x.min_ground_distance, _x.max_ground_distance,) = _get_struct_QB6f2IHhB3f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_QB6f2IHhB3f().pack(_x.timestamp, _x.sensor_id, _x.pixel_flow_x_integral, _x.pixel_flow_y_integral, _x.gyro_x_rate_integral, _x.gyro_y_rate_integral, _x.gyro_z_rate_integral, _x.ground_distance_m, _x.integration_timespan, _x.time_since_last_sonar_update, _x.frame_count_since_last_readout, _x.gyro_temperature, _x.quality, _x.max_flow_rate, _x.min_ground_distance, _x.max_ground_distance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 58
      (_x.timestamp, _x.sensor_id, _x.pixel_flow_x_integral, _x.pixel_flow_y_integral, _x.gyro_x_rate_integral, _x.gyro_y_rate_integral, _x.gyro_z_rate_integral, _x.ground_distance_m, _x.integration_timespan, _x.time_since_last_sonar_update, _x.frame_count_since_last_readout, _x.gyro_temperature, _x.quality, _x.max_flow_rate, _x.min_ground_distance, _x.max_ground_distance,) = _get_struct_QB6f2IHhB3f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_QB6f2IHhB3f = None
def _get_struct_QB6f2IHhB3f():
    global _struct_QB6f2IHhB3f
    if _struct_QB6f2IHhB3f is None:
        _struct_QB6f2IHhB3f = struct.Struct("<QB6f2IHhB3f")
    return _struct_QB6f2IHhB3f
