# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/PositionSetpoint.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class PositionSetpoint(genpy.Message):
  _md5sum = "dd5757cafcd3170a5ba6b73a12915435"
  _type = "px4_msgs/PositionSetpoint"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# this file is only used in the position_setpoint triple as a dependency

uint64 timestamp		# time since system start (microseconds)

uint8 SETPOINT_TYPE_POSITION=0	# position setpoint
uint8 SETPOINT_TYPE_VELOCITY=1	# velocity setpoint
uint8 SETPOINT_TYPE_LOITER=2	# loiter setpoint
uint8 SETPOINT_TYPE_TAKEOFF=3	# takeoff setpoint
uint8 SETPOINT_TYPE_LAND=4	# land setpoint, altitude must be ignored, descend until landing
uint8 SETPOINT_TYPE_IDLE=5	# do nothing, switch off motors or keep at idle speed (MC)
uint8 SETPOINT_TYPE_OFFBOARD=6 	# setpoint in NED frame (x, y, z, vx, vy, vz) set by offboard
uint8 SETPOINT_TYPE_FOLLOW_TARGET=7  # setpoint in NED frame (x, y, z, vx, vy, vz) set by follow target

uint8 VELOCITY_FRAME_LOCAL_NED = 1 # MAV_FRAME_LOCAL_NED
uint8 VELOCITY_FRAME_BODY_NED = 8 # MAV_FRAME_BODY_NED

bool valid			# true if setpoint is valid
uint8 type			# setpoint type to adjust behavior of position controller

float32 x			# local position setpoint in m in NED
float32 y			# local position setpoint in m in NED
float32 z			# local position setpoint in m in NED
bool position_valid		# true if local position setpoint valid

float32 vx			# local velocity setpoint in m/s in NED
float32 vy			# local velocity setpoint in m/s in NED
float32 vz			# local velocity setpoint in m/s in NED
bool velocity_valid		# true if local velocity setpoint valid
uint8 velocity_frame		# to set velocity setpoints in NED or body
bool alt_valid		# do not set for 3D position control. Set to true if you want z-position control while doing vx,vy velocity control.

float64 lat			# latitude, in deg
float64 lon			# longitude, in deg
float32 alt			# altitude AMSL, in m
float32 yaw			# yaw (only for multirotors), in rad [-PI..PI), NaN = hold current yaw
bool yaw_valid			# true if yaw setpoint valid

float32 yawspeed		# yawspeed (only for multirotors, in rad/s)
bool yawspeed_valid		# true if yawspeed setpoint valid

int8 landing_gear		# landing gear: see definition of the states in landing_gear.msg

float32 loiter_radius		# loiter radius (only for fixed wing), in m
int8 loiter_direction		# loiter direction: 1 = CW, -1 = CCW
float32 pitch_min		# minimal pitch angle for fixed wing takeoff waypoints

float32 a_x			# acceleration x setpoint
float32 a_y			# acceleration y setpoint
float32 a_z			# acceleration z setpoint
bool acceleration_valid		# true if acceleration setpoint is valid/should be used
bool acceleration_is_force	# interprete acceleration as force

float32 acceptance_radius   # navigation acceptance_radius if we're doing waypoint navigation

float32 cruising_speed		# the generally desired cruising speed (not a hard constraint)
float32 cruising_throttle	# the generally desired cruising throttle (not a hard constraint)

bool allow_weather_vane   # VTOL: allow (in mission mode) the weather vane feature that turns the nose into the wind
"""
  # Pseudo-constants
  SETPOINT_TYPE_POSITION = 0
  SETPOINT_TYPE_VELOCITY = 1
  SETPOINT_TYPE_LOITER = 2
  SETPOINT_TYPE_TAKEOFF = 3
  SETPOINT_TYPE_LAND = 4
  SETPOINT_TYPE_IDLE = 5
  SETPOINT_TYPE_OFFBOARD = 6
  SETPOINT_TYPE_FOLLOW_TARGET = 7
  VELOCITY_FRAME_LOCAL_NED = 1
  VELOCITY_FRAME_BODY_NED = 8

  __slots__ = ['timestamp','valid','type','x','y','z','position_valid','vx','vy','vz','velocity_valid','velocity_frame','alt_valid','lat','lon','alt','yaw','yaw_valid','yawspeed','yawspeed_valid','landing_gear','loiter_radius','loiter_direction','pitch_min','a_x','a_y','a_z','acceleration_valid','acceleration_is_force','acceptance_radius','cruising_speed','cruising_throttle','allow_weather_vane']
  _slot_types = ['uint64','bool','uint8','float32','float32','float32','bool','float32','float32','float32','bool','uint8','bool','float64','float64','float32','float32','bool','float32','bool','int8','float32','int8','float32','float32','float32','float32','bool','bool','float32','float32','float32','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,valid,type,x,y,z,position_valid,vx,vy,vz,velocity_valid,velocity_frame,alt_valid,lat,lon,alt,yaw,yaw_valid,yawspeed,yawspeed_valid,landing_gear,loiter_radius,loiter_direction,pitch_min,a_x,a_y,a_z,acceleration_valid,acceleration_is_force,acceptance_radius,cruising_speed,cruising_throttle,allow_weather_vane

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PositionSetpoint, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.valid is None:
        self.valid = False
      if self.type is None:
        self.type = 0
      if self.x is None:
        self.x = 0.
      if self.y is None:
        self.y = 0.
      if self.z is None:
        self.z = 0.
      if self.position_valid is None:
        self.position_valid = False
      if self.vx is None:
        self.vx = 0.
      if self.vy is None:
        self.vy = 0.
      if self.vz is None:
        self.vz = 0.
      if self.velocity_valid is None:
        self.velocity_valid = False
      if self.velocity_frame is None:
        self.velocity_frame = 0
      if self.alt_valid is None:
        self.alt_valid = False
      if self.lat is None:
        self.lat = 0.
      if self.lon is None:
        self.lon = 0.
      if self.alt is None:
        self.alt = 0.
      if self.yaw is None:
        self.yaw = 0.
      if self.yaw_valid is None:
        self.yaw_valid = False
      if self.yawspeed is None:
        self.yawspeed = 0.
      if self.yawspeed_valid is None:
        self.yawspeed_valid = False
      if self.landing_gear is None:
        self.landing_gear = 0
      if self.loiter_radius is None:
        self.loiter_radius = 0.
      if self.loiter_direction is None:
        self.loiter_direction = 0
      if self.pitch_min is None:
        self.pitch_min = 0.
      if self.a_x is None:
        self.a_x = 0.
      if self.a_y is None:
        self.a_y = 0.
      if self.a_z is None:
        self.a_z = 0.
      if self.acceleration_valid is None:
        self.acceleration_valid = False
      if self.acceleration_is_force is None:
        self.acceleration_is_force = False
      if self.acceptance_radius is None:
        self.acceptance_radius = 0.
      if self.cruising_speed is None:
        self.cruising_speed = 0.
      if self.cruising_throttle is None:
        self.cruising_throttle = 0.
      if self.allow_weather_vane is None:
        self.allow_weather_vane = False
    else:
      self.timestamp = 0
      self.valid = False
      self.type = 0
      self.x = 0.
      self.y = 0.
      self.z = 0.
      self.position_valid = False
      self.vx = 0.
      self.vy = 0.
      self.vz = 0.
      self.velocity_valid = False
      self.velocity_frame = 0
      self.alt_valid = False
      self.lat = 0.
      self.lon = 0.
      self.alt = 0.
      self.yaw = 0.
      self.yaw_valid = False
      self.yawspeed = 0.
      self.yawspeed_valid = False
      self.landing_gear = 0
      self.loiter_radius = 0.
      self.loiter_direction = 0
      self.pitch_min = 0.
      self.a_x = 0.
      self.a_y = 0.
      self.a_z = 0.
      self.acceleration_valid = False
      self.acceleration_is_force = False
      self.acceptance_radius = 0.
      self.cruising_speed = 0.
      self.cruising_throttle = 0.
      self.allow_weather_vane = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q2B3fB3f3B2d2fBfBbfb4f2B3fB().pack(_x.timestamp, _x.valid, _x.type, _x.x, _x.y, _x.z, _x.position_valid, _x.vx, _x.vy, _x.vz, _x.velocity_valid, _x.velocity_frame, _x.alt_valid, _x.lat, _x.lon, _x.alt, _x.yaw, _x.yaw_valid, _x.yawspeed, _x.yawspeed_valid, _x.landing_gear, _x.loiter_radius, _x.loiter_direction, _x.pitch_min, _x.a_x, _x.a_y, _x.a_z, _x.acceleration_valid, _x.acceleration_is_force, _x.acceptance_radius, _x.cruising_speed, _x.cruising_throttle, _x.allow_weather_vane))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 105
      (_x.timestamp, _x.valid, _x.type, _x.x, _x.y, _x.z, _x.position_valid, _x.vx, _x.vy, _x.vz, _x.velocity_valid, _x.velocity_frame, _x.alt_valid, _x.lat, _x.lon, _x.alt, _x.yaw, _x.yaw_valid, _x.yawspeed, _x.yawspeed_valid, _x.landing_gear, _x.loiter_radius, _x.loiter_direction, _x.pitch_min, _x.a_x, _x.a_y, _x.a_z, _x.acceleration_valid, _x.acceleration_is_force, _x.acceptance_radius, _x.cruising_speed, _x.cruising_throttle, _x.allow_weather_vane,) = _get_struct_Q2B3fB3f3B2d2fBfBbfb4f2B3fB().unpack(str[start:end])
      self.valid = bool(self.valid)
      self.position_valid = bool(self.position_valid)
      self.velocity_valid = bool(self.velocity_valid)
      self.alt_valid = bool(self.alt_valid)
      self.yaw_valid = bool(self.yaw_valid)
      self.yawspeed_valid = bool(self.yawspeed_valid)
      self.acceleration_valid = bool(self.acceleration_valid)
      self.acceleration_is_force = bool(self.acceleration_is_force)
      self.allow_weather_vane = bool(self.allow_weather_vane)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q2B3fB3f3B2d2fBfBbfb4f2B3fB().pack(_x.timestamp, _x.valid, _x.type, _x.x, _x.y, _x.z, _x.position_valid, _x.vx, _x.vy, _x.vz, _x.velocity_valid, _x.velocity_frame, _x.alt_valid, _x.lat, _x.lon, _x.alt, _x.yaw, _x.yaw_valid, _x.yawspeed, _x.yawspeed_valid, _x.landing_gear, _x.loiter_radius, _x.loiter_direction, _x.pitch_min, _x.a_x, _x.a_y, _x.a_z, _x.acceleration_valid, _x.acceleration_is_force, _x.acceptance_radius, _x.cruising_speed, _x.cruising_throttle, _x.allow_weather_vane))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 105
      (_x.timestamp, _x.valid, _x.type, _x.x, _x.y, _x.z, _x.position_valid, _x.vx, _x.vy, _x.vz, _x.velocity_valid, _x.velocity_frame, _x.alt_valid, _x.lat, _x.lon, _x.alt, _x.yaw, _x.yaw_valid, _x.yawspeed, _x.yawspeed_valid, _x.landing_gear, _x.loiter_radius, _x.loiter_direction, _x.pitch_min, _x.a_x, _x.a_y, _x.a_z, _x.acceleration_valid, _x.acceleration_is_force, _x.acceptance_radius, _x.cruising_speed, _x.cruising_throttle, _x.allow_weather_vane,) = _get_struct_Q2B3fB3f3B2d2fBfBbfb4f2B3fB().unpack(str[start:end])
      self.valid = bool(self.valid)
      self.position_valid = bool(self.position_valid)
      self.velocity_valid = bool(self.velocity_valid)
      self.alt_valid = bool(self.alt_valid)
      self.yaw_valid = bool(self.yaw_valid)
      self.yawspeed_valid = bool(self.yawspeed_valid)
      self.acceleration_valid = bool(self.acceleration_valid)
      self.acceleration_is_force = bool(self.acceleration_is_force)
      self.allow_weather_vane = bool(self.allow_weather_vane)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q2B3fB3f3B2d2fBfBbfb4f2B3fB = None
def _get_struct_Q2B3fB3f3B2d2fBfBbfb4f2B3fB():
    global _struct_Q2B3fB3f3B2d2fBfBbfb4f2B3fB
    if _struct_Q2B3fB3f3B2d2fBfBbfb4f2B3fB is None:
        _struct_Q2B3fB3f3B2d2fBfBbfb4f2B3fB = struct.Struct("<Q2B3fB3f3B2d2fBfBbfb4f2B3fB")
    return _struct_Q2B3fB3f3B2d2fBfBbfb4f2B3fB
