# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/PositionSetpointTriplet.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import px4_msgs.msg

class PositionSetpointTriplet(genpy.Message):
  _md5sum = "dbc79ff53d1ae4714a0d965726bb239c"
  _type = "px4_msgs/PositionSetpointTriplet"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Global position setpoint triplet in WGS84 coordinates.
# This are the three next waypoints (or just the next two or one).

uint64 timestamp		# time since system start (microseconds)

PositionSetpoint previous
PositionSetpoint current
PositionSetpoint next

================================================================================
MSG: px4_msgs/PositionSetpoint
# this file is only used in the position_setpoint triple as a dependency

uint64 timestamp		# time since system start (microseconds)

uint8 SETPOINT_TYPE_POSITION=0	# position setpoint
uint8 SETPOINT_TYPE_VELOCITY=1	# velocity setpoint
uint8 SETPOINT_TYPE_LOITER=2	# loiter setpoint
uint8 SETPOINT_TYPE_TAKEOFF=3	# takeoff setpoint
uint8 SETPOINT_TYPE_LAND=4	# land setpoint, altitude must be ignored, descend until landing
uint8 SETPOINT_TYPE_IDLE=5	# do nothing, switch off motors or keep at idle speed (MC)
uint8 SETPOINT_TYPE_OFFBOARD=6 	# setpoint in NED frame (x, y, z, vx, vy, vz) set by offboard
uint8 SETPOINT_TYPE_FOLLOW_TARGET=7  # setpoint in NED frame (x, y, z, vx, vy, vz) set by follow target

uint8 VELOCITY_FRAME_LOCAL_NED = 1 # MAV_FRAME_LOCAL_NED
uint8 VELOCITY_FRAME_BODY_NED = 8 # MAV_FRAME_BODY_NED

bool valid			# true if setpoint is valid
uint8 type			# setpoint type to adjust behavior of position controller

float32 x			# local position setpoint in m in NED
float32 y			# local position setpoint in m in NED
float32 z			# local position setpoint in m in NED
bool position_valid		# true if local position setpoint valid

float32 vx			# local velocity setpoint in m/s in NED
float32 vy			# local velocity setpoint in m/s in NED
float32 vz			# local velocity setpoint in m/s in NED
bool velocity_valid		# true if local velocity setpoint valid
uint8 velocity_frame		# to set velocity setpoints in NED or body
bool alt_valid		# do not set for 3D position control. Set to true if you want z-position control while doing vx,vy velocity control.

float64 lat			# latitude, in deg
float64 lon			# longitude, in deg
float32 alt			# altitude AMSL, in m
float32 yaw			# yaw (only for multirotors), in rad [-PI..PI), NaN = hold current yaw
bool yaw_valid			# true if yaw setpoint valid

float32 yawspeed		# yawspeed (only for multirotors, in rad/s)
bool yawspeed_valid		# true if yawspeed setpoint valid

int8 landing_gear		# landing gear: see definition of the states in landing_gear.msg

float32 loiter_radius		# loiter radius (only for fixed wing), in m
int8 loiter_direction		# loiter direction: 1 = CW, -1 = CCW
float32 pitch_min		# minimal pitch angle for fixed wing takeoff waypoints

float32 a_x			# acceleration x setpoint
float32 a_y			# acceleration y setpoint
float32 a_z			# acceleration z setpoint
bool acceleration_valid		# true if acceleration setpoint is valid/should be used
bool acceleration_is_force	# interprete acceleration as force

float32 acceptance_radius   # navigation acceptance_radius if we're doing waypoint navigation

float32 cruising_speed		# the generally desired cruising speed (not a hard constraint)
float32 cruising_throttle	# the generally desired cruising throttle (not a hard constraint)

bool allow_weather_vane   # VTOL: allow (in mission mode) the weather vane feature that turns the nose into the wind
"""
  __slots__ = ['timestamp','previous','current','next']
  _slot_types = ['uint64','px4_msgs/PositionSetpoint','px4_msgs/PositionSetpoint','px4_msgs/PositionSetpoint']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,previous,current,next

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PositionSetpointTriplet, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.previous is None:
        self.previous = px4_msgs.msg.PositionSetpoint()
      if self.current is None:
        self.current = px4_msgs.msg.PositionSetpoint()
      if self.next is None:
        self.next = px4_msgs.msg.PositionSetpoint()
    else:
      self.timestamp = 0
      self.previous = px4_msgs.msg.PositionSetpoint()
      self.current = px4_msgs.msg.PositionSetpoint()
      self.next = px4_msgs.msg.PositionSetpoint()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2Q2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fB().pack(_x.timestamp, _x.previous.timestamp, _x.previous.valid, _x.previous.type, _x.previous.x, _x.previous.y, _x.previous.z, _x.previous.position_valid, _x.previous.vx, _x.previous.vy, _x.previous.vz, _x.previous.velocity_valid, _x.previous.velocity_frame, _x.previous.alt_valid, _x.previous.lat, _x.previous.lon, _x.previous.alt, _x.previous.yaw, _x.previous.yaw_valid, _x.previous.yawspeed, _x.previous.yawspeed_valid, _x.previous.landing_gear, _x.previous.loiter_radius, _x.previous.loiter_direction, _x.previous.pitch_min, _x.previous.a_x, _x.previous.a_y, _x.previous.a_z, _x.previous.acceleration_valid, _x.previous.acceleration_is_force, _x.previous.acceptance_radius, _x.previous.cruising_speed, _x.previous.cruising_throttle, _x.previous.allow_weather_vane, _x.current.timestamp, _x.current.valid, _x.current.type, _x.current.x, _x.current.y, _x.current.z, _x.current.position_valid, _x.current.vx, _x.current.vy, _x.current.vz, _x.current.velocity_valid, _x.current.velocity_frame, _x.current.alt_valid, _x.current.lat, _x.current.lon, _x.current.alt, _x.current.yaw, _x.current.yaw_valid, _x.current.yawspeed, _x.current.yawspeed_valid, _x.current.landing_gear, _x.current.loiter_radius, _x.current.loiter_direction, _x.current.pitch_min, _x.current.a_x, _x.current.a_y, _x.current.a_z, _x.current.acceleration_valid, _x.current.acceleration_is_force, _x.current.acceptance_radius, _x.current.cruising_speed, _x.current.cruising_throttle, _x.current.allow_weather_vane, _x.next.timestamp, _x.next.valid, _x.next.type, _x.next.x, _x.next.y, _x.next.z, _x.next.position_valid, _x.next.vx, _x.next.vy, _x.next.vz, _x.next.velocity_valid, _x.next.velocity_frame, _x.next.alt_valid, _x.next.lat, _x.next.lon, _x.next.alt, _x.next.yaw, _x.next.yaw_valid, _x.next.yawspeed, _x.next.yawspeed_valid, _x.next.landing_gear, _x.next.loiter_radius, _x.next.loiter_direction, _x.next.pitch_min, _x.next.a_x, _x.next.a_y, _x.next.a_z, _x.next.acceleration_valid, _x.next.acceleration_is_force, _x.next.acceptance_radius, _x.next.cruising_speed, _x.next.cruising_throttle, _x.next.allow_weather_vane))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.previous is None:
        self.previous = px4_msgs.msg.PositionSetpoint()
      if self.current is None:
        self.current = px4_msgs.msg.PositionSetpoint()
      if self.next is None:
        self.next = px4_msgs.msg.PositionSetpoint()
      end = 0
      _x = self
      start = end
      end += 323
      (_x.timestamp, _x.previous.timestamp, _x.previous.valid, _x.previous.type, _x.previous.x, _x.previous.y, _x.previous.z, _x.previous.position_valid, _x.previous.vx, _x.previous.vy, _x.previous.vz, _x.previous.velocity_valid, _x.previous.velocity_frame, _x.previous.alt_valid, _x.previous.lat, _x.previous.lon, _x.previous.alt, _x.previous.yaw, _x.previous.yaw_valid, _x.previous.yawspeed, _x.previous.yawspeed_valid, _x.previous.landing_gear, _x.previous.loiter_radius, _x.previous.loiter_direction, _x.previous.pitch_min, _x.previous.a_x, _x.previous.a_y, _x.previous.a_z, _x.previous.acceleration_valid, _x.previous.acceleration_is_force, _x.previous.acceptance_radius, _x.previous.cruising_speed, _x.previous.cruising_throttle, _x.previous.allow_weather_vane, _x.current.timestamp, _x.current.valid, _x.current.type, _x.current.x, _x.current.y, _x.current.z, _x.current.position_valid, _x.current.vx, _x.current.vy, _x.current.vz, _x.current.velocity_valid, _x.current.velocity_frame, _x.current.alt_valid, _x.current.lat, _x.current.lon, _x.current.alt, _x.current.yaw, _x.current.yaw_valid, _x.current.yawspeed, _x.current.yawspeed_valid, _x.current.landing_gear, _x.current.loiter_radius, _x.current.loiter_direction, _x.current.pitch_min, _x.current.a_x, _x.current.a_y, _x.current.a_z, _x.current.acceleration_valid, _x.current.acceleration_is_force, _x.current.acceptance_radius, _x.current.cruising_speed, _x.current.cruising_throttle, _x.current.allow_weather_vane, _x.next.timestamp, _x.next.valid, _x.next.type, _x.next.x, _x.next.y, _x.next.z, _x.next.position_valid, _x.next.vx, _x.next.vy, _x.next.vz, _x.next.velocity_valid, _x.next.velocity_frame, _x.next.alt_valid, _x.next.lat, _x.next.lon, _x.next.alt, _x.next.yaw, _x.next.yaw_valid, _x.next.yawspeed, _x.next.yawspeed_valid, _x.next.landing_gear, _x.next.loiter_radius, _x.next.loiter_direction, _x.next.pitch_min, _x.next.a_x, _x.next.a_y, _x.next.a_z, _x.next.acceleration_valid, _x.next.acceleration_is_force, _x.next.acceptance_radius, _x.next.cruising_speed, _x.next.cruising_throttle, _x.next.allow_weather_vane,) = _get_struct_2Q2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fB().unpack(str[start:end])
      self.previous.valid = bool(self.previous.valid)
      self.previous.position_valid = bool(self.previous.position_valid)
      self.previous.velocity_valid = bool(self.previous.velocity_valid)
      self.previous.alt_valid = bool(self.previous.alt_valid)
      self.previous.yaw_valid = bool(self.previous.yaw_valid)
      self.previous.yawspeed_valid = bool(self.previous.yawspeed_valid)
      self.previous.acceleration_valid = bool(self.previous.acceleration_valid)
      self.previous.acceleration_is_force = bool(self.previous.acceleration_is_force)
      self.previous.allow_weather_vane = bool(self.previous.allow_weather_vane)
      self.current.valid = bool(self.current.valid)
      self.current.position_valid = bool(self.current.position_valid)
      self.current.velocity_valid = bool(self.current.velocity_valid)
      self.current.alt_valid = bool(self.current.alt_valid)
      self.current.yaw_valid = bool(self.current.yaw_valid)
      self.current.yawspeed_valid = bool(self.current.yawspeed_valid)
      self.current.acceleration_valid = bool(self.current.acceleration_valid)
      self.current.acceleration_is_force = bool(self.current.acceleration_is_force)
      self.current.allow_weather_vane = bool(self.current.allow_weather_vane)
      self.next.valid = bool(self.next.valid)
      self.next.position_valid = bool(self.next.position_valid)
      self.next.velocity_valid = bool(self.next.velocity_valid)
      self.next.alt_valid = bool(self.next.alt_valid)
      self.next.yaw_valid = bool(self.next.yaw_valid)
      self.next.yawspeed_valid = bool(self.next.yawspeed_valid)
      self.next.acceleration_valid = bool(self.next.acceleration_valid)
      self.next.acceleration_is_force = bool(self.next.acceleration_is_force)
      self.next.allow_weather_vane = bool(self.next.allow_weather_vane)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2Q2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fB().pack(_x.timestamp, _x.previous.timestamp, _x.previous.valid, _x.previous.type, _x.previous.x, _x.previous.y, _x.previous.z, _x.previous.position_valid, _x.previous.vx, _x.previous.vy, _x.previous.vz, _x.previous.velocity_valid, _x.previous.velocity_frame, _x.previous.alt_valid, _x.previous.lat, _x.previous.lon, _x.previous.alt, _x.previous.yaw, _x.previous.yaw_valid, _x.previous.yawspeed, _x.previous.yawspeed_valid, _x.previous.landing_gear, _x.previous.loiter_radius, _x.previous.loiter_direction, _x.previous.pitch_min, _x.previous.a_x, _x.previous.a_y, _x.previous.a_z, _x.previous.acceleration_valid, _x.previous.acceleration_is_force, _x.previous.acceptance_radius, _x.previous.cruising_speed, _x.previous.cruising_throttle, _x.previous.allow_weather_vane, _x.current.timestamp, _x.current.valid, _x.current.type, _x.current.x, _x.current.y, _x.current.z, _x.current.position_valid, _x.current.vx, _x.current.vy, _x.current.vz, _x.current.velocity_valid, _x.current.velocity_frame, _x.current.alt_valid, _x.current.lat, _x.current.lon, _x.current.alt, _x.current.yaw, _x.current.yaw_valid, _x.current.yawspeed, _x.current.yawspeed_valid, _x.current.landing_gear, _x.current.loiter_radius, _x.current.loiter_direction, _x.current.pitch_min, _x.current.a_x, _x.current.a_y, _x.current.a_z, _x.current.acceleration_valid, _x.current.acceleration_is_force, _x.current.acceptance_radius, _x.current.cruising_speed, _x.current.cruising_throttle, _x.current.allow_weather_vane, _x.next.timestamp, _x.next.valid, _x.next.type, _x.next.x, _x.next.y, _x.next.z, _x.next.position_valid, _x.next.vx, _x.next.vy, _x.next.vz, _x.next.velocity_valid, _x.next.velocity_frame, _x.next.alt_valid, _x.next.lat, _x.next.lon, _x.next.alt, _x.next.yaw, _x.next.yaw_valid, _x.next.yawspeed, _x.next.yawspeed_valid, _x.next.landing_gear, _x.next.loiter_radius, _x.next.loiter_direction, _x.next.pitch_min, _x.next.a_x, _x.next.a_y, _x.next.a_z, _x.next.acceleration_valid, _x.next.acceleration_is_force, _x.next.acceptance_radius, _x.next.cruising_speed, _x.next.cruising_throttle, _x.next.allow_weather_vane))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.previous is None:
        self.previous = px4_msgs.msg.PositionSetpoint()
      if self.current is None:
        self.current = px4_msgs.msg.PositionSetpoint()
      if self.next is None:
        self.next = px4_msgs.msg.PositionSetpoint()
      end = 0
      _x = self
      start = end
      end += 323
      (_x.timestamp, _x.previous.timestamp, _x.previous.valid, _x.previous.type, _x.previous.x, _x.previous.y, _x.previous.z, _x.previous.position_valid, _x.previous.vx, _x.previous.vy, _x.previous.vz, _x.previous.velocity_valid, _x.previous.velocity_frame, _x.previous.alt_valid, _x.previous.lat, _x.previous.lon, _x.previous.alt, _x.previous.yaw, _x.previous.yaw_valid, _x.previous.yawspeed, _x.previous.yawspeed_valid, _x.previous.landing_gear, _x.previous.loiter_radius, _x.previous.loiter_direction, _x.previous.pitch_min, _x.previous.a_x, _x.previous.a_y, _x.previous.a_z, _x.previous.acceleration_valid, _x.previous.acceleration_is_force, _x.previous.acceptance_radius, _x.previous.cruising_speed, _x.previous.cruising_throttle, _x.previous.allow_weather_vane, _x.current.timestamp, _x.current.valid, _x.current.type, _x.current.x, _x.current.y, _x.current.z, _x.current.position_valid, _x.current.vx, _x.current.vy, _x.current.vz, _x.current.velocity_valid, _x.current.velocity_frame, _x.current.alt_valid, _x.current.lat, _x.current.lon, _x.current.alt, _x.current.yaw, _x.current.yaw_valid, _x.current.yawspeed, _x.current.yawspeed_valid, _x.current.landing_gear, _x.current.loiter_radius, _x.current.loiter_direction, _x.current.pitch_min, _x.current.a_x, _x.current.a_y, _x.current.a_z, _x.current.acceleration_valid, _x.current.acceleration_is_force, _x.current.acceptance_radius, _x.current.cruising_speed, _x.current.cruising_throttle, _x.current.allow_weather_vane, _x.next.timestamp, _x.next.valid, _x.next.type, _x.next.x, _x.next.y, _x.next.z, _x.next.position_valid, _x.next.vx, _x.next.vy, _x.next.vz, _x.next.velocity_valid, _x.next.velocity_frame, _x.next.alt_valid, _x.next.lat, _x.next.lon, _x.next.alt, _x.next.yaw, _x.next.yaw_valid, _x.next.yawspeed, _x.next.yawspeed_valid, _x.next.landing_gear, _x.next.loiter_radius, _x.next.loiter_direction, _x.next.pitch_min, _x.next.a_x, _x.next.a_y, _x.next.a_z, _x.next.acceleration_valid, _x.next.acceleration_is_force, _x.next.acceptance_radius, _x.next.cruising_speed, _x.next.cruising_throttle, _x.next.allow_weather_vane,) = _get_struct_2Q2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fB().unpack(str[start:end])
      self.previous.valid = bool(self.previous.valid)
      self.previous.position_valid = bool(self.previous.position_valid)
      self.previous.velocity_valid = bool(self.previous.velocity_valid)
      self.previous.alt_valid = bool(self.previous.alt_valid)
      self.previous.yaw_valid = bool(self.previous.yaw_valid)
      self.previous.yawspeed_valid = bool(self.previous.yawspeed_valid)
      self.previous.acceleration_valid = bool(self.previous.acceleration_valid)
      self.previous.acceleration_is_force = bool(self.previous.acceleration_is_force)
      self.previous.allow_weather_vane = bool(self.previous.allow_weather_vane)
      self.current.valid = bool(self.current.valid)
      self.current.position_valid = bool(self.current.position_valid)
      self.current.velocity_valid = bool(self.current.velocity_valid)
      self.current.alt_valid = bool(self.current.alt_valid)
      self.current.yaw_valid = bool(self.current.yaw_valid)
      self.current.yawspeed_valid = bool(self.current.yawspeed_valid)
      self.current.acceleration_valid = bool(self.current.acceleration_valid)
      self.current.acceleration_is_force = bool(self.current.acceleration_is_force)
      self.current.allow_weather_vane = bool(self.current.allow_weather_vane)
      self.next.valid = bool(self.next.valid)
      self.next.position_valid = bool(self.next.position_valid)
      self.next.velocity_valid = bool(self.next.velocity_valid)
      self.next.alt_valid = bool(self.next.alt_valid)
      self.next.yaw_valid = bool(self.next.yaw_valid)
      self.next.yawspeed_valid = bool(self.next.yawspeed_valid)
      self.next.acceleration_valid = bool(self.next.acceleration_valid)
      self.next.acceleration_is_force = bool(self.next.acceleration_is_force)
      self.next.allow_weather_vane = bool(self.next.allow_weather_vane)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2Q2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fB = None
def _get_struct_2Q2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fB():
    global _struct_2Q2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fB
    if _struct_2Q2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fB is None:
        _struct_2Q2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fB = struct.Struct("<2Q2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fB")
    return _struct_2Q2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fBQ2B3fB3f3B2d2fBfBbfb4f2B3fB
