# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/RcParameterMap.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class RcParameterMap(genpy.Message):
  _md5sum = "b7ecd1f32dbda75ddc546919325fa659"
  _type = "px4_msgs/RcParameterMap"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp		# time since system start (microseconds)
uint8 RC_PARAM_MAP_NCHAN = 3 # This limit is also hardcoded in the enum RC_CHANNELS_FUNCTION in rc_channels.h
uint8 PARAM_ID_LEN = 16 # corresponds to MAVLINK_MSG_PARAM_VALUE_FIELD_PARAM_ID_LEN

bool[3] valid		#true for RC-Param channels which are mapped to a param
int32[3] param_index	# corresponding param index, this field is ignored if set to -1, in this case param_id will be used
char[51] param_id	# MAP_NCHAN * (ID_LEN + 1) chars, corresponding param id, null terminated
float32[3] scale		# scale to map the RC input [-1, 1] to a parameter value
float32[3] value0		# initial value around which the parameter value is changed
float32[3] value_min	# minimal parameter value
float32[3] value_max	# minimal parameter value
"""
  # Pseudo-constants
  RC_PARAM_MAP_NCHAN = 3
  PARAM_ID_LEN = 16

  __slots__ = ['timestamp','valid','param_index','param_id','scale','value0','value_min','value_max']
  _slot_types = ['uint64','bool[3]','int32[3]','char[51]','float32[3]','float32[3]','float32[3]','float32[3]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,valid,param_index,param_id,scale,value0,value_min,value_max

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RcParameterMap, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.valid is None:
        self.valid = [False] * 3
      if self.param_index is None:
        self.param_index = [0] * 3
      if self.param_id is None:
        self.param_id = b'\0'*51
      if self.scale is None:
        self.scale = [0.] * 3
      if self.value0 is None:
        self.value0 = [0.] * 3
      if self.value_min is None:
        self.value_min = [0.] * 3
      if self.value_max is None:
        self.value_max = [0.] * 3
    else:
      self.timestamp = 0
      self.valid = [False] * 3
      self.param_index = [0] * 3
      self.param_id = b'\0'*51
      self.scale = [0.] * 3
      self.value0 = [0.] * 3
      self.value_min = [0.] * 3
      self.value_max = [0.] * 3

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.timestamp
      buff.write(_get_struct_Q().pack(_x))
      buff.write(_get_struct_3B().pack(*self.valid))
      buff.write(_get_struct_3i().pack(*self.param_index))
      _x = self.param_id
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_51B().pack(*_x))
      else:
        buff.write(_get_struct_51s().pack(_x))
      buff.write(_get_struct_3f().pack(*self.scale))
      buff.write(_get_struct_3f().pack(*self.value0))
      buff.write(_get_struct_3f().pack(*self.value_min))
      buff.write(_get_struct_3f().pack(*self.value_max))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 8
      (self.timestamp,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 3
      self.valid = _get_struct_3B().unpack(str[start:end])
      self.valid = list(map(bool, self.valid))
      start = end
      end += 12
      self.param_index = _get_struct_3i().unpack(str[start:end])
      start = end
      end += 51
      self.param_id = str[start:end]
      start = end
      end += 12
      self.scale = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.value0 = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.value_min = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.value_max = _get_struct_3f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.timestamp
      buff.write(_get_struct_Q().pack(_x))
      buff.write(self.valid.tostring())
      buff.write(self.param_index.tostring())
      _x = self.param_id
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_51B().pack(*_x))
      else:
        buff.write(_get_struct_51s().pack(_x))
      buff.write(self.scale.tostring())
      buff.write(self.value0.tostring())
      buff.write(self.value_min.tostring())
      buff.write(self.value_max.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 8
      (self.timestamp,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 3
      self.valid = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=3)
      self.valid = list(map(bool, self.valid))
      start = end
      end += 12
      self.param_index = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=3)
      start = end
      end += 51
      self.param_id = str[start:end]
      start = end
      end += 12
      self.scale = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.value0 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.value_min = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.value_max = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3B = None
def _get_struct_3B():
    global _struct_3B
    if _struct_3B is None:
        _struct_3B = struct.Struct("<3B")
    return _struct_3B
_struct_3f = None
def _get_struct_3f():
    global _struct_3f
    if _struct_3f is None:
        _struct_3f = struct.Struct("<3f")
    return _struct_3f
_struct_3i = None
def _get_struct_3i():
    global _struct_3i
    if _struct_3i is None:
        _struct_3i = struct.Struct("<3i")
    return _struct_3i
_struct_51B = None
def _get_struct_51B():
    global _struct_51B
    if _struct_51B is None:
        _struct_51B = struct.Struct("<51B")
    return _struct_51B
_struct_51s = None
def _get_struct_51s():
    global _struct_51s
    if _struct_51s is None:
        _struct_51s = struct.Struct("<51s")
    return _struct_51s
_struct_Q = None
def _get_struct_Q():
    global _struct_Q
    if _struct_Q is None:
        _struct_Q = struct.Struct("<Q")
    return _struct_Q
