# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/SatelliteInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SatelliteInfo(genpy.Message):
  _md5sum = "5b13b7f043a2c1c9339121e656ce670d"
  _type = "px4_msgs/SatelliteInfo"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp		# time since system start (microseconds)
uint8 SAT_INFO_MAX_SATELLITES = 20

uint8 count			# Number of satellites in satellite info
uint8[20] svid	 		# Space vehicle ID [1..255], see scheme below
uint8[20] used			# 0: Satellite not used, 1: used for navigation
uint8[20] elevation		# Elevation (0: right on top of receiver, 90: on the horizon) of satellite
uint8[20] azimuth		# Direction of satellite, 0: 0 deg, 255: 360 deg.
uint8[20] snr			# dBHz, Signal to noise ratio of satellite C/N0, range 0..99, zero when not tracking this satellite.
"""
  # Pseudo-constants
  SAT_INFO_MAX_SATELLITES = 20

  __slots__ = ['timestamp','count','svid','used','elevation','azimuth','snr']
  _slot_types = ['uint64','uint8','uint8[20]','uint8[20]','uint8[20]','uint8[20]','uint8[20]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,count,svid,used,elevation,azimuth,snr

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SatelliteInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.count is None:
        self.count = 0
      if self.svid is None:
        self.svid = b'\0'*20
      if self.used is None:
        self.used = b'\0'*20
      if self.elevation is None:
        self.elevation = b'\0'*20
      if self.azimuth is None:
        self.azimuth = b'\0'*20
      if self.snr is None:
        self.snr = b'\0'*20
    else:
      self.timestamp = 0
      self.count = 0
      self.svid = b'\0'*20
      self.used = b'\0'*20
      self.elevation = b'\0'*20
      self.azimuth = b'\0'*20
      self.snr = b'\0'*20

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_QB().pack(_x.timestamp, _x.count))
      _x = self.svid
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_20B().pack(*_x))
      else:
        buff.write(_get_struct_20s().pack(_x))
      _x = self.used
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_20B().pack(*_x))
      else:
        buff.write(_get_struct_20s().pack(_x))
      _x = self.elevation
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_20B().pack(*_x))
      else:
        buff.write(_get_struct_20s().pack(_x))
      _x = self.azimuth
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_20B().pack(*_x))
      else:
        buff.write(_get_struct_20s().pack(_x))
      _x = self.snr
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_20B().pack(*_x))
      else:
        buff.write(_get_struct_20s().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 9
      (_x.timestamp, _x.count,) = _get_struct_QB().unpack(str[start:end])
      start = end
      end += 20
      self.svid = str[start:end]
      start = end
      end += 20
      self.used = str[start:end]
      start = end
      end += 20
      self.elevation = str[start:end]
      start = end
      end += 20
      self.azimuth = str[start:end]
      start = end
      end += 20
      self.snr = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_QB().pack(_x.timestamp, _x.count))
      _x = self.svid
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_20B().pack(*_x))
      else:
        buff.write(_get_struct_20s().pack(_x))
      _x = self.used
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_20B().pack(*_x))
      else:
        buff.write(_get_struct_20s().pack(_x))
      _x = self.elevation
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_20B().pack(*_x))
      else:
        buff.write(_get_struct_20s().pack(_x))
      _x = self.azimuth
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_20B().pack(*_x))
      else:
        buff.write(_get_struct_20s().pack(_x))
      _x = self.snr
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_20B().pack(*_x))
      else:
        buff.write(_get_struct_20s().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 9
      (_x.timestamp, _x.count,) = _get_struct_QB().unpack(str[start:end])
      start = end
      end += 20
      self.svid = str[start:end]
      start = end
      end += 20
      self.used = str[start:end]
      start = end
      end += 20
      self.elevation = str[start:end]
      start = end
      end += 20
      self.azimuth = str[start:end]
      start = end
      end += 20
      self.snr = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_20B = None
def _get_struct_20B():
    global _struct_20B
    if _struct_20B is None:
        _struct_20B = struct.Struct("<20B")
    return _struct_20B
_struct_20s = None
def _get_struct_20s():
    global _struct_20s
    if _struct_20s is None:
        _struct_20s = struct.Struct("<20s")
    return _struct_20s
_struct_QB = None
def _get_struct_QB():
    global _struct_QB
    if _struct_QB is None:
        _struct_QB = struct.Struct("<QB")
    return _struct_QB
