# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/SensorCombined.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SensorCombined(genpy.Message):
  _md5sum = "7fdd17007ff7b950ca00dc9701277b2e"
  _type = "px4_msgs/SensorCombined"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Sensor readings in SI-unit form.
# These fields are scaled and offset-compensated where possible and do not
# change with board revisions and sensor updates.

uint64 timestamp				# time since system start (microseconds)

int32 RELATIVE_TIMESTAMP_INVALID = 2147483647	# (0x7fffffff) If one of the relative timestamps is set to this value, it means the associated sensor values are invalid

# gyro timstamp is equal to the timestamp of the message
float32[3] gyro_rad			# average angular rate measured in the XYZ body frame in rad/s over the last gyro sampling period
uint32 gyro_integral_dt		# gyro measurement sampling period in us

int32 accelerometer_timestamp_relative	# timestamp + accelerometer_timestamp_relative = Accelerometer timestamp
float32[3] accelerometer_m_s2		# average value acceleration measured in the XYZ body frame in m/s/s over the last accelerometer sampling period
uint32 accelerometer_integral_dt	# accelerometer measurement sampling period in us
"""
  # Pseudo-constants
  RELATIVE_TIMESTAMP_INVALID = 2147483647

  __slots__ = ['timestamp','gyro_rad','gyro_integral_dt','accelerometer_timestamp_relative','accelerometer_m_s2','accelerometer_integral_dt']
  _slot_types = ['uint64','float32[3]','uint32','int32','float32[3]','uint32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,gyro_rad,gyro_integral_dt,accelerometer_timestamp_relative,accelerometer_m_s2,accelerometer_integral_dt

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SensorCombined, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.gyro_rad is None:
        self.gyro_rad = [0.] * 3
      if self.gyro_integral_dt is None:
        self.gyro_integral_dt = 0
      if self.accelerometer_timestamp_relative is None:
        self.accelerometer_timestamp_relative = 0
      if self.accelerometer_m_s2 is None:
        self.accelerometer_m_s2 = [0.] * 3
      if self.accelerometer_integral_dt is None:
        self.accelerometer_integral_dt = 0
    else:
      self.timestamp = 0
      self.gyro_rad = [0.] * 3
      self.gyro_integral_dt = 0
      self.accelerometer_timestamp_relative = 0
      self.accelerometer_m_s2 = [0.] * 3
      self.accelerometer_integral_dt = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.timestamp
      buff.write(_get_struct_Q().pack(_x))
      buff.write(_get_struct_3f().pack(*self.gyro_rad))
      _x = self
      buff.write(_get_struct_Ii().pack(_x.gyro_integral_dt, _x.accelerometer_timestamp_relative))
      buff.write(_get_struct_3f().pack(*self.accelerometer_m_s2))
      _x = self.accelerometer_integral_dt
      buff.write(_get_struct_I().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 8
      (self.timestamp,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 12
      self.gyro_rad = _get_struct_3f().unpack(str[start:end])
      _x = self
      start = end
      end += 8
      (_x.gyro_integral_dt, _x.accelerometer_timestamp_relative,) = _get_struct_Ii().unpack(str[start:end])
      start = end
      end += 12
      self.accelerometer_m_s2 = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 4
      (self.accelerometer_integral_dt,) = _get_struct_I().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.timestamp
      buff.write(_get_struct_Q().pack(_x))
      buff.write(self.gyro_rad.tostring())
      _x = self
      buff.write(_get_struct_Ii().pack(_x.gyro_integral_dt, _x.accelerometer_timestamp_relative))
      buff.write(self.accelerometer_m_s2.tostring())
      _x = self.accelerometer_integral_dt
      buff.write(_get_struct_I().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 8
      (self.timestamp,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 12
      self.gyro_rad = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      _x = self
      start = end
      end += 8
      (_x.gyro_integral_dt, _x.accelerometer_timestamp_relative,) = _get_struct_Ii().unpack(str[start:end])
      start = end
      end += 12
      self.accelerometer_m_s2 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 4
      (self.accelerometer_integral_dt,) = _get_struct_I().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3f = None
def _get_struct_3f():
    global _struct_3f
    if _struct_3f is None:
        _struct_3f = struct.Struct("<3f")
    return _struct_3f
_struct_Ii = None
def _get_struct_Ii():
    global _struct_Ii
    if _struct_Ii is None:
        _struct_Ii = struct.Struct("<Ii")
    return _struct_Ii
_struct_Q = None
def _get_struct_Q():
    global _struct_Q
    if _struct_Q is None:
        _struct_Q = struct.Struct("<Q")
    return _struct_Q
