# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/SensorCorrection.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SensorCorrection(genpy.Message):
  _md5sum = "ecfb84a75f9a7535659897436aa97dbd"
  _type = "px4_msgs/SensorCorrection"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """#
# Sensor corrections in SI-unit form for the voted sensor
#

uint64 timestamp		# time since system start (microseconds)

# Corrections for gyro angular rate outputs where corrected_rate = raw_rate * gyro_scale + gyro_offset
# Note the corrections are in the sensor frame and must be applied before the sensor data is rotated into body frame
# corrections for uORB instance 0
float32[3] gyro_offset_0	# gyro XYZ offsets in the sensor frame in rad/s
float32[3] gyro_scale_0		# gyro XYZ scale factors in the sensor frame

# corrections for uORB instance 1
float32[3] gyro_offset_1	# gyro XYZ offsets in the sensor frame in rad/s
float32[3] gyro_scale_1		# gyro XYZ scale factors in the sensor frame

# corrections for uORB instance 2
float32[3] gyro_offset_2	# gyro XYZ offsets in the sensor frame in rad/s
float32[3] gyro_scale_2		# gyro XYZ scale factors in the sensor frame

# Corrections for acceleromter acceleration outputs where corrected_accel = raw_accel * accel_scale + accel_offset
# Note the corrections are in the sensor frame and must be applied before the sensor data is rotated into body frame
# corrections for uORB instance 0
float32[3] accel_offset_0	# accelerometer XYZ offsets in the sensor frame in m/s/s
float32[3] accel_scale_0	# accelerometer XYZ scale factors in the sensor frame

# corrections for uORB instance 1
float32[3] accel_offset_1	# accelerometer XYZ offsets in the sensor frame in m/s/s
float32[3] accel_scale_1	# accelerometer XYZ scale factors in the sensor frame

# corrections for uORB instance 2
float32[3] accel_offset_2	# accelerometer XYZ offsets in the sensor frame in m/s/s
float32[3] accel_scale_2	# accelerometer XYZ scale factors in the sensor frame

# Corrections for barometric pressure outputs where corrected_pressure = raw_pressure * pressure_scale + pressure_offset
# Note the corrections are in the sensor frame and must be applied before the sensor data is rotated into body frame
# corrections for uORB instance 0
float32 baro_offset_0		# barometric pressure offsets in the sensor frame in m/s/s
float32 baro_scale_0		# barometric pressure scale factors in the sensor frame

# corrections for uORB instance 1
float32 baro_offset_1		# barometric pressure offsets in the sensor frame in m/s/s
float32 baro_scale_1		# barometric pressure scale factors in the sensor frame

# corrections for uORB instance 2
float32 baro_offset_2		# barometric pressure offsets in the sensor frame in m/s/s
float32 baro_scale_2		# barometric pressure scale factors in the sensor frame

uint8 selected_gyro_instance	# gyro uORB topic instance for the voted sensor
uint8 selected_accel_instance	# accelerometer uORB topic instance for the voted sensor
uint8 selected_baro_instance	# barometric pressure uORB topic instance for the voted sensor

# Mapping from uORB index to parameter index for each sensor type. For example accel_mapping[1] contains the
# compensation parameter system index for the sensor_accel uORB index 1 data.
uint8[3] gyro_mapping
uint8[3] accel_mapping
uint8[3] baro_mapping
"""
  __slots__ = ['timestamp','gyro_offset_0','gyro_scale_0','gyro_offset_1','gyro_scale_1','gyro_offset_2','gyro_scale_2','accel_offset_0','accel_scale_0','accel_offset_1','accel_scale_1','accel_offset_2','accel_scale_2','baro_offset_0','baro_scale_0','baro_offset_1','baro_scale_1','baro_offset_2','baro_scale_2','selected_gyro_instance','selected_accel_instance','selected_baro_instance','gyro_mapping','accel_mapping','baro_mapping']
  _slot_types = ['uint64','float32[3]','float32[3]','float32[3]','float32[3]','float32[3]','float32[3]','float32[3]','float32[3]','float32[3]','float32[3]','float32[3]','float32[3]','float32','float32','float32','float32','float32','float32','uint8','uint8','uint8','uint8[3]','uint8[3]','uint8[3]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,gyro_offset_0,gyro_scale_0,gyro_offset_1,gyro_scale_1,gyro_offset_2,gyro_scale_2,accel_offset_0,accel_scale_0,accel_offset_1,accel_scale_1,accel_offset_2,accel_scale_2,baro_offset_0,baro_scale_0,baro_offset_1,baro_scale_1,baro_offset_2,baro_scale_2,selected_gyro_instance,selected_accel_instance,selected_baro_instance,gyro_mapping,accel_mapping,baro_mapping

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SensorCorrection, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.gyro_offset_0 is None:
        self.gyro_offset_0 = [0.] * 3
      if self.gyro_scale_0 is None:
        self.gyro_scale_0 = [0.] * 3
      if self.gyro_offset_1 is None:
        self.gyro_offset_1 = [0.] * 3
      if self.gyro_scale_1 is None:
        self.gyro_scale_1 = [0.] * 3
      if self.gyro_offset_2 is None:
        self.gyro_offset_2 = [0.] * 3
      if self.gyro_scale_2 is None:
        self.gyro_scale_2 = [0.] * 3
      if self.accel_offset_0 is None:
        self.accel_offset_0 = [0.] * 3
      if self.accel_scale_0 is None:
        self.accel_scale_0 = [0.] * 3
      if self.accel_offset_1 is None:
        self.accel_offset_1 = [0.] * 3
      if self.accel_scale_1 is None:
        self.accel_scale_1 = [0.] * 3
      if self.accel_offset_2 is None:
        self.accel_offset_2 = [0.] * 3
      if self.accel_scale_2 is None:
        self.accel_scale_2 = [0.] * 3
      if self.baro_offset_0 is None:
        self.baro_offset_0 = 0.
      if self.baro_scale_0 is None:
        self.baro_scale_0 = 0.
      if self.baro_offset_1 is None:
        self.baro_offset_1 = 0.
      if self.baro_scale_1 is None:
        self.baro_scale_1 = 0.
      if self.baro_offset_2 is None:
        self.baro_offset_2 = 0.
      if self.baro_scale_2 is None:
        self.baro_scale_2 = 0.
      if self.selected_gyro_instance is None:
        self.selected_gyro_instance = 0
      if self.selected_accel_instance is None:
        self.selected_accel_instance = 0
      if self.selected_baro_instance is None:
        self.selected_baro_instance = 0
      if self.gyro_mapping is None:
        self.gyro_mapping = b'\0'*3
      if self.accel_mapping is None:
        self.accel_mapping = b'\0'*3
      if self.baro_mapping is None:
        self.baro_mapping = b'\0'*3
    else:
      self.timestamp = 0
      self.gyro_offset_0 = [0.] * 3
      self.gyro_scale_0 = [0.] * 3
      self.gyro_offset_1 = [0.] * 3
      self.gyro_scale_1 = [0.] * 3
      self.gyro_offset_2 = [0.] * 3
      self.gyro_scale_2 = [0.] * 3
      self.accel_offset_0 = [0.] * 3
      self.accel_scale_0 = [0.] * 3
      self.accel_offset_1 = [0.] * 3
      self.accel_scale_1 = [0.] * 3
      self.accel_offset_2 = [0.] * 3
      self.accel_scale_2 = [0.] * 3
      self.baro_offset_0 = 0.
      self.baro_scale_0 = 0.
      self.baro_offset_1 = 0.
      self.baro_scale_1 = 0.
      self.baro_offset_2 = 0.
      self.baro_scale_2 = 0.
      self.selected_gyro_instance = 0
      self.selected_accel_instance = 0
      self.selected_baro_instance = 0
      self.gyro_mapping = b'\0'*3
      self.accel_mapping = b'\0'*3
      self.baro_mapping = b'\0'*3

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.timestamp
      buff.write(_get_struct_Q().pack(_x))
      buff.write(_get_struct_3f().pack(*self.gyro_offset_0))
      buff.write(_get_struct_3f().pack(*self.gyro_scale_0))
      buff.write(_get_struct_3f().pack(*self.gyro_offset_1))
      buff.write(_get_struct_3f().pack(*self.gyro_scale_1))
      buff.write(_get_struct_3f().pack(*self.gyro_offset_2))
      buff.write(_get_struct_3f().pack(*self.gyro_scale_2))
      buff.write(_get_struct_3f().pack(*self.accel_offset_0))
      buff.write(_get_struct_3f().pack(*self.accel_scale_0))
      buff.write(_get_struct_3f().pack(*self.accel_offset_1))
      buff.write(_get_struct_3f().pack(*self.accel_scale_1))
      buff.write(_get_struct_3f().pack(*self.accel_offset_2))
      buff.write(_get_struct_3f().pack(*self.accel_scale_2))
      _x = self
      buff.write(_get_struct_6f3B().pack(_x.baro_offset_0, _x.baro_scale_0, _x.baro_offset_1, _x.baro_scale_1, _x.baro_offset_2, _x.baro_scale_2, _x.selected_gyro_instance, _x.selected_accel_instance, _x.selected_baro_instance))
      _x = self.gyro_mapping
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_3B().pack(*_x))
      else:
        buff.write(_get_struct_3s().pack(_x))
      _x = self.accel_mapping
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_3B().pack(*_x))
      else:
        buff.write(_get_struct_3s().pack(_x))
      _x = self.baro_mapping
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_3B().pack(*_x))
      else:
        buff.write(_get_struct_3s().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 8
      (self.timestamp,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 12
      self.gyro_offset_0 = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.gyro_scale_0 = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.gyro_offset_1 = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.gyro_scale_1 = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.gyro_offset_2 = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.gyro_scale_2 = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.accel_offset_0 = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.accel_scale_0 = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.accel_offset_1 = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.accel_scale_1 = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.accel_offset_2 = _get_struct_3f().unpack(str[start:end])
      start = end
      end += 12
      self.accel_scale_2 = _get_struct_3f().unpack(str[start:end])
      _x = self
      start = end
      end += 27
      (_x.baro_offset_0, _x.baro_scale_0, _x.baro_offset_1, _x.baro_scale_1, _x.baro_offset_2, _x.baro_scale_2, _x.selected_gyro_instance, _x.selected_accel_instance, _x.selected_baro_instance,) = _get_struct_6f3B().unpack(str[start:end])
      start = end
      end += 3
      self.gyro_mapping = str[start:end]
      start = end
      end += 3
      self.accel_mapping = str[start:end]
      start = end
      end += 3
      self.baro_mapping = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.timestamp
      buff.write(_get_struct_Q().pack(_x))
      buff.write(self.gyro_offset_0.tostring())
      buff.write(self.gyro_scale_0.tostring())
      buff.write(self.gyro_offset_1.tostring())
      buff.write(self.gyro_scale_1.tostring())
      buff.write(self.gyro_offset_2.tostring())
      buff.write(self.gyro_scale_2.tostring())
      buff.write(self.accel_offset_0.tostring())
      buff.write(self.accel_scale_0.tostring())
      buff.write(self.accel_offset_1.tostring())
      buff.write(self.accel_scale_1.tostring())
      buff.write(self.accel_offset_2.tostring())
      buff.write(self.accel_scale_2.tostring())
      _x = self
      buff.write(_get_struct_6f3B().pack(_x.baro_offset_0, _x.baro_scale_0, _x.baro_offset_1, _x.baro_scale_1, _x.baro_offset_2, _x.baro_scale_2, _x.selected_gyro_instance, _x.selected_accel_instance, _x.selected_baro_instance))
      _x = self.gyro_mapping
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_3B().pack(*_x))
      else:
        buff.write(_get_struct_3s().pack(_x))
      _x = self.accel_mapping
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_3B().pack(*_x))
      else:
        buff.write(_get_struct_3s().pack(_x))
      _x = self.baro_mapping
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_3B().pack(*_x))
      else:
        buff.write(_get_struct_3s().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 8
      (self.timestamp,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 12
      self.gyro_offset_0 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.gyro_scale_0 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.gyro_offset_1 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.gyro_scale_1 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.gyro_offset_2 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.gyro_scale_2 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.accel_offset_0 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.accel_scale_0 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.accel_offset_1 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.accel_scale_1 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.accel_offset_2 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      start = end
      end += 12
      self.accel_scale_2 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      _x = self
      start = end
      end += 27
      (_x.baro_offset_0, _x.baro_scale_0, _x.baro_offset_1, _x.baro_scale_1, _x.baro_offset_2, _x.baro_scale_2, _x.selected_gyro_instance, _x.selected_accel_instance, _x.selected_baro_instance,) = _get_struct_6f3B().unpack(str[start:end])
      start = end
      end += 3
      self.gyro_mapping = str[start:end]
      start = end
      end += 3
      self.accel_mapping = str[start:end]
      start = end
      end += 3
      self.baro_mapping = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3B = None
def _get_struct_3B():
    global _struct_3B
    if _struct_3B is None:
        _struct_3B = struct.Struct("<3B")
    return _struct_3B
_struct_3f = None
def _get_struct_3f():
    global _struct_3f
    if _struct_3f is None:
        _struct_3f = struct.Struct("<3f")
    return _struct_3f
_struct_3s = None
def _get_struct_3s():
    global _struct_3s
    if _struct_3s is None:
        _struct_3s = struct.Struct("<3s")
    return _struct_3s
_struct_6f3B = None
def _get_struct_6f3B():
    global _struct_6f3B
    if _struct_6f3B is None:
        _struct_6f3B = struct.Struct("<6f3B")
    return _struct_6f3B
_struct_Q = None
def _get_struct_Q():
    global _struct_Q
    if _struct_Q is None:
        _struct_Q = struct.Struct("<Q")
    return _struct_Q
