# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/SensorGyro.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SensorGyro(genpy.Message):
  _md5sum = "f07e82e81bb02e7d3803725740930361"
  _type = "px4_msgs/SensorGyro"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint32 device_id	# unique device ID for the sensor that does not change between power cycles

uint64 timestamp	# time since system start (microseconds)

uint64 error_count

float32 x		# angular velocity in the NED X board axis in rad/s
float32 y		# angular velocity in the NED Y board axis in rad/s
float32 z		# angular velocity in the NED Z board axis in rad/s

uint32 integral_dt	# integration time (microseconds)
float32 x_integral	# delta angle in the NED X board axis in rad/s over the integration time frame (integral_dt)
float32 y_integral	# delta angle in the NED Y board axis in rad/s over the integration time frame (integral_dt)
float32 z_integral	# delta angle in the NED Z board axis in rad/s over the integration time frame (integral_dt)

float32 temperature	# temperature in degrees celsius

float32 scaling		# scaling from raw to rad/s
int16 x_raw
int16 y_raw
int16 z_raw
"""
  __slots__ = ['device_id','timestamp','error_count','x','y','z','integral_dt','x_integral','y_integral','z_integral','temperature','scaling','x_raw','y_raw','z_raw']
  _slot_types = ['uint32','uint64','uint64','float32','float32','float32','uint32','float32','float32','float32','float32','float32','int16','int16','int16']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       device_id,timestamp,error_count,x,y,z,integral_dt,x_integral,y_integral,z_integral,temperature,scaling,x_raw,y_raw,z_raw

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SensorGyro, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.device_id is None:
        self.device_id = 0
      if self.timestamp is None:
        self.timestamp = 0
      if self.error_count is None:
        self.error_count = 0
      if self.x is None:
        self.x = 0.
      if self.y is None:
        self.y = 0.
      if self.z is None:
        self.z = 0.
      if self.integral_dt is None:
        self.integral_dt = 0
      if self.x_integral is None:
        self.x_integral = 0.
      if self.y_integral is None:
        self.y_integral = 0.
      if self.z_integral is None:
        self.z_integral = 0.
      if self.temperature is None:
        self.temperature = 0.
      if self.scaling is None:
        self.scaling = 0.
      if self.x_raw is None:
        self.x_raw = 0
      if self.y_raw is None:
        self.y_raw = 0
      if self.z_raw is None:
        self.z_raw = 0
    else:
      self.device_id = 0
      self.timestamp = 0
      self.error_count = 0
      self.x = 0.
      self.y = 0.
      self.z = 0.
      self.integral_dt = 0
      self.x_integral = 0.
      self.y_integral = 0.
      self.z_integral = 0.
      self.temperature = 0.
      self.scaling = 0.
      self.x_raw = 0
      self.y_raw = 0
      self.z_raw = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_I2Q3fI5f3h().pack(_x.device_id, _x.timestamp, _x.error_count, _x.x, _x.y, _x.z, _x.integral_dt, _x.x_integral, _x.y_integral, _x.z_integral, _x.temperature, _x.scaling, _x.x_raw, _x.y_raw, _x.z_raw))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 62
      (_x.device_id, _x.timestamp, _x.error_count, _x.x, _x.y, _x.z, _x.integral_dt, _x.x_integral, _x.y_integral, _x.z_integral, _x.temperature, _x.scaling, _x.x_raw, _x.y_raw, _x.z_raw,) = _get_struct_I2Q3fI5f3h().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_I2Q3fI5f3h().pack(_x.device_id, _x.timestamp, _x.error_count, _x.x, _x.y, _x.z, _x.integral_dt, _x.x_integral, _x.y_integral, _x.z_integral, _x.temperature, _x.scaling, _x.x_raw, _x.y_raw, _x.z_raw))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 62
      (_x.device_id, _x.timestamp, _x.error_count, _x.x, _x.y, _x.z, _x.integral_dt, _x.x_integral, _x.y_integral, _x.z_integral, _x.temperature, _x.scaling, _x.x_raw, _x.y_raw, _x.z_raw,) = _get_struct_I2Q3fI5f3h().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_I2Q3fI5f3h = None
def _get_struct_I2Q3fI5f3h():
    global _struct_I2Q3fI5f3h
    if _struct_I2Q3fI5f3h is None:
        _struct_I2Q3fI5f3h = struct.Struct("<I2Q3fI5f3h")
    return _struct_I2Q3fI5f3h
