# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/SensorGyroControl.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SensorGyroControl(genpy.Message):
  _md5sum = "2620424bdd9a730d7397b0919f0ec5f0"
  _type = "px4_msgs/SensorGyroControl"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """
# WARNING: Not recommend for custom development.
#  This topic is part of an incremental refactoring of the sensor pipeline and will likely disappear post PX4 release v1.10

uint32 device_id	# unique device ID for the sensor that does not change between power cycles

uint64 timestamp	# time since system start (microseconds)

uint64 timestamp_sample	# time the raw data was sampled (microseconds)

float32[3] xyz		# filtered angular velocity in the board axis in rad/s
"""
  __slots__ = ['device_id','timestamp','timestamp_sample','xyz']
  _slot_types = ['uint32','uint64','uint64','float32[3]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       device_id,timestamp,timestamp_sample,xyz

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SensorGyroControl, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.device_id is None:
        self.device_id = 0
      if self.timestamp is None:
        self.timestamp = 0
      if self.timestamp_sample is None:
        self.timestamp_sample = 0
      if self.xyz is None:
        self.xyz = [0.] * 3
    else:
      self.device_id = 0
      self.timestamp = 0
      self.timestamp_sample = 0
      self.xyz = [0.] * 3

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_I2Q().pack(_x.device_id, _x.timestamp, _x.timestamp_sample))
      buff.write(_get_struct_3f().pack(*self.xyz))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 20
      (_x.device_id, _x.timestamp, _x.timestamp_sample,) = _get_struct_I2Q().unpack(str[start:end])
      start = end
      end += 12
      self.xyz = _get_struct_3f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_I2Q().pack(_x.device_id, _x.timestamp, _x.timestamp_sample))
      buff.write(self.xyz.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 20
      (_x.device_id, _x.timestamp, _x.timestamp_sample,) = _get_struct_I2Q().unpack(str[start:end])
      start = end
      end += 12
      self.xyz = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=3)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3f = None
def _get_struct_3f():
    global _struct_3f
    if _struct_3f is None:
        _struct_3f = struct.Struct("<3f")
    return _struct_3f
_struct_I2Q = None
def _get_struct_I2Q():
    global _struct_I2Q
    if _struct_I2Q is None:
        _struct_I2Q = struct.Struct("<I2Q")
    return _struct_I2Q
