# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/TransponderReport.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class TransponderReport(genpy.Message):
  _md5sum = "8349f106b0a73eece8f05cf9884f6ea6"
  _type = "px4_msgs/TransponderReport"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp	# time since system start (microseconds)
uint32 icao_address 	# ICAO address
float64 lat 		# Latitude, expressed as degrees
float64 lon 		# Longitude, expressed as degrees
uint8 altitude_type	# Type from ADSB_ALTITUDE_TYPE enum
float32 altitude 	# Altitude(ASL) in meters
float32 heading 	# Course over ground in radians, -pi to +pi, 0 is north
float32 hor_velocity	# The horizontal velocity in m/s
float32 ver_velocity 	# The vertical velocity in m/s, positive is up
char[9] callsign	# The callsign, 8+null
uint8 emitter_type 	# Type from ADSB_EMITTER_TYPE enum
uint8 tslc 		# Time since last communication in seconds
uint16 flags 		# Flags to indicate various statuses including valid data fields
uint16 squawk 		# Squawk code

# ADSB flags
uint16 PX4_ADSB_FLAGS_VALID_COORDS = 1
uint16 PX4_ADSB_FLAGS_VALID_ALTITUDE = 2
uint16 PX4_ADSB_FLAGS_VALID_HEADING = 4
uint16 PX4_ADSB_FLAGS_VALID_VELOCITY = 8
uint16 PX4_ADSB_FLAGS_VALID_CALLSIGN = 16
uint16 PX4_ADSB_FLAGS_VALID_SQUAWK = 32
uint16 PX4_ADSB_FLAGS_RETRANSLATE = 256

uint8 ORB_QUEUE_LENGTH = 10
"""
  # Pseudo-constants
  PX4_ADSB_FLAGS_VALID_COORDS = 1
  PX4_ADSB_FLAGS_VALID_ALTITUDE = 2
  PX4_ADSB_FLAGS_VALID_HEADING = 4
  PX4_ADSB_FLAGS_VALID_VELOCITY = 8
  PX4_ADSB_FLAGS_VALID_CALLSIGN = 16
  PX4_ADSB_FLAGS_VALID_SQUAWK = 32
  PX4_ADSB_FLAGS_RETRANSLATE = 256
  ORB_QUEUE_LENGTH = 10

  __slots__ = ['timestamp','icao_address','lat','lon','altitude_type','altitude','heading','hor_velocity','ver_velocity','callsign','emitter_type','tslc','flags','squawk']
  _slot_types = ['uint64','uint32','float64','float64','uint8','float32','float32','float32','float32','char[9]','uint8','uint8','uint16','uint16']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,icao_address,lat,lon,altitude_type,altitude,heading,hor_velocity,ver_velocity,callsign,emitter_type,tslc,flags,squawk

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TransponderReport, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.icao_address is None:
        self.icao_address = 0
      if self.lat is None:
        self.lat = 0.
      if self.lon is None:
        self.lon = 0.
      if self.altitude_type is None:
        self.altitude_type = 0
      if self.altitude is None:
        self.altitude = 0.
      if self.heading is None:
        self.heading = 0.
      if self.hor_velocity is None:
        self.hor_velocity = 0.
      if self.ver_velocity is None:
        self.ver_velocity = 0.
      if self.callsign is None:
        self.callsign = b'\0'*9
      if self.emitter_type is None:
        self.emitter_type = 0
      if self.tslc is None:
        self.tslc = 0
      if self.flags is None:
        self.flags = 0
      if self.squawk is None:
        self.squawk = 0
    else:
      self.timestamp = 0
      self.icao_address = 0
      self.lat = 0.
      self.lon = 0.
      self.altitude_type = 0
      self.altitude = 0.
      self.heading = 0.
      self.hor_velocity = 0.
      self.ver_velocity = 0.
      self.callsign = b'\0'*9
      self.emitter_type = 0
      self.tslc = 0
      self.flags = 0
      self.squawk = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_QI2dB4f().pack(_x.timestamp, _x.icao_address, _x.lat, _x.lon, _x.altitude_type, _x.altitude, _x.heading, _x.hor_velocity, _x.ver_velocity))
      _x = self.callsign
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_9B().pack(*_x))
      else:
        buff.write(_get_struct_9s().pack(_x))
      _x = self
      buff.write(_get_struct_2B2H().pack(_x.emitter_type, _x.tslc, _x.flags, _x.squawk))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 45
      (_x.timestamp, _x.icao_address, _x.lat, _x.lon, _x.altitude_type, _x.altitude, _x.heading, _x.hor_velocity, _x.ver_velocity,) = _get_struct_QI2dB4f().unpack(str[start:end])
      start = end
      end += 9
      self.callsign = str[start:end]
      _x = self
      start = end
      end += 6
      (_x.emitter_type, _x.tslc, _x.flags, _x.squawk,) = _get_struct_2B2H().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_QI2dB4f().pack(_x.timestamp, _x.icao_address, _x.lat, _x.lon, _x.altitude_type, _x.altitude, _x.heading, _x.hor_velocity, _x.ver_velocity))
      _x = self.callsign
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_9B().pack(*_x))
      else:
        buff.write(_get_struct_9s().pack(_x))
      _x = self
      buff.write(_get_struct_2B2H().pack(_x.emitter_type, _x.tslc, _x.flags, _x.squawk))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 45
      (_x.timestamp, _x.icao_address, _x.lat, _x.lon, _x.altitude_type, _x.altitude, _x.heading, _x.hor_velocity, _x.ver_velocity,) = _get_struct_QI2dB4f().unpack(str[start:end])
      start = end
      end += 9
      self.callsign = str[start:end]
      _x = self
      start = end
      end += 6
      (_x.emitter_type, _x.tslc, _x.flags, _x.squawk,) = _get_struct_2B2H().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B2H = None
def _get_struct_2B2H():
    global _struct_2B2H
    if _struct_2B2H is None:
        _struct_2B2H = struct.Struct("<2B2H")
    return _struct_2B2H
_struct_9B = None
def _get_struct_9B():
    global _struct_9B
    if _struct_9B is None:
        _struct_9B = struct.Struct("<9B")
    return _struct_9B
_struct_9s = None
def _get_struct_9s():
    global _struct_9s
    if _struct_9s is None:
        _struct_9s = struct.Struct("<9s")
    return _struct_9s
_struct_QI2dB4f = None
def _get_struct_QI2dB4f():
    global _struct_QI2dB4f
    if _struct_QI2dB4f is None:
        _struct_QI2dB4f = struct.Struct("<QI2dB4f")
    return _struct_QI2dB4f
