# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/TuneControl.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class TuneControl(genpy.Message):
  _md5sum = "5b7deb8f7b4db5d82eae45b962c276b5"
  _type = "px4_msgs/TuneControl"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This message is used to control the tunes, when the tune_id is set to CUSTOM
# then the frequency, duration are used otherwise those values are ignored.

uint64 timestamp     # time since system start (microseconds)

uint8 tune_id        # tune_id corresponding to TuneID::* from the tune_defaults.h in the tunes library
uint8 tune_override  # if set to 1 the tune which is playing will be stopped and the new started
uint16 frequency     # in Hz
uint32 duration      # in us
uint32 silence       # in us
uint8 volume         # value between 0-100 if supported by backend

uint8 VOLUME_LEVEL_MIN = 0
uint8 VOLUME_LEVEL_DEFAULT = 40
uint8 VOLUME_LEVEL_MAX = 100

uint8 ORB_QUEUE_LENGTH = 3
"""
  # Pseudo-constants
  VOLUME_LEVEL_MIN = 0
  VOLUME_LEVEL_DEFAULT = 40
  VOLUME_LEVEL_MAX = 100
  ORB_QUEUE_LENGTH = 3

  __slots__ = ['timestamp','tune_id','tune_override','frequency','duration','silence','volume']
  _slot_types = ['uint64','uint8','uint8','uint16','uint32','uint32','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,tune_id,tune_override,frequency,duration,silence,volume

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TuneControl, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.tune_id is None:
        self.tune_id = 0
      if self.tune_override is None:
        self.tune_override = 0
      if self.frequency is None:
        self.frequency = 0
      if self.duration is None:
        self.duration = 0
      if self.silence is None:
        self.silence = 0
      if self.volume is None:
        self.volume = 0
    else:
      self.timestamp = 0
      self.tune_id = 0
      self.tune_override = 0
      self.frequency = 0
      self.duration = 0
      self.silence = 0
      self.volume = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q2BH2IB().pack(_x.timestamp, _x.tune_id, _x.tune_override, _x.frequency, _x.duration, _x.silence, _x.volume))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 21
      (_x.timestamp, _x.tune_id, _x.tune_override, _x.frequency, _x.duration, _x.silence, _x.volume,) = _get_struct_Q2BH2IB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q2BH2IB().pack(_x.timestamp, _x.tune_id, _x.tune_override, _x.frequency, _x.duration, _x.silence, _x.volume))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 21
      (_x.timestamp, _x.tune_id, _x.tune_override, _x.frequency, _x.duration, _x.silence, _x.volume,) = _get_struct_Q2BH2IB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q2BH2IB = None
def _get_struct_Q2BH2IB():
    global _struct_Q2BH2IB
    if _struct_Q2BH2IB is None:
        _struct_Q2BH2IB = struct.Struct("<Q2BH2IB")
    return _struct_Q2BH2IB
