# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/UavcanParameterValue.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class UavcanParameterValue(genpy.Message):
  _md5sum = "9f06fa71963b2fa7b270668d875741c7"
  _type = "px4_msgs/UavcanParameterValue"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# UAVCAN-MAVLink parameter bridge response type
uint64 timestamp		# time since system start (microseconds)
uint8 node_id			# UAVCAN node ID mapped from MAVLink component ID
char[17] param_id		# MAVLink/UAVCAN parameter name
int16 param_index		# parameter index, if known
uint16 param_count		# number of parameters exposed by the node
uint8 param_type		# MAVLink parameter type
int64 int_value			# current value if param_type is int-like
float32 real_value		# current value if param_type is float-like
"""
  __slots__ = ['timestamp','node_id','param_id','param_index','param_count','param_type','int_value','real_value']
  _slot_types = ['uint64','uint8','char[17]','int16','uint16','uint8','int64','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,node_id,param_id,param_index,param_count,param_type,int_value,real_value

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(UavcanParameterValue, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.node_id is None:
        self.node_id = 0
      if self.param_id is None:
        self.param_id = b'\0'*17
      if self.param_index is None:
        self.param_index = 0
      if self.param_count is None:
        self.param_count = 0
      if self.param_type is None:
        self.param_type = 0
      if self.int_value is None:
        self.int_value = 0
      if self.real_value is None:
        self.real_value = 0.
    else:
      self.timestamp = 0
      self.node_id = 0
      self.param_id = b'\0'*17
      self.param_index = 0
      self.param_count = 0
      self.param_type = 0
      self.int_value = 0
      self.real_value = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_QB().pack(_x.timestamp, _x.node_id))
      _x = self.param_id
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_17B().pack(*_x))
      else:
        buff.write(_get_struct_17s().pack(_x))
      _x = self
      buff.write(_get_struct_hHBqf().pack(_x.param_index, _x.param_count, _x.param_type, _x.int_value, _x.real_value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 9
      (_x.timestamp, _x.node_id,) = _get_struct_QB().unpack(str[start:end])
      start = end
      end += 17
      self.param_id = str[start:end]
      _x = self
      start = end
      end += 17
      (_x.param_index, _x.param_count, _x.param_type, _x.int_value, _x.real_value,) = _get_struct_hHBqf().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_QB().pack(_x.timestamp, _x.node_id))
      _x = self.param_id
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_17B().pack(*_x))
      else:
        buff.write(_get_struct_17s().pack(_x))
      _x = self
      buff.write(_get_struct_hHBqf().pack(_x.param_index, _x.param_count, _x.param_type, _x.int_value, _x.real_value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 9
      (_x.timestamp, _x.node_id,) = _get_struct_QB().unpack(str[start:end])
      start = end
      end += 17
      self.param_id = str[start:end]
      _x = self
      start = end
      end += 17
      (_x.param_index, _x.param_count, _x.param_type, _x.int_value, _x.real_value,) = _get_struct_hHBqf().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_17B = None
def _get_struct_17B():
    global _struct_17B
    if _struct_17B is None:
        _struct_17B = struct.Struct("<17B")
    return _struct_17B
_struct_17s = None
def _get_struct_17s():
    global _struct_17s
    if _struct_17s is None:
        _struct_17s = struct.Struct("<17s")
    return _struct_17s
_struct_QB = None
def _get_struct_QB():
    global _struct_QB
    if _struct_QB is None:
        _struct_QB = struct.Struct("<QB")
    return _struct_QB
_struct_hHBqf = None
def _get_struct_hHBqf():
    global _struct_hHBqf
    if _struct_hHBqf is None:
        _struct_hHBqf = struct.Struct("<hHBqf")
    return _struct_hHBqf
