# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/UlogStream.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class UlogStream(genpy.Message):
  _md5sum = "7c89b50fc4460224aa672064b6060ab9"
  _type = "px4_msgs/UlogStream"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Message to stream ULog data from the logger. Corresponds to the LOGGING_DATA
# mavlink message

uint64 timestamp		# time since system start (microseconds)

# flags bitmasks
uint8 FLAGS_NEED_ACK = 1	# if set, this message requires to be acked.
				# Acked messages are published synchronous: a
				# publisher waits for an ack before sending the
				# next message

uint8 length			# length of data
uint8 first_message_offset	# offset into data where first message starts. This
				# can be used for recovery, when a previous message got lost
uint16 msg_sequence		# allows determine drops
uint8 flags			# see FLAGS_*
uint8[249] data		# ulog data

uint8 ORB_QUEUE_LENGTH = 14	# TODO: we might be able to reduce this if mavlink polled on the topic
"""
  # Pseudo-constants
  FLAGS_NEED_ACK = 1
  ORB_QUEUE_LENGTH = 14

  __slots__ = ['timestamp','length','first_message_offset','msg_sequence','flags','data']
  _slot_types = ['uint64','uint8','uint8','uint16','uint8','uint8[249]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,length,first_message_offset,msg_sequence,flags,data

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(UlogStream, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.length is None:
        self.length = 0
      if self.first_message_offset is None:
        self.first_message_offset = 0
      if self.msg_sequence is None:
        self.msg_sequence = 0
      if self.flags is None:
        self.flags = 0
      if self.data is None:
        self.data = b'\0'*249
    else:
      self.timestamp = 0
      self.length = 0
      self.first_message_offset = 0
      self.msg_sequence = 0
      self.flags = 0
      self.data = b'\0'*249

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q2BHB().pack(_x.timestamp, _x.length, _x.first_message_offset, _x.msg_sequence, _x.flags))
      _x = self.data
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_249B().pack(*_x))
      else:
        buff.write(_get_struct_249s().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 13
      (_x.timestamp, _x.length, _x.first_message_offset, _x.msg_sequence, _x.flags,) = _get_struct_Q2BHB().unpack(str[start:end])
      start = end
      end += 249
      self.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q2BHB().pack(_x.timestamp, _x.length, _x.first_message_offset, _x.msg_sequence, _x.flags))
      _x = self.data
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_249B().pack(*_x))
      else:
        buff.write(_get_struct_249s().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 13
      (_x.timestamp, _x.length, _x.first_message_offset, _x.msg_sequence, _x.flags,) = _get_struct_Q2BHB().unpack(str[start:end])
      start = end
      end += 249
      self.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_249B = None
def _get_struct_249B():
    global _struct_249B
    if _struct_249B is None:
        _struct_249B = struct.Struct("<249B")
    return _struct_249B
_struct_249s = None
def _get_struct_249s():
    global _struct_249s
    if _struct_249s is None:
        _struct_249s = struct.Struct("<249s")
    return _struct_249s
_struct_Q2BHB = None
def _get_struct_Q2BHB():
    global _struct_Q2BHB
    if _struct_Q2BHB is None:
        _struct_Q2BHB = struct.Struct("<Q2BHB")
    return _struct_Q2BHB
