# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/VehicleConstraints.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class VehicleConstraints(genpy.Message):
  _md5sum = "5898702939e906fceaf8cd1860942ff7"
  _type = "px4_msgs/VehicleConstraints"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Local setpoint constraints in NED frame
# setting something to NaN means that no limit is provided

uint64 timestamp # time since system start (microseconds)

float32 yawspeed # in radians/sec
float32 speed_xy # in meters/sec
float32 speed_up # in meters/sec
float32 speed_down # in meters/sec
float32 tilt # in radians [0, PI]
float32 min_distance_to_ground # in meters
float32 max_distance_to_ground # in meters
bool want_takeoff # tell the controller to initiate takeoff when idling (ignored during flight)
"""
  __slots__ = ['timestamp','yawspeed','speed_xy','speed_up','speed_down','tilt','min_distance_to_ground','max_distance_to_ground','want_takeoff']
  _slot_types = ['uint64','float32','float32','float32','float32','float32','float32','float32','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,yawspeed,speed_xy,speed_up,speed_down,tilt,min_distance_to_ground,max_distance_to_ground,want_takeoff

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleConstraints, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.yawspeed is None:
        self.yawspeed = 0.
      if self.speed_xy is None:
        self.speed_xy = 0.
      if self.speed_up is None:
        self.speed_up = 0.
      if self.speed_down is None:
        self.speed_down = 0.
      if self.tilt is None:
        self.tilt = 0.
      if self.min_distance_to_ground is None:
        self.min_distance_to_ground = 0.
      if self.max_distance_to_ground is None:
        self.max_distance_to_ground = 0.
      if self.want_takeoff is None:
        self.want_takeoff = False
    else:
      self.timestamp = 0
      self.yawspeed = 0.
      self.speed_xy = 0.
      self.speed_up = 0.
      self.speed_down = 0.
      self.tilt = 0.
      self.min_distance_to_ground = 0.
      self.max_distance_to_ground = 0.
      self.want_takeoff = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q7fB().pack(_x.timestamp, _x.yawspeed, _x.speed_xy, _x.speed_up, _x.speed_down, _x.tilt, _x.min_distance_to_ground, _x.max_distance_to_ground, _x.want_takeoff))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 37
      (_x.timestamp, _x.yawspeed, _x.speed_xy, _x.speed_up, _x.speed_down, _x.tilt, _x.min_distance_to_ground, _x.max_distance_to_ground, _x.want_takeoff,) = _get_struct_Q7fB().unpack(str[start:end])
      self.want_takeoff = bool(self.want_takeoff)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q7fB().pack(_x.timestamp, _x.yawspeed, _x.speed_xy, _x.speed_up, _x.speed_down, _x.tilt, _x.min_distance_to_ground, _x.max_distance_to_ground, _x.want_takeoff))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 37
      (_x.timestamp, _x.yawspeed, _x.speed_xy, _x.speed_up, _x.speed_down, _x.tilt, _x.min_distance_to_ground, _x.max_distance_to_ground, _x.want_takeoff,) = _get_struct_Q7fB().unpack(str[start:end])
      self.want_takeoff = bool(self.want_takeoff)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q7fB = None
def _get_struct_Q7fB():
    global _struct_Q7fB
    if _struct_Q7fB is None:
        _struct_Q7fB = struct.Struct("<Q7fB")
    return _struct_Q7fB
