# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/VehicleGlobalPosition.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class VehicleGlobalPosition(genpy.Message):
  _md5sum = "84580f061cc35bb28602e4e1e8bd708e"
  _type = "px4_msgs/VehicleGlobalPosition"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Fused global position in WGS84.
# This struct contains global position estimation. It is not the raw GPS
# measurement (@see vehicle_gps_position). This topic is usually published by the position
# estimator, which will take more sources of information into account than just GPS,
# e.g. control inputs of the vehicle in a Kalman-filter implementation.
#

uint64 timestamp		# time since system start (microseconds)

float64 lat			# Latitude, (degrees)
float64 lon			# Longitude, (degrees)
float32 alt			# Altitude AMSL, (meters)
float32 alt_ellipsoid		# Altitude above ellipsoid, (meters)

float32 delta_alt 	# Reset delta for altitude
uint8 lat_lon_reset_counter	# Counter for reset events on horizontal position coordinates
uint8 alt_reset_counter 	# Counter for reset events on altitude

float32 vel_n			# North velocity in NED earth-fixed frame, (metres/sec)
float32 vel_e			# East velocity in NED earth-fixed frame, (metres/sec)
float32 vel_d			# Down velocity in NED earth-fixed frame, (metres/sec)

float32 yaw 			# Euler yaw angle relative to NED earth-fixed frame, -PI..+PI, (radians)

float32 eph			# Standard deviation of horizontal position error, (metres)
float32 epv			# Standard deviation of vertical position error, (metres)

float32 terrain_alt		# Terrain altitude WGS84, (metres)
bool terrain_alt_valid		# Terrain altitude estimate is valid

bool dead_reckoning		# True if this position is estimated through dead-reckoning

"""
  __slots__ = ['timestamp','lat','lon','alt','alt_ellipsoid','delta_alt','lat_lon_reset_counter','alt_reset_counter','vel_n','vel_e','vel_d','yaw','eph','epv','terrain_alt','terrain_alt_valid','dead_reckoning']
  _slot_types = ['uint64','float64','float64','float32','float32','float32','uint8','uint8','float32','float32','float32','float32','float32','float32','float32','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,lat,lon,alt,alt_ellipsoid,delta_alt,lat_lon_reset_counter,alt_reset_counter,vel_n,vel_e,vel_d,yaw,eph,epv,terrain_alt,terrain_alt_valid,dead_reckoning

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleGlobalPosition, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.lat is None:
        self.lat = 0.
      if self.lon is None:
        self.lon = 0.
      if self.alt is None:
        self.alt = 0.
      if self.alt_ellipsoid is None:
        self.alt_ellipsoid = 0.
      if self.delta_alt is None:
        self.delta_alt = 0.
      if self.lat_lon_reset_counter is None:
        self.lat_lon_reset_counter = 0
      if self.alt_reset_counter is None:
        self.alt_reset_counter = 0
      if self.vel_n is None:
        self.vel_n = 0.
      if self.vel_e is None:
        self.vel_e = 0.
      if self.vel_d is None:
        self.vel_d = 0.
      if self.yaw is None:
        self.yaw = 0.
      if self.eph is None:
        self.eph = 0.
      if self.epv is None:
        self.epv = 0.
      if self.terrain_alt is None:
        self.terrain_alt = 0.
      if self.terrain_alt_valid is None:
        self.terrain_alt_valid = False
      if self.dead_reckoning is None:
        self.dead_reckoning = False
    else:
      self.timestamp = 0
      self.lat = 0.
      self.lon = 0.
      self.alt = 0.
      self.alt_ellipsoid = 0.
      self.delta_alt = 0.
      self.lat_lon_reset_counter = 0
      self.alt_reset_counter = 0
      self.vel_n = 0.
      self.vel_e = 0.
      self.vel_d = 0.
      self.yaw = 0.
      self.eph = 0.
      self.epv = 0.
      self.terrain_alt = 0.
      self.terrain_alt_valid = False
      self.dead_reckoning = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q2d3f2B7f2B().pack(_x.timestamp, _x.lat, _x.lon, _x.alt, _x.alt_ellipsoid, _x.delta_alt, _x.lat_lon_reset_counter, _x.alt_reset_counter, _x.vel_n, _x.vel_e, _x.vel_d, _x.yaw, _x.eph, _x.epv, _x.terrain_alt, _x.terrain_alt_valid, _x.dead_reckoning))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 68
      (_x.timestamp, _x.lat, _x.lon, _x.alt, _x.alt_ellipsoid, _x.delta_alt, _x.lat_lon_reset_counter, _x.alt_reset_counter, _x.vel_n, _x.vel_e, _x.vel_d, _x.yaw, _x.eph, _x.epv, _x.terrain_alt, _x.terrain_alt_valid, _x.dead_reckoning,) = _get_struct_Q2d3f2B7f2B().unpack(str[start:end])
      self.terrain_alt_valid = bool(self.terrain_alt_valid)
      self.dead_reckoning = bool(self.dead_reckoning)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q2d3f2B7f2B().pack(_x.timestamp, _x.lat, _x.lon, _x.alt, _x.alt_ellipsoid, _x.delta_alt, _x.lat_lon_reset_counter, _x.alt_reset_counter, _x.vel_n, _x.vel_e, _x.vel_d, _x.yaw, _x.eph, _x.epv, _x.terrain_alt, _x.terrain_alt_valid, _x.dead_reckoning))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 68
      (_x.timestamp, _x.lat, _x.lon, _x.alt, _x.alt_ellipsoid, _x.delta_alt, _x.lat_lon_reset_counter, _x.alt_reset_counter, _x.vel_n, _x.vel_e, _x.vel_d, _x.yaw, _x.eph, _x.epv, _x.terrain_alt, _x.terrain_alt_valid, _x.dead_reckoning,) = _get_struct_Q2d3f2B7f2B().unpack(str[start:end])
      self.terrain_alt_valid = bool(self.terrain_alt_valid)
      self.dead_reckoning = bool(self.dead_reckoning)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q2d3f2B7f2B = None
def _get_struct_Q2d3f2B7f2B():
    global _struct_Q2d3f2B7f2B
    if _struct_Q2d3f2B7f2B is None:
        _struct_Q2d3f2B7f2B = struct.Struct("<Q2d3f2B7f2B")
    return _struct_Q2d3f2B7f2B
