# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/VehicleGpsPosition.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class VehicleGpsPosition(genpy.Message):
  _md5sum = "c2e4924970cfab82357b0dbacf64544c"
  _type = "px4_msgs/VehicleGpsPosition"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# GPS position in WGS84 coordinates.
# the field 'timestamp' is for the position & velocity (microseconds)
uint64 timestamp		# time since system start (microseconds)

int32 lat			# Latitude in 1E-7 degrees
int32 lon			# Longitude in 1E-7 degrees
int32 alt			# Altitude in 1E-3 meters above MSL, (millimetres)
int32 alt_ellipsoid 		# Altitude in 1E-3 meters bove Ellipsoid, (millimetres)

float32 s_variance_m_s		# GPS speed accuracy estimate, (metres/sec)
float32 c_variance_rad		# GPS course accuracy estimate, (radians)
uint8 fix_type # 0-1: no fix, 2: 2D fix, 3: 3D fix, 4: RTCM code differential, 5: Real-Time Kinematic, float, 6: Real-Time Kinematic, fixed, 8: Extrapolated. Some applications will not use the value of this field unless it is at least two, so always correctly fill in the fix.

float32 eph			# GPS horizontal position accuracy (metres)
float32 epv			# GPS vertical position accuracy (metres)

float32 hdop			# Horizontal dilution of precision
float32 vdop			# Vertical dilution of precision

int32 noise_per_ms		# GPS noise per millisecond
int32 jamming_indicator		# indicates jamming is occurring

float32 vel_m_s			# GPS ground speed, (metres/sec)
float32 vel_n_m_s		# GPS North velocity, (metres/sec)
float32 vel_e_m_s		# GPS East velocity, (metres/sec)
float32 vel_d_m_s		# GPS Down velocity, (metres/sec)
float32 cog_rad			# Course over ground (NOT heading, but direction of movement), -PI..PI, (radians)
bool vel_ned_valid		# True if NED velocity is valid

int32 timestamp_time_relative	# timestamp + timestamp_time_relative = Time of the UTC timestamp since system start, (microseconds)
uint64 time_utc_usec		# Timestamp (microseconds, UTC), this is the timestamp which comes from the gps module. It might be unavailable right after cold start, indicated by a value of 0

uint8 satellites_used		# Number of satellites used

float32 heading			# heading angle of XYZ body frame rel to NED. Set to NaN if not available and updated (used for dual antenna GPS), (rad, [-PI, PI])
float32 heading_offset		# heading offset of dual antenna array in body frame. Set to NaN if not applicable. (rad, [-PI, PI])
"""
  __slots__ = ['timestamp','lat','lon','alt','alt_ellipsoid','s_variance_m_s','c_variance_rad','fix_type','eph','epv','hdop','vdop','noise_per_ms','jamming_indicator','vel_m_s','vel_n_m_s','vel_e_m_s','vel_d_m_s','cog_rad','vel_ned_valid','timestamp_time_relative','time_utc_usec','satellites_used','heading','heading_offset']
  _slot_types = ['uint64','int32','int32','int32','int32','float32','float32','uint8','float32','float32','float32','float32','int32','int32','float32','float32','float32','float32','float32','bool','int32','uint64','uint8','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,lat,lon,alt,alt_ellipsoid,s_variance_m_s,c_variance_rad,fix_type,eph,epv,hdop,vdop,noise_per_ms,jamming_indicator,vel_m_s,vel_n_m_s,vel_e_m_s,vel_d_m_s,cog_rad,vel_ned_valid,timestamp_time_relative,time_utc_usec,satellites_used,heading,heading_offset

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleGpsPosition, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.lat is None:
        self.lat = 0
      if self.lon is None:
        self.lon = 0
      if self.alt is None:
        self.alt = 0
      if self.alt_ellipsoid is None:
        self.alt_ellipsoid = 0
      if self.s_variance_m_s is None:
        self.s_variance_m_s = 0.
      if self.c_variance_rad is None:
        self.c_variance_rad = 0.
      if self.fix_type is None:
        self.fix_type = 0
      if self.eph is None:
        self.eph = 0.
      if self.epv is None:
        self.epv = 0.
      if self.hdop is None:
        self.hdop = 0.
      if self.vdop is None:
        self.vdop = 0.
      if self.noise_per_ms is None:
        self.noise_per_ms = 0
      if self.jamming_indicator is None:
        self.jamming_indicator = 0
      if self.vel_m_s is None:
        self.vel_m_s = 0.
      if self.vel_n_m_s is None:
        self.vel_n_m_s = 0.
      if self.vel_e_m_s is None:
        self.vel_e_m_s = 0.
      if self.vel_d_m_s is None:
        self.vel_d_m_s = 0.
      if self.cog_rad is None:
        self.cog_rad = 0.
      if self.vel_ned_valid is None:
        self.vel_ned_valid = False
      if self.timestamp_time_relative is None:
        self.timestamp_time_relative = 0
      if self.time_utc_usec is None:
        self.time_utc_usec = 0
      if self.satellites_used is None:
        self.satellites_used = 0
      if self.heading is None:
        self.heading = 0.
      if self.heading_offset is None:
        self.heading_offset = 0.
    else:
      self.timestamp = 0
      self.lat = 0
      self.lon = 0
      self.alt = 0
      self.alt_ellipsoid = 0
      self.s_variance_m_s = 0.
      self.c_variance_rad = 0.
      self.fix_type = 0
      self.eph = 0.
      self.epv = 0.
      self.hdop = 0.
      self.vdop = 0.
      self.noise_per_ms = 0
      self.jamming_indicator = 0
      self.vel_m_s = 0.
      self.vel_n_m_s = 0.
      self.vel_e_m_s = 0.
      self.vel_d_m_s = 0.
      self.cog_rad = 0.
      self.vel_ned_valid = False
      self.timestamp_time_relative = 0
      self.time_utc_usec = 0
      self.satellites_used = 0
      self.heading = 0.
      self.heading_offset = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q4i2fB4f2i5fBiQB2f().pack(_x.timestamp, _x.lat, _x.lon, _x.alt, _x.alt_ellipsoid, _x.s_variance_m_s, _x.c_variance_rad, _x.fix_type, _x.eph, _x.epv, _x.hdop, _x.vdop, _x.noise_per_ms, _x.jamming_indicator, _x.vel_m_s, _x.vel_n_m_s, _x.vel_e_m_s, _x.vel_d_m_s, _x.cog_rad, _x.vel_ned_valid, _x.timestamp_time_relative, _x.time_utc_usec, _x.satellites_used, _x.heading, _x.heading_offset))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 99
      (_x.timestamp, _x.lat, _x.lon, _x.alt, _x.alt_ellipsoid, _x.s_variance_m_s, _x.c_variance_rad, _x.fix_type, _x.eph, _x.epv, _x.hdop, _x.vdop, _x.noise_per_ms, _x.jamming_indicator, _x.vel_m_s, _x.vel_n_m_s, _x.vel_e_m_s, _x.vel_d_m_s, _x.cog_rad, _x.vel_ned_valid, _x.timestamp_time_relative, _x.time_utc_usec, _x.satellites_used, _x.heading, _x.heading_offset,) = _get_struct_Q4i2fB4f2i5fBiQB2f().unpack(str[start:end])
      self.vel_ned_valid = bool(self.vel_ned_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q4i2fB4f2i5fBiQB2f().pack(_x.timestamp, _x.lat, _x.lon, _x.alt, _x.alt_ellipsoid, _x.s_variance_m_s, _x.c_variance_rad, _x.fix_type, _x.eph, _x.epv, _x.hdop, _x.vdop, _x.noise_per_ms, _x.jamming_indicator, _x.vel_m_s, _x.vel_n_m_s, _x.vel_e_m_s, _x.vel_d_m_s, _x.cog_rad, _x.vel_ned_valid, _x.timestamp_time_relative, _x.time_utc_usec, _x.satellites_used, _x.heading, _x.heading_offset))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 99
      (_x.timestamp, _x.lat, _x.lon, _x.alt, _x.alt_ellipsoid, _x.s_variance_m_s, _x.c_variance_rad, _x.fix_type, _x.eph, _x.epv, _x.hdop, _x.vdop, _x.noise_per_ms, _x.jamming_indicator, _x.vel_m_s, _x.vel_n_m_s, _x.vel_e_m_s, _x.vel_d_m_s, _x.cog_rad, _x.vel_ned_valid, _x.timestamp_time_relative, _x.time_utc_usec, _x.satellites_used, _x.heading, _x.heading_offset,) = _get_struct_Q4i2fB4f2i5fBiQB2f().unpack(str[start:end])
      self.vel_ned_valid = bool(self.vel_ned_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q4i2fB4f2i5fBiQB2f = None
def _get_struct_Q4i2fB4f2i5fBiQB2f():
    global _struct_Q4i2fB4f2i5fBiQB2f
    if _struct_Q4i2fB4f2i5fBiQB2f is None:
        _struct_Q4i2fB4f2i5fBiQB2f = struct.Struct("<Q4i2fB4f2i5fBiQB2f")
    return _struct_Q4i2fB4f2i5fBiQB2f
