# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/VehicleLandDetected.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class VehicleLandDetected(genpy.Message):
  _md5sum = "68da2236c49d8b65da510a94cde146a8"
  _type = "px4_msgs/VehicleLandDetected"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp	# time since system start (microseconds)
float32 alt_max 	# maximum altitude in [m] that can be reached
bool freefall		# true if vehicle is currently in free-fall
bool ground_contact	# true if vehicle has ground contact but is not landed (1. stage)
bool maybe_landed	# true if the vehicle might have landed (2. stage)
bool landed		# true if vehicle is currently landed on the ground (3. stage)
bool in_ground_effect # indicates if from the perspective of the landing detector the vehicle might be in ground effect (baro). This flag will become true if the vehicle is not moving horizontally and is descending (crude assumption that user is landing).
"""
  __slots__ = ['timestamp','alt_max','freefall','ground_contact','maybe_landed','landed','in_ground_effect']
  _slot_types = ['uint64','float32','bool','bool','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,alt_max,freefall,ground_contact,maybe_landed,landed,in_ground_effect

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleLandDetected, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.alt_max is None:
        self.alt_max = 0.
      if self.freefall is None:
        self.freefall = False
      if self.ground_contact is None:
        self.ground_contact = False
      if self.maybe_landed is None:
        self.maybe_landed = False
      if self.landed is None:
        self.landed = False
      if self.in_ground_effect is None:
        self.in_ground_effect = False
    else:
      self.timestamp = 0
      self.alt_max = 0.
      self.freefall = False
      self.ground_contact = False
      self.maybe_landed = False
      self.landed = False
      self.in_ground_effect = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Qf5B().pack(_x.timestamp, _x.alt_max, _x.freefall, _x.ground_contact, _x.maybe_landed, _x.landed, _x.in_ground_effect))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 17
      (_x.timestamp, _x.alt_max, _x.freefall, _x.ground_contact, _x.maybe_landed, _x.landed, _x.in_ground_effect,) = _get_struct_Qf5B().unpack(str[start:end])
      self.freefall = bool(self.freefall)
      self.ground_contact = bool(self.ground_contact)
      self.maybe_landed = bool(self.maybe_landed)
      self.landed = bool(self.landed)
      self.in_ground_effect = bool(self.in_ground_effect)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Qf5B().pack(_x.timestamp, _x.alt_max, _x.freefall, _x.ground_contact, _x.maybe_landed, _x.landed, _x.in_ground_effect))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 17
      (_x.timestamp, _x.alt_max, _x.freefall, _x.ground_contact, _x.maybe_landed, _x.landed, _x.in_ground_effect,) = _get_struct_Qf5B().unpack(str[start:end])
      self.freefall = bool(self.freefall)
      self.ground_contact = bool(self.ground_contact)
      self.maybe_landed = bool(self.maybe_landed)
      self.landed = bool(self.landed)
      self.in_ground_effect = bool(self.in_ground_effect)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Qf5B = None
def _get_struct_Qf5B():
    global _struct_Qf5B
    if _struct_Qf5B is None:
        _struct_Qf5B = struct.Struct("<Qf5B")
    return _struct_Qf5B
