# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/VehicleLocalPosition.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class VehicleLocalPosition(genpy.Message):
  _md5sum = "abc6033a9a022cafd2ca4ce7e9a3d5ca"
  _type = "px4_msgs/VehicleLocalPosition"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Fused local position in NED.

uint64 timestamp			# time since system start (microseconds)

bool xy_valid				# true if x and y are valid
bool z_valid				# true if z is valid
bool v_xy_valid				# true if vy and vy are valid
bool v_z_valid				# true if vz is valid

# Position in local NED frame
float32 x				# North position in NED earth-fixed frame, (metres)
float32 y				# East position in NED earth-fixed frame, (metres)
float32 z				# Down position (negative altitude) in NED earth-fixed frame, (metres)

# Position reset delta
float32[2] delta_xy
uint8 xy_reset_counter

float32 delta_z
uint8 z_reset_counter

# Velocity in NED frame
float32 vx 				# North velocity in NED earth-fixed frame, (metres/sec)
float32 vy				# East velocity in NED earth-fixed frame, (metres/sec)
float32 vz				# Down velocity in NED earth-fixed frame, (metres/sec)
float32 z_deriv				# Down position time derivative in NED earth-fixed frame, (metres/sec)

# Velocity reset delta
float32[2] delta_vxy
uint8 vxy_reset_counter

float32 delta_vz
uint8 vz_reset_counter
# Acceleration in NED frame
float32 ax        # North velocity derivative in NED earth-fixed frame, (metres/sec^2)
float32 ay        # East velocity derivative in NED earth-fixed frame, (metres/sec^2)
float32 az        # Down velocity derivative in NED earth-fixed frame, (metres/sec^2)

# Heading
float32 yaw				# Euler yaw angle transforming the tangent plane relative to NED earth-fixed frame, -PI..+PI,  (radians)

# Position of reference point (local NED frame origin) in global (GPS / WGS84) frame
bool xy_global				# true if position (x, y) has a valid global reference (ref_lat, ref_lon)
bool z_global				# true if z has a valid global reference (ref_alt)
uint64 ref_timestamp			# Time when reference position was set since system start, (microseconds)
float64 ref_lat				# Reference point latitude, (degrees)
float64 ref_lon				# Reference point longitude, (degrees)
float32 ref_alt				# Reference altitude AMSL, (metres)

# Distance to surface
float32 dist_bottom			# Distance from from bottom surface to ground, (metres)
float32 dist_bottom_rate		# Rate of change of distance from bottom surface to ground, (metres/sec)
bool dist_bottom_valid			# true if distance to bottom surface is valid

float32 eph				# Standard deviation of horizontal position error, (metres)
float32 epv				# Standard deviation of vertical position error, (metres)
float32 evh				# Standard deviation of horizontal velocity error, (metres/sec)
float32 evv				# Standard deviation of horizontal velocity error, (metres/sec)

# estimator specified vehicle limits
float32 vxy_max				# maximum horizontal speed - set to 0 when limiting not required (meters/sec)
float32 vz_max				# maximum vertical speed - set to 0 when limiting not required (meters/sec)
float32 hagl_min			# minimum height above ground level - set to 0 when limiting not required (meters)
float32 hagl_max			# maximum height above ground level - set to 0 when limiting not required (meters)

"""
  __slots__ = ['timestamp','xy_valid','z_valid','v_xy_valid','v_z_valid','x','y','z','delta_xy','xy_reset_counter','delta_z','z_reset_counter','vx','vy','vz','z_deriv','delta_vxy','vxy_reset_counter','delta_vz','vz_reset_counter','ax','ay','az','yaw','xy_global','z_global','ref_timestamp','ref_lat','ref_lon','ref_alt','dist_bottom','dist_bottom_rate','dist_bottom_valid','eph','epv','evh','evv','vxy_max','vz_max','hagl_min','hagl_max']
  _slot_types = ['uint64','bool','bool','bool','bool','float32','float32','float32','float32[2]','uint8','float32','uint8','float32','float32','float32','float32','float32[2]','uint8','float32','uint8','float32','float32','float32','float32','bool','bool','uint64','float64','float64','float32','float32','float32','bool','float32','float32','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,xy_valid,z_valid,v_xy_valid,v_z_valid,x,y,z,delta_xy,xy_reset_counter,delta_z,z_reset_counter,vx,vy,vz,z_deriv,delta_vxy,vxy_reset_counter,delta_vz,vz_reset_counter,ax,ay,az,yaw,xy_global,z_global,ref_timestamp,ref_lat,ref_lon,ref_alt,dist_bottom,dist_bottom_rate,dist_bottom_valid,eph,epv,evh,evv,vxy_max,vz_max,hagl_min,hagl_max

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleLocalPosition, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.xy_valid is None:
        self.xy_valid = False
      if self.z_valid is None:
        self.z_valid = False
      if self.v_xy_valid is None:
        self.v_xy_valid = False
      if self.v_z_valid is None:
        self.v_z_valid = False
      if self.x is None:
        self.x = 0.
      if self.y is None:
        self.y = 0.
      if self.z is None:
        self.z = 0.
      if self.delta_xy is None:
        self.delta_xy = [0.] * 2
      if self.xy_reset_counter is None:
        self.xy_reset_counter = 0
      if self.delta_z is None:
        self.delta_z = 0.
      if self.z_reset_counter is None:
        self.z_reset_counter = 0
      if self.vx is None:
        self.vx = 0.
      if self.vy is None:
        self.vy = 0.
      if self.vz is None:
        self.vz = 0.
      if self.z_deriv is None:
        self.z_deriv = 0.
      if self.delta_vxy is None:
        self.delta_vxy = [0.] * 2
      if self.vxy_reset_counter is None:
        self.vxy_reset_counter = 0
      if self.delta_vz is None:
        self.delta_vz = 0.
      if self.vz_reset_counter is None:
        self.vz_reset_counter = 0
      if self.ax is None:
        self.ax = 0.
      if self.ay is None:
        self.ay = 0.
      if self.az is None:
        self.az = 0.
      if self.yaw is None:
        self.yaw = 0.
      if self.xy_global is None:
        self.xy_global = False
      if self.z_global is None:
        self.z_global = False
      if self.ref_timestamp is None:
        self.ref_timestamp = 0
      if self.ref_lat is None:
        self.ref_lat = 0.
      if self.ref_lon is None:
        self.ref_lon = 0.
      if self.ref_alt is None:
        self.ref_alt = 0.
      if self.dist_bottom is None:
        self.dist_bottom = 0.
      if self.dist_bottom_rate is None:
        self.dist_bottom_rate = 0.
      if self.dist_bottom_valid is None:
        self.dist_bottom_valid = False
      if self.eph is None:
        self.eph = 0.
      if self.epv is None:
        self.epv = 0.
      if self.evh is None:
        self.evh = 0.
      if self.evv is None:
        self.evv = 0.
      if self.vxy_max is None:
        self.vxy_max = 0.
      if self.vz_max is None:
        self.vz_max = 0.
      if self.hagl_min is None:
        self.hagl_min = 0.
      if self.hagl_max is None:
        self.hagl_max = 0.
    else:
      self.timestamp = 0
      self.xy_valid = False
      self.z_valid = False
      self.v_xy_valid = False
      self.v_z_valid = False
      self.x = 0.
      self.y = 0.
      self.z = 0.
      self.delta_xy = [0.] * 2
      self.xy_reset_counter = 0
      self.delta_z = 0.
      self.z_reset_counter = 0
      self.vx = 0.
      self.vy = 0.
      self.vz = 0.
      self.z_deriv = 0.
      self.delta_vxy = [0.] * 2
      self.vxy_reset_counter = 0
      self.delta_vz = 0.
      self.vz_reset_counter = 0
      self.ax = 0.
      self.ay = 0.
      self.az = 0.
      self.yaw = 0.
      self.xy_global = False
      self.z_global = False
      self.ref_timestamp = 0
      self.ref_lat = 0.
      self.ref_lon = 0.
      self.ref_alt = 0.
      self.dist_bottom = 0.
      self.dist_bottom_rate = 0.
      self.dist_bottom_valid = False
      self.eph = 0.
      self.epv = 0.
      self.evh = 0.
      self.evv = 0.
      self.vxy_max = 0.
      self.vz_max = 0.
      self.hagl_min = 0.
      self.hagl_max = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q4B3f().pack(_x.timestamp, _x.xy_valid, _x.z_valid, _x.v_xy_valid, _x.v_z_valid, _x.x, _x.y, _x.z))
      buff.write(_get_struct_2f().pack(*self.delta_xy))
      _x = self
      buff.write(_get_struct_BfB4f().pack(_x.xy_reset_counter, _x.delta_z, _x.z_reset_counter, _x.vx, _x.vy, _x.vz, _x.z_deriv))
      buff.write(_get_struct_2f().pack(*self.delta_vxy))
      _x = self
      buff.write(_get_struct_BfB4f2BQ2d3fB8f().pack(_x.vxy_reset_counter, _x.delta_vz, _x.vz_reset_counter, _x.ax, _x.ay, _x.az, _x.yaw, _x.xy_global, _x.z_global, _x.ref_timestamp, _x.ref_lat, _x.ref_lon, _x.ref_alt, _x.dist_bottom, _x.dist_bottom_rate, _x.dist_bottom_valid, _x.eph, _x.epv, _x.evh, _x.evv, _x.vxy_max, _x.vz_max, _x.hagl_min, _x.hagl_max))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 24
      (_x.timestamp, _x.xy_valid, _x.z_valid, _x.v_xy_valid, _x.v_z_valid, _x.x, _x.y, _x.z,) = _get_struct_Q4B3f().unpack(str[start:end])
      self.xy_valid = bool(self.xy_valid)
      self.z_valid = bool(self.z_valid)
      self.v_xy_valid = bool(self.v_xy_valid)
      self.v_z_valid = bool(self.v_z_valid)
      start = end
      end += 8
      self.delta_xy = _get_struct_2f().unpack(str[start:end])
      _x = self
      start = end
      end += 22
      (_x.xy_reset_counter, _x.delta_z, _x.z_reset_counter, _x.vx, _x.vy, _x.vz, _x.z_deriv,) = _get_struct_BfB4f().unpack(str[start:end])
      start = end
      end += 8
      self.delta_vxy = _get_struct_2f().unpack(str[start:end])
      _x = self
      start = end
      end += 93
      (_x.vxy_reset_counter, _x.delta_vz, _x.vz_reset_counter, _x.ax, _x.ay, _x.az, _x.yaw, _x.xy_global, _x.z_global, _x.ref_timestamp, _x.ref_lat, _x.ref_lon, _x.ref_alt, _x.dist_bottom, _x.dist_bottom_rate, _x.dist_bottom_valid, _x.eph, _x.epv, _x.evh, _x.evv, _x.vxy_max, _x.vz_max, _x.hagl_min, _x.hagl_max,) = _get_struct_BfB4f2BQ2d3fB8f().unpack(str[start:end])
      self.xy_global = bool(self.xy_global)
      self.z_global = bool(self.z_global)
      self.dist_bottom_valid = bool(self.dist_bottom_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q4B3f().pack(_x.timestamp, _x.xy_valid, _x.z_valid, _x.v_xy_valid, _x.v_z_valid, _x.x, _x.y, _x.z))
      buff.write(self.delta_xy.tostring())
      _x = self
      buff.write(_get_struct_BfB4f().pack(_x.xy_reset_counter, _x.delta_z, _x.z_reset_counter, _x.vx, _x.vy, _x.vz, _x.z_deriv))
      buff.write(self.delta_vxy.tostring())
      _x = self
      buff.write(_get_struct_BfB4f2BQ2d3fB8f().pack(_x.vxy_reset_counter, _x.delta_vz, _x.vz_reset_counter, _x.ax, _x.ay, _x.az, _x.yaw, _x.xy_global, _x.z_global, _x.ref_timestamp, _x.ref_lat, _x.ref_lon, _x.ref_alt, _x.dist_bottom, _x.dist_bottom_rate, _x.dist_bottom_valid, _x.eph, _x.epv, _x.evh, _x.evv, _x.vxy_max, _x.vz_max, _x.hagl_min, _x.hagl_max))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 24
      (_x.timestamp, _x.xy_valid, _x.z_valid, _x.v_xy_valid, _x.v_z_valid, _x.x, _x.y, _x.z,) = _get_struct_Q4B3f().unpack(str[start:end])
      self.xy_valid = bool(self.xy_valid)
      self.z_valid = bool(self.z_valid)
      self.v_xy_valid = bool(self.v_xy_valid)
      self.v_z_valid = bool(self.v_z_valid)
      start = end
      end += 8
      self.delta_xy = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=2)
      _x = self
      start = end
      end += 22
      (_x.xy_reset_counter, _x.delta_z, _x.z_reset_counter, _x.vx, _x.vy, _x.vz, _x.z_deriv,) = _get_struct_BfB4f().unpack(str[start:end])
      start = end
      end += 8
      self.delta_vxy = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=2)
      _x = self
      start = end
      end += 93
      (_x.vxy_reset_counter, _x.delta_vz, _x.vz_reset_counter, _x.ax, _x.ay, _x.az, _x.yaw, _x.xy_global, _x.z_global, _x.ref_timestamp, _x.ref_lat, _x.ref_lon, _x.ref_alt, _x.dist_bottom, _x.dist_bottom_rate, _x.dist_bottom_valid, _x.eph, _x.epv, _x.evh, _x.evv, _x.vxy_max, _x.vz_max, _x.hagl_min, _x.hagl_max,) = _get_struct_BfB4f2BQ2d3fB8f().unpack(str[start:end])
      self.xy_global = bool(self.xy_global)
      self.z_global = bool(self.z_global)
      self.dist_bottom_valid = bool(self.dist_bottom_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2f = None
def _get_struct_2f():
    global _struct_2f
    if _struct_2f is None:
        _struct_2f = struct.Struct("<2f")
    return _struct_2f
_struct_BfB4f = None
def _get_struct_BfB4f():
    global _struct_BfB4f
    if _struct_BfB4f is None:
        _struct_BfB4f = struct.Struct("<BfB4f")
    return _struct_BfB4f
_struct_BfB4f2BQ2d3fB8f = None
def _get_struct_BfB4f2BQ2d3fB8f():
    global _struct_BfB4f2BQ2d3fB8f
    if _struct_BfB4f2BQ2d3fB8f is None:
        _struct_BfB4f2BQ2d3fB8f = struct.Struct("<BfB4f2BQ2d3fB8f")
    return _struct_BfB4f2BQ2d3fB8f
_struct_Q4B3f = None
def _get_struct_Q4B3f():
    global _struct_Q4B3f
    if _struct_Q4B3f is None:
        _struct_Q4B3f = struct.Struct("<Q4B3f")
    return _struct_Q4B3f
