# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/VehicleRoi.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class VehicleRoi(genpy.Message):
  _md5sum = "53b0d3b229ff0371c88ee39354cf251b"
  _type = "px4_msgs/VehicleRoi"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Vehicle Region Of Interest (ROI)

uint64 timestamp			# time since system start (microseconds)

uint8 ROI_NONE = 0			# No region of interest
uint8 ROI_WPNEXT = 1			# Point toward next MISSION with optional offset
uint8 ROI_WPINDEX = 2			# Point toward given MISSION
uint8 ROI_LOCATION = 3			# Point toward fixed location
uint8 ROI_TARGET = 4			# Point toward target
uint8 ROI_ENUM_END = 5

uint8 mode          # ROI mode (see above)

float64 lat			    # Latitude to point to
float64 lon			    # Longitude to point to
float32 alt			    # Altitude to point to

# additional angle offsets to next waypoint (only used with ROI_WPNEXT)
float32 roll_offset		# angle offset in rad
float32 pitch_offset		# angle offset in rad
float32 yaw_offset		# angle offset in rad
"""
  # Pseudo-constants
  ROI_NONE = 0
  ROI_WPNEXT = 1
  ROI_WPINDEX = 2
  ROI_LOCATION = 3
  ROI_TARGET = 4
  ROI_ENUM_END = 5

  __slots__ = ['timestamp','mode','lat','lon','alt','roll_offset','pitch_offset','yaw_offset']
  _slot_types = ['uint64','uint8','float64','float64','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,mode,lat,lon,alt,roll_offset,pitch_offset,yaw_offset

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleRoi, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.mode is None:
        self.mode = 0
      if self.lat is None:
        self.lat = 0.
      if self.lon is None:
        self.lon = 0.
      if self.alt is None:
        self.alt = 0.
      if self.roll_offset is None:
        self.roll_offset = 0.
      if self.pitch_offset is None:
        self.pitch_offset = 0.
      if self.yaw_offset is None:
        self.yaw_offset = 0.
    else:
      self.timestamp = 0
      self.mode = 0
      self.lat = 0.
      self.lon = 0.
      self.alt = 0.
      self.roll_offset = 0.
      self.pitch_offset = 0.
      self.yaw_offset = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_QB2d4f().pack(_x.timestamp, _x.mode, _x.lat, _x.lon, _x.alt, _x.roll_offset, _x.pitch_offset, _x.yaw_offset))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 41
      (_x.timestamp, _x.mode, _x.lat, _x.lon, _x.alt, _x.roll_offset, _x.pitch_offset, _x.yaw_offset,) = _get_struct_QB2d4f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_QB2d4f().pack(_x.timestamp, _x.mode, _x.lat, _x.lon, _x.alt, _x.roll_offset, _x.pitch_offset, _x.yaw_offset))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 41
      (_x.timestamp, _x.mode, _x.lat, _x.lon, _x.alt, _x.roll_offset, _x.pitch_offset, _x.yaw_offset,) = _get_struct_QB2d4f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_QB2d4f = None
def _get_struct_QB2d4f():
    global _struct_QB2d4f
    if _struct_QB2d4f is None:
        _struct_QB2d4f = struct.Struct("<QB2d4f")
    return _struct_QB2d4f
