# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/VehicleStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class VehicleStatus(genpy.Message):
  _md5sum = "176675ae7b16bac3b755691665078d11"
  _type = "px4_msgs/VehicleStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# If you change the order, add or remove arming_state_t states make sure to update the arrays
# in state_machine_helper.cpp as well.
uint64 timestamp				# time since system start (microseconds)

uint8 ARMING_STATE_INIT = 0
uint8 ARMING_STATE_STANDBY = 1
uint8 ARMING_STATE_ARMED = 2
uint8 ARMING_STATE_STANDBY_ERROR = 3
uint8 ARMING_STATE_SHUTDOWN = 4
uint8 ARMING_STATE_IN_AIR_RESTORE = 5
uint8 ARMING_STATE_MAX = 6

# FailureDetector status
uint8 FAILURE_NONE = 0
uint8 FAILURE_ROLL = 1 	# (1 << 0)
uint8 FAILURE_PITCH = 2	# (1 << 1)
uint8 FAILURE_ALT = 4 	# (1 << 2)

# HIL
uint8 HIL_STATE_OFF = 0
uint8 HIL_STATE_ON = 1

# Navigation state, i.e. "what should vehicle do".
uint8 NAVIGATION_STATE_MANUAL = 0		# Manual mode
uint8 NAVIGATION_STATE_ALTCTL = 1		# Altitude control mode
uint8 NAVIGATION_STATE_POSCTL = 2		# Position control mode
uint8 NAVIGATION_STATE_AUTO_MISSION = 3		# Auto mission mode
uint8 NAVIGATION_STATE_AUTO_LOITER = 4		# Auto loiter mode
uint8 NAVIGATION_STATE_AUTO_RTL = 5		# Auto return to launch mode
uint8 NAVIGATION_STATE_AUTO_RCRECOVER = 6	# RC recover mode
uint8 NAVIGATION_STATE_AUTO_RTGS = 7		# Auto return to groundstation on data link loss
uint8 NAVIGATION_STATE_AUTO_LANDENGFAIL = 8 	# Auto land on engine failure
uint8 NAVIGATION_STATE_AUTO_LANDGPSFAIL = 9	# Auto land on gps failure (e.g. open loop loiter down)
uint8 NAVIGATION_STATE_ACRO = 10		# Acro mode
uint8 NAVIGATION_STATE_UNUSED = 11		# Free slot
uint8 NAVIGATION_STATE_DESCEND = 12		# Descend mode (no position control)
uint8 NAVIGATION_STATE_TERMINATION = 13		# Termination mode
uint8 NAVIGATION_STATE_OFFBOARD = 14
uint8 NAVIGATION_STATE_STAB = 15		# Stabilized mode
uint8 NAVIGATION_STATE_RATTITUDE = 16		# Rattitude (aka "flip") mode
uint8 NAVIGATION_STATE_AUTO_TAKEOFF = 17	# Takeoff
uint8 NAVIGATION_STATE_AUTO_LAND = 18		# Land
uint8 NAVIGATION_STATE_AUTO_FOLLOW_TARGET = 19	# Auto Follow
uint8 NAVIGATION_STATE_AUTO_PRECLAND = 20	# Precision land with landing target
uint8 NAVIGATION_STATE_ORBIT = 21       # Orbit in a circle
uint8 NAVIGATION_STATE_MAX = 22

uint8 RC_IN_MODE_DEFAULT = 0
uint8 RC_IN_MODE_OFF = 1
uint8 RC_IN_MODE_GENERATED = 2

uint8 VEHICLE_TYPE_UNKNOWN = 0
uint8 VEHICLE_TYPE_ROTARY_WING = 1
uint8 VEHICLE_TYPE_FIXED_WING = 2
uint8 VEHICLE_TYPE_ROVER = 3

# state machine / state of vehicle.
# Encodes the complete system state and is set by the commander app.

uint8 nav_state				# set navigation state machine to specified value
uint8 arming_state			# current arming state
uint8 hil_state				# current hil state
bool failsafe				# true if system is in failsafe state (e.g.:RTL, Hover, Terminate, ...)

uint8 system_type			# system type, contains mavlink MAV_TYPE
uint8 system_id			# system id, contains MAVLink's system ID field
uint8 component_id			# subsystem / component id, contains MAVLink's component ID field

uint8 vehicle_type          # Type of vehicle (fixed-wing, rotary wing, ground)
                            # If the vehicle is a VTOL, then this value will be VEHICLE_TYPE_ROTARY_WING while flying as a multicopter,
                            # and VEHICLE_TYPE_FIXED_WING when flying as a fixed-wing

bool is_vtol				# True if the system is VTOL capable
bool vtol_fw_permanent_stab		# True if VTOL should stabilize attitude for fw in manual mode
bool in_transition_mode			# True if VTOL is doing a transition
bool in_transition_to_fw		# True if VTOL is doing a transition from MC to FW

bool rc_signal_lost				# true if RC reception lost
uint8 rc_input_mode				# set to 1 to disable the RC input, 2 to enable manual control to RC in mapping.

bool data_link_lost				# datalink to GCS lost
uint8 data_link_lost_counter			# counts unique data link lost events

bool high_latency_data_link_lost 			# Set to true if the high latency data link (eg. RockBlock Iridium 9603 telemetry module) is lost

bool engine_failure				# Set to true if an engine failure is detected
bool mission_failure				# Set to true if mission could not continue/finish

uint8 failure_detector_status			# Bitmask containing FailureDetector status [0, 0, 0, 0, 0, FAILURE_ALT, FAILURE_PITCH, FAILURE_ROLL]

# see SYS_STATUS mavlink message for the following
uint32 onboard_control_sensors_present
uint32 onboard_control_sensors_enabled
uint32 onboard_control_sensors_health

# airspeed fault and airspeed use status
float32 arspd_check_level	# integrated airspeed inconsistency as checked against the COM_TAS_FS_INTEG parameter
bool aspd_check_failing		# true when airspeed consistency checks are failing
bool aspd_fault_declared	# true when an airspeed fault has been declared
bool aspd_use_inhibit		# true if switching to a non-airspeed control mode has been requested
bool aspd_fail_rtl		# true if airspeed failure invoked RTL has been requested
float32 load_factor_ratio	# ratio of measured to aerodynamic load factor limit. Greater than 1 indicates airspeed low error condition.
"""
  # Pseudo-constants
  ARMING_STATE_INIT = 0
  ARMING_STATE_STANDBY = 1
  ARMING_STATE_ARMED = 2
  ARMING_STATE_STANDBY_ERROR = 3
  ARMING_STATE_SHUTDOWN = 4
  ARMING_STATE_IN_AIR_RESTORE = 5
  ARMING_STATE_MAX = 6
  FAILURE_NONE = 0
  FAILURE_ROLL = 1
  FAILURE_PITCH = 2
  FAILURE_ALT = 4
  HIL_STATE_OFF = 0
  HIL_STATE_ON = 1
  NAVIGATION_STATE_MANUAL = 0
  NAVIGATION_STATE_ALTCTL = 1
  NAVIGATION_STATE_POSCTL = 2
  NAVIGATION_STATE_AUTO_MISSION = 3
  NAVIGATION_STATE_AUTO_LOITER = 4
  NAVIGATION_STATE_AUTO_RTL = 5
  NAVIGATION_STATE_AUTO_RCRECOVER = 6
  NAVIGATION_STATE_AUTO_RTGS = 7
  NAVIGATION_STATE_AUTO_LANDENGFAIL = 8
  NAVIGATION_STATE_AUTO_LANDGPSFAIL = 9
  NAVIGATION_STATE_ACRO = 10
  NAVIGATION_STATE_UNUSED = 11
  NAVIGATION_STATE_DESCEND = 12
  NAVIGATION_STATE_TERMINATION = 13
  NAVIGATION_STATE_OFFBOARD = 14
  NAVIGATION_STATE_STAB = 15
  NAVIGATION_STATE_RATTITUDE = 16
  NAVIGATION_STATE_AUTO_TAKEOFF = 17
  NAVIGATION_STATE_AUTO_LAND = 18
  NAVIGATION_STATE_AUTO_FOLLOW_TARGET = 19
  NAVIGATION_STATE_AUTO_PRECLAND = 20
  NAVIGATION_STATE_ORBIT = 21
  NAVIGATION_STATE_MAX = 22
  RC_IN_MODE_DEFAULT = 0
  RC_IN_MODE_OFF = 1
  RC_IN_MODE_GENERATED = 2
  VEHICLE_TYPE_UNKNOWN = 0
  VEHICLE_TYPE_ROTARY_WING = 1
  VEHICLE_TYPE_FIXED_WING = 2
  VEHICLE_TYPE_ROVER = 3

  __slots__ = ['timestamp','nav_state','arming_state','hil_state','failsafe','system_type','system_id','component_id','vehicle_type','is_vtol','vtol_fw_permanent_stab','in_transition_mode','in_transition_to_fw','rc_signal_lost','rc_input_mode','data_link_lost','data_link_lost_counter','high_latency_data_link_lost','engine_failure','mission_failure','failure_detector_status','onboard_control_sensors_present','onboard_control_sensors_enabled','onboard_control_sensors_health','arspd_check_level','aspd_check_failing','aspd_fault_declared','aspd_use_inhibit','aspd_fail_rtl','load_factor_ratio']
  _slot_types = ['uint64','uint8','uint8','uint8','bool','uint8','uint8','uint8','uint8','bool','bool','bool','bool','bool','uint8','bool','uint8','bool','bool','bool','uint8','uint32','uint32','uint32','float32','bool','bool','bool','bool','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,nav_state,arming_state,hil_state,failsafe,system_type,system_id,component_id,vehicle_type,is_vtol,vtol_fw_permanent_stab,in_transition_mode,in_transition_to_fw,rc_signal_lost,rc_input_mode,data_link_lost,data_link_lost_counter,high_latency_data_link_lost,engine_failure,mission_failure,failure_detector_status,onboard_control_sensors_present,onboard_control_sensors_enabled,onboard_control_sensors_health,arspd_check_level,aspd_check_failing,aspd_fault_declared,aspd_use_inhibit,aspd_fail_rtl,load_factor_ratio

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.nav_state is None:
        self.nav_state = 0
      if self.arming_state is None:
        self.arming_state = 0
      if self.hil_state is None:
        self.hil_state = 0
      if self.failsafe is None:
        self.failsafe = False
      if self.system_type is None:
        self.system_type = 0
      if self.system_id is None:
        self.system_id = 0
      if self.component_id is None:
        self.component_id = 0
      if self.vehicle_type is None:
        self.vehicle_type = 0
      if self.is_vtol is None:
        self.is_vtol = False
      if self.vtol_fw_permanent_stab is None:
        self.vtol_fw_permanent_stab = False
      if self.in_transition_mode is None:
        self.in_transition_mode = False
      if self.in_transition_to_fw is None:
        self.in_transition_to_fw = False
      if self.rc_signal_lost is None:
        self.rc_signal_lost = False
      if self.rc_input_mode is None:
        self.rc_input_mode = 0
      if self.data_link_lost is None:
        self.data_link_lost = False
      if self.data_link_lost_counter is None:
        self.data_link_lost_counter = 0
      if self.high_latency_data_link_lost is None:
        self.high_latency_data_link_lost = False
      if self.engine_failure is None:
        self.engine_failure = False
      if self.mission_failure is None:
        self.mission_failure = False
      if self.failure_detector_status is None:
        self.failure_detector_status = 0
      if self.onboard_control_sensors_present is None:
        self.onboard_control_sensors_present = 0
      if self.onboard_control_sensors_enabled is None:
        self.onboard_control_sensors_enabled = 0
      if self.onboard_control_sensors_health is None:
        self.onboard_control_sensors_health = 0
      if self.arspd_check_level is None:
        self.arspd_check_level = 0.
      if self.aspd_check_failing is None:
        self.aspd_check_failing = False
      if self.aspd_fault_declared is None:
        self.aspd_fault_declared = False
      if self.aspd_use_inhibit is None:
        self.aspd_use_inhibit = False
      if self.aspd_fail_rtl is None:
        self.aspd_fail_rtl = False
      if self.load_factor_ratio is None:
        self.load_factor_ratio = 0.
    else:
      self.timestamp = 0
      self.nav_state = 0
      self.arming_state = 0
      self.hil_state = 0
      self.failsafe = False
      self.system_type = 0
      self.system_id = 0
      self.component_id = 0
      self.vehicle_type = 0
      self.is_vtol = False
      self.vtol_fw_permanent_stab = False
      self.in_transition_mode = False
      self.in_transition_to_fw = False
      self.rc_signal_lost = False
      self.rc_input_mode = 0
      self.data_link_lost = False
      self.data_link_lost_counter = 0
      self.high_latency_data_link_lost = False
      self.engine_failure = False
      self.mission_failure = False
      self.failure_detector_status = 0
      self.onboard_control_sensors_present = 0
      self.onboard_control_sensors_enabled = 0
      self.onboard_control_sensors_health = 0
      self.arspd_check_level = 0.
      self.aspd_check_failing = False
      self.aspd_fault_declared = False
      self.aspd_use_inhibit = False
      self.aspd_fail_rtl = False
      self.load_factor_ratio = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q20B3If4Bf().pack(_x.timestamp, _x.nav_state, _x.arming_state, _x.hil_state, _x.failsafe, _x.system_type, _x.system_id, _x.component_id, _x.vehicle_type, _x.is_vtol, _x.vtol_fw_permanent_stab, _x.in_transition_mode, _x.in_transition_to_fw, _x.rc_signal_lost, _x.rc_input_mode, _x.data_link_lost, _x.data_link_lost_counter, _x.high_latency_data_link_lost, _x.engine_failure, _x.mission_failure, _x.failure_detector_status, _x.onboard_control_sensors_present, _x.onboard_control_sensors_enabled, _x.onboard_control_sensors_health, _x.arspd_check_level, _x.aspd_check_failing, _x.aspd_fault_declared, _x.aspd_use_inhibit, _x.aspd_fail_rtl, _x.load_factor_ratio))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 52
      (_x.timestamp, _x.nav_state, _x.arming_state, _x.hil_state, _x.failsafe, _x.system_type, _x.system_id, _x.component_id, _x.vehicle_type, _x.is_vtol, _x.vtol_fw_permanent_stab, _x.in_transition_mode, _x.in_transition_to_fw, _x.rc_signal_lost, _x.rc_input_mode, _x.data_link_lost, _x.data_link_lost_counter, _x.high_latency_data_link_lost, _x.engine_failure, _x.mission_failure, _x.failure_detector_status, _x.onboard_control_sensors_present, _x.onboard_control_sensors_enabled, _x.onboard_control_sensors_health, _x.arspd_check_level, _x.aspd_check_failing, _x.aspd_fault_declared, _x.aspd_use_inhibit, _x.aspd_fail_rtl, _x.load_factor_ratio,) = _get_struct_Q20B3If4Bf().unpack(str[start:end])
      self.failsafe = bool(self.failsafe)
      self.is_vtol = bool(self.is_vtol)
      self.vtol_fw_permanent_stab = bool(self.vtol_fw_permanent_stab)
      self.in_transition_mode = bool(self.in_transition_mode)
      self.in_transition_to_fw = bool(self.in_transition_to_fw)
      self.rc_signal_lost = bool(self.rc_signal_lost)
      self.data_link_lost = bool(self.data_link_lost)
      self.high_latency_data_link_lost = bool(self.high_latency_data_link_lost)
      self.engine_failure = bool(self.engine_failure)
      self.mission_failure = bool(self.mission_failure)
      self.aspd_check_failing = bool(self.aspd_check_failing)
      self.aspd_fault_declared = bool(self.aspd_fault_declared)
      self.aspd_use_inhibit = bool(self.aspd_use_inhibit)
      self.aspd_fail_rtl = bool(self.aspd_fail_rtl)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q20B3If4Bf().pack(_x.timestamp, _x.nav_state, _x.arming_state, _x.hil_state, _x.failsafe, _x.system_type, _x.system_id, _x.component_id, _x.vehicle_type, _x.is_vtol, _x.vtol_fw_permanent_stab, _x.in_transition_mode, _x.in_transition_to_fw, _x.rc_signal_lost, _x.rc_input_mode, _x.data_link_lost, _x.data_link_lost_counter, _x.high_latency_data_link_lost, _x.engine_failure, _x.mission_failure, _x.failure_detector_status, _x.onboard_control_sensors_present, _x.onboard_control_sensors_enabled, _x.onboard_control_sensors_health, _x.arspd_check_level, _x.aspd_check_failing, _x.aspd_fault_declared, _x.aspd_use_inhibit, _x.aspd_fail_rtl, _x.load_factor_ratio))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 52
      (_x.timestamp, _x.nav_state, _x.arming_state, _x.hil_state, _x.failsafe, _x.system_type, _x.system_id, _x.component_id, _x.vehicle_type, _x.is_vtol, _x.vtol_fw_permanent_stab, _x.in_transition_mode, _x.in_transition_to_fw, _x.rc_signal_lost, _x.rc_input_mode, _x.data_link_lost, _x.data_link_lost_counter, _x.high_latency_data_link_lost, _x.engine_failure, _x.mission_failure, _x.failure_detector_status, _x.onboard_control_sensors_present, _x.onboard_control_sensors_enabled, _x.onboard_control_sensors_health, _x.arspd_check_level, _x.aspd_check_failing, _x.aspd_fault_declared, _x.aspd_use_inhibit, _x.aspd_fail_rtl, _x.load_factor_ratio,) = _get_struct_Q20B3If4Bf().unpack(str[start:end])
      self.failsafe = bool(self.failsafe)
      self.is_vtol = bool(self.is_vtol)
      self.vtol_fw_permanent_stab = bool(self.vtol_fw_permanent_stab)
      self.in_transition_mode = bool(self.in_transition_mode)
      self.in_transition_to_fw = bool(self.in_transition_to_fw)
      self.rc_signal_lost = bool(self.rc_signal_lost)
      self.data_link_lost = bool(self.data_link_lost)
      self.high_latency_data_link_lost = bool(self.high_latency_data_link_lost)
      self.engine_failure = bool(self.engine_failure)
      self.mission_failure = bool(self.mission_failure)
      self.aspd_check_failing = bool(self.aspd_check_failing)
      self.aspd_fault_declared = bool(self.aspd_fault_declared)
      self.aspd_use_inhibit = bool(self.aspd_use_inhibit)
      self.aspd_fail_rtl = bool(self.aspd_fail_rtl)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q20B3If4Bf = None
def _get_struct_Q20B3If4Bf():
    global _struct_Q20B3If4Bf
    if _struct_Q20B3If4Bf is None:
        _struct_Q20B3If4Bf = struct.Struct("<Q20B3If4Bf")
    return _struct_Q20B3If4Bf
