# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/VehicleStatusFlags.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class VehicleStatusFlags(genpy.Message):
  _md5sum = "6b9271c4a9559bb9b873ad79daea7e72"
  _type = "px4_msgs/VehicleStatusFlags"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This is a struct used by the commander internally.

uint64 timestamp				# time since system start (microseconds)

bool condition_calibration_enabled
bool condition_system_sensors_initialized
bool condition_system_hotplug_timeout		# true if the hotplug sensor search is over
bool condition_system_returned_to_home
bool condition_auto_mission_available
bool condition_global_position_valid		# set to true by the commander app if the quality of the global position estimate is good enough to use for navigation
bool condition_home_position_valid			# indicates a valid home position (a valid home position is not always a valid launch)
bool condition_local_position_valid		# set to true by the commander app if the quality of the local position estimate is good enough to use for navigation
bool condition_local_velocity_valid		# set to true by the commander app if the quality of the local horizontal velocity data is good enough to use for navigation
bool condition_local_altitude_valid
bool condition_power_input_valid                # set if input power is valid
bool condition_battery_healthy                # set if battery is available and not low
bool condition_escs_error		      # set to true if one or more ESCs reporting esc_status are offline
bool circuit_breaker_engaged_power_check
bool circuit_breaker_engaged_airspd_check
bool circuit_breaker_engaged_enginefailure_check
bool circuit_breaker_engaged_gpsfailure_check
bool circuit_breaker_flight_termination_disabled
bool circuit_breaker_engaged_usb_check
bool circuit_breaker_engaged_posfailure_check	# set to true when the position valid checks have been disabled

bool offboard_control_signal_found_once
bool offboard_control_signal_lost
bool offboard_control_set_by_command                # true if the offboard mode was set by a mavlink command and should not be overridden by RC
bool offboard_control_loss_timeout                # true if offboard is lost for a certain amount of time

bool rc_signal_found_once
bool rc_input_blocked                                # set if RC input should be ignored temporarily
bool rc_calibration_valid                            # set if RC calibration is valid
bool vtol_transition_failure                        # Set to true if vtol transition failed
bool usb_connected                                # status of the USB power supply

bool avoidance_system_required					  # Set to true if avoidance system is enabled via COM_OBS_AVOID parameter
bool avoidance_system_valid                       # Status of the obstacle avoidance system
"""
  __slots__ = ['timestamp','condition_calibration_enabled','condition_system_sensors_initialized','condition_system_hotplug_timeout','condition_system_returned_to_home','condition_auto_mission_available','condition_global_position_valid','condition_home_position_valid','condition_local_position_valid','condition_local_velocity_valid','condition_local_altitude_valid','condition_power_input_valid','condition_battery_healthy','condition_escs_error','circuit_breaker_engaged_power_check','circuit_breaker_engaged_airspd_check','circuit_breaker_engaged_enginefailure_check','circuit_breaker_engaged_gpsfailure_check','circuit_breaker_flight_termination_disabled','circuit_breaker_engaged_usb_check','circuit_breaker_engaged_posfailure_check','offboard_control_signal_found_once','offboard_control_signal_lost','offboard_control_set_by_command','offboard_control_loss_timeout','rc_signal_found_once','rc_input_blocked','rc_calibration_valid','vtol_transition_failure','usb_connected','avoidance_system_required','avoidance_system_valid']
  _slot_types = ['uint64','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,condition_calibration_enabled,condition_system_sensors_initialized,condition_system_hotplug_timeout,condition_system_returned_to_home,condition_auto_mission_available,condition_global_position_valid,condition_home_position_valid,condition_local_position_valid,condition_local_velocity_valid,condition_local_altitude_valid,condition_power_input_valid,condition_battery_healthy,condition_escs_error,circuit_breaker_engaged_power_check,circuit_breaker_engaged_airspd_check,circuit_breaker_engaged_enginefailure_check,circuit_breaker_engaged_gpsfailure_check,circuit_breaker_flight_termination_disabled,circuit_breaker_engaged_usb_check,circuit_breaker_engaged_posfailure_check,offboard_control_signal_found_once,offboard_control_signal_lost,offboard_control_set_by_command,offboard_control_loss_timeout,rc_signal_found_once,rc_input_blocked,rc_calibration_valid,vtol_transition_failure,usb_connected,avoidance_system_required,avoidance_system_valid

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleStatusFlags, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.condition_calibration_enabled is None:
        self.condition_calibration_enabled = False
      if self.condition_system_sensors_initialized is None:
        self.condition_system_sensors_initialized = False
      if self.condition_system_hotplug_timeout is None:
        self.condition_system_hotplug_timeout = False
      if self.condition_system_returned_to_home is None:
        self.condition_system_returned_to_home = False
      if self.condition_auto_mission_available is None:
        self.condition_auto_mission_available = False
      if self.condition_global_position_valid is None:
        self.condition_global_position_valid = False
      if self.condition_home_position_valid is None:
        self.condition_home_position_valid = False
      if self.condition_local_position_valid is None:
        self.condition_local_position_valid = False
      if self.condition_local_velocity_valid is None:
        self.condition_local_velocity_valid = False
      if self.condition_local_altitude_valid is None:
        self.condition_local_altitude_valid = False
      if self.condition_power_input_valid is None:
        self.condition_power_input_valid = False
      if self.condition_battery_healthy is None:
        self.condition_battery_healthy = False
      if self.condition_escs_error is None:
        self.condition_escs_error = False
      if self.circuit_breaker_engaged_power_check is None:
        self.circuit_breaker_engaged_power_check = False
      if self.circuit_breaker_engaged_airspd_check is None:
        self.circuit_breaker_engaged_airspd_check = False
      if self.circuit_breaker_engaged_enginefailure_check is None:
        self.circuit_breaker_engaged_enginefailure_check = False
      if self.circuit_breaker_engaged_gpsfailure_check is None:
        self.circuit_breaker_engaged_gpsfailure_check = False
      if self.circuit_breaker_flight_termination_disabled is None:
        self.circuit_breaker_flight_termination_disabled = False
      if self.circuit_breaker_engaged_usb_check is None:
        self.circuit_breaker_engaged_usb_check = False
      if self.circuit_breaker_engaged_posfailure_check is None:
        self.circuit_breaker_engaged_posfailure_check = False
      if self.offboard_control_signal_found_once is None:
        self.offboard_control_signal_found_once = False
      if self.offboard_control_signal_lost is None:
        self.offboard_control_signal_lost = False
      if self.offboard_control_set_by_command is None:
        self.offboard_control_set_by_command = False
      if self.offboard_control_loss_timeout is None:
        self.offboard_control_loss_timeout = False
      if self.rc_signal_found_once is None:
        self.rc_signal_found_once = False
      if self.rc_input_blocked is None:
        self.rc_input_blocked = False
      if self.rc_calibration_valid is None:
        self.rc_calibration_valid = False
      if self.vtol_transition_failure is None:
        self.vtol_transition_failure = False
      if self.usb_connected is None:
        self.usb_connected = False
      if self.avoidance_system_required is None:
        self.avoidance_system_required = False
      if self.avoidance_system_valid is None:
        self.avoidance_system_valid = False
    else:
      self.timestamp = 0
      self.condition_calibration_enabled = False
      self.condition_system_sensors_initialized = False
      self.condition_system_hotplug_timeout = False
      self.condition_system_returned_to_home = False
      self.condition_auto_mission_available = False
      self.condition_global_position_valid = False
      self.condition_home_position_valid = False
      self.condition_local_position_valid = False
      self.condition_local_velocity_valid = False
      self.condition_local_altitude_valid = False
      self.condition_power_input_valid = False
      self.condition_battery_healthy = False
      self.condition_escs_error = False
      self.circuit_breaker_engaged_power_check = False
      self.circuit_breaker_engaged_airspd_check = False
      self.circuit_breaker_engaged_enginefailure_check = False
      self.circuit_breaker_engaged_gpsfailure_check = False
      self.circuit_breaker_flight_termination_disabled = False
      self.circuit_breaker_engaged_usb_check = False
      self.circuit_breaker_engaged_posfailure_check = False
      self.offboard_control_signal_found_once = False
      self.offboard_control_signal_lost = False
      self.offboard_control_set_by_command = False
      self.offboard_control_loss_timeout = False
      self.rc_signal_found_once = False
      self.rc_input_blocked = False
      self.rc_calibration_valid = False
      self.vtol_transition_failure = False
      self.usb_connected = False
      self.avoidance_system_required = False
      self.avoidance_system_valid = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q31B().pack(_x.timestamp, _x.condition_calibration_enabled, _x.condition_system_sensors_initialized, _x.condition_system_hotplug_timeout, _x.condition_system_returned_to_home, _x.condition_auto_mission_available, _x.condition_global_position_valid, _x.condition_home_position_valid, _x.condition_local_position_valid, _x.condition_local_velocity_valid, _x.condition_local_altitude_valid, _x.condition_power_input_valid, _x.condition_battery_healthy, _x.condition_escs_error, _x.circuit_breaker_engaged_power_check, _x.circuit_breaker_engaged_airspd_check, _x.circuit_breaker_engaged_enginefailure_check, _x.circuit_breaker_engaged_gpsfailure_check, _x.circuit_breaker_flight_termination_disabled, _x.circuit_breaker_engaged_usb_check, _x.circuit_breaker_engaged_posfailure_check, _x.offboard_control_signal_found_once, _x.offboard_control_signal_lost, _x.offboard_control_set_by_command, _x.offboard_control_loss_timeout, _x.rc_signal_found_once, _x.rc_input_blocked, _x.rc_calibration_valid, _x.vtol_transition_failure, _x.usb_connected, _x.avoidance_system_required, _x.avoidance_system_valid))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 39
      (_x.timestamp, _x.condition_calibration_enabled, _x.condition_system_sensors_initialized, _x.condition_system_hotplug_timeout, _x.condition_system_returned_to_home, _x.condition_auto_mission_available, _x.condition_global_position_valid, _x.condition_home_position_valid, _x.condition_local_position_valid, _x.condition_local_velocity_valid, _x.condition_local_altitude_valid, _x.condition_power_input_valid, _x.condition_battery_healthy, _x.condition_escs_error, _x.circuit_breaker_engaged_power_check, _x.circuit_breaker_engaged_airspd_check, _x.circuit_breaker_engaged_enginefailure_check, _x.circuit_breaker_engaged_gpsfailure_check, _x.circuit_breaker_flight_termination_disabled, _x.circuit_breaker_engaged_usb_check, _x.circuit_breaker_engaged_posfailure_check, _x.offboard_control_signal_found_once, _x.offboard_control_signal_lost, _x.offboard_control_set_by_command, _x.offboard_control_loss_timeout, _x.rc_signal_found_once, _x.rc_input_blocked, _x.rc_calibration_valid, _x.vtol_transition_failure, _x.usb_connected, _x.avoidance_system_required, _x.avoidance_system_valid,) = _get_struct_Q31B().unpack(str[start:end])
      self.condition_calibration_enabled = bool(self.condition_calibration_enabled)
      self.condition_system_sensors_initialized = bool(self.condition_system_sensors_initialized)
      self.condition_system_hotplug_timeout = bool(self.condition_system_hotplug_timeout)
      self.condition_system_returned_to_home = bool(self.condition_system_returned_to_home)
      self.condition_auto_mission_available = bool(self.condition_auto_mission_available)
      self.condition_global_position_valid = bool(self.condition_global_position_valid)
      self.condition_home_position_valid = bool(self.condition_home_position_valid)
      self.condition_local_position_valid = bool(self.condition_local_position_valid)
      self.condition_local_velocity_valid = bool(self.condition_local_velocity_valid)
      self.condition_local_altitude_valid = bool(self.condition_local_altitude_valid)
      self.condition_power_input_valid = bool(self.condition_power_input_valid)
      self.condition_battery_healthy = bool(self.condition_battery_healthy)
      self.condition_escs_error = bool(self.condition_escs_error)
      self.circuit_breaker_engaged_power_check = bool(self.circuit_breaker_engaged_power_check)
      self.circuit_breaker_engaged_airspd_check = bool(self.circuit_breaker_engaged_airspd_check)
      self.circuit_breaker_engaged_enginefailure_check = bool(self.circuit_breaker_engaged_enginefailure_check)
      self.circuit_breaker_engaged_gpsfailure_check = bool(self.circuit_breaker_engaged_gpsfailure_check)
      self.circuit_breaker_flight_termination_disabled = bool(self.circuit_breaker_flight_termination_disabled)
      self.circuit_breaker_engaged_usb_check = bool(self.circuit_breaker_engaged_usb_check)
      self.circuit_breaker_engaged_posfailure_check = bool(self.circuit_breaker_engaged_posfailure_check)
      self.offboard_control_signal_found_once = bool(self.offboard_control_signal_found_once)
      self.offboard_control_signal_lost = bool(self.offboard_control_signal_lost)
      self.offboard_control_set_by_command = bool(self.offboard_control_set_by_command)
      self.offboard_control_loss_timeout = bool(self.offboard_control_loss_timeout)
      self.rc_signal_found_once = bool(self.rc_signal_found_once)
      self.rc_input_blocked = bool(self.rc_input_blocked)
      self.rc_calibration_valid = bool(self.rc_calibration_valid)
      self.vtol_transition_failure = bool(self.vtol_transition_failure)
      self.usb_connected = bool(self.usb_connected)
      self.avoidance_system_required = bool(self.avoidance_system_required)
      self.avoidance_system_valid = bool(self.avoidance_system_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q31B().pack(_x.timestamp, _x.condition_calibration_enabled, _x.condition_system_sensors_initialized, _x.condition_system_hotplug_timeout, _x.condition_system_returned_to_home, _x.condition_auto_mission_available, _x.condition_global_position_valid, _x.condition_home_position_valid, _x.condition_local_position_valid, _x.condition_local_velocity_valid, _x.condition_local_altitude_valid, _x.condition_power_input_valid, _x.condition_battery_healthy, _x.condition_escs_error, _x.circuit_breaker_engaged_power_check, _x.circuit_breaker_engaged_airspd_check, _x.circuit_breaker_engaged_enginefailure_check, _x.circuit_breaker_engaged_gpsfailure_check, _x.circuit_breaker_flight_termination_disabled, _x.circuit_breaker_engaged_usb_check, _x.circuit_breaker_engaged_posfailure_check, _x.offboard_control_signal_found_once, _x.offboard_control_signal_lost, _x.offboard_control_set_by_command, _x.offboard_control_loss_timeout, _x.rc_signal_found_once, _x.rc_input_blocked, _x.rc_calibration_valid, _x.vtol_transition_failure, _x.usb_connected, _x.avoidance_system_required, _x.avoidance_system_valid))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 39
      (_x.timestamp, _x.condition_calibration_enabled, _x.condition_system_sensors_initialized, _x.condition_system_hotplug_timeout, _x.condition_system_returned_to_home, _x.condition_auto_mission_available, _x.condition_global_position_valid, _x.condition_home_position_valid, _x.condition_local_position_valid, _x.condition_local_velocity_valid, _x.condition_local_altitude_valid, _x.condition_power_input_valid, _x.condition_battery_healthy, _x.condition_escs_error, _x.circuit_breaker_engaged_power_check, _x.circuit_breaker_engaged_airspd_check, _x.circuit_breaker_engaged_enginefailure_check, _x.circuit_breaker_engaged_gpsfailure_check, _x.circuit_breaker_flight_termination_disabled, _x.circuit_breaker_engaged_usb_check, _x.circuit_breaker_engaged_posfailure_check, _x.offboard_control_signal_found_once, _x.offboard_control_signal_lost, _x.offboard_control_set_by_command, _x.offboard_control_loss_timeout, _x.rc_signal_found_once, _x.rc_input_blocked, _x.rc_calibration_valid, _x.vtol_transition_failure, _x.usb_connected, _x.avoidance_system_required, _x.avoidance_system_valid,) = _get_struct_Q31B().unpack(str[start:end])
      self.condition_calibration_enabled = bool(self.condition_calibration_enabled)
      self.condition_system_sensors_initialized = bool(self.condition_system_sensors_initialized)
      self.condition_system_hotplug_timeout = bool(self.condition_system_hotplug_timeout)
      self.condition_system_returned_to_home = bool(self.condition_system_returned_to_home)
      self.condition_auto_mission_available = bool(self.condition_auto_mission_available)
      self.condition_global_position_valid = bool(self.condition_global_position_valid)
      self.condition_home_position_valid = bool(self.condition_home_position_valid)
      self.condition_local_position_valid = bool(self.condition_local_position_valid)
      self.condition_local_velocity_valid = bool(self.condition_local_velocity_valid)
      self.condition_local_altitude_valid = bool(self.condition_local_altitude_valid)
      self.condition_power_input_valid = bool(self.condition_power_input_valid)
      self.condition_battery_healthy = bool(self.condition_battery_healthy)
      self.condition_escs_error = bool(self.condition_escs_error)
      self.circuit_breaker_engaged_power_check = bool(self.circuit_breaker_engaged_power_check)
      self.circuit_breaker_engaged_airspd_check = bool(self.circuit_breaker_engaged_airspd_check)
      self.circuit_breaker_engaged_enginefailure_check = bool(self.circuit_breaker_engaged_enginefailure_check)
      self.circuit_breaker_engaged_gpsfailure_check = bool(self.circuit_breaker_engaged_gpsfailure_check)
      self.circuit_breaker_flight_termination_disabled = bool(self.circuit_breaker_flight_termination_disabled)
      self.circuit_breaker_engaged_usb_check = bool(self.circuit_breaker_engaged_usb_check)
      self.circuit_breaker_engaged_posfailure_check = bool(self.circuit_breaker_engaged_posfailure_check)
      self.offboard_control_signal_found_once = bool(self.offboard_control_signal_found_once)
      self.offboard_control_signal_lost = bool(self.offboard_control_signal_lost)
      self.offboard_control_set_by_command = bool(self.offboard_control_set_by_command)
      self.offboard_control_loss_timeout = bool(self.offboard_control_loss_timeout)
      self.rc_signal_found_once = bool(self.rc_signal_found_once)
      self.rc_input_blocked = bool(self.rc_input_blocked)
      self.rc_calibration_valid = bool(self.rc_calibration_valid)
      self.vtol_transition_failure = bool(self.vtol_transition_failure)
      self.usb_connected = bool(self.usb_connected)
      self.avoidance_system_required = bool(self.avoidance_system_required)
      self.avoidance_system_valid = bool(self.avoidance_system_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q31B = None
def _get_struct_Q31B():
    global _struct_Q31B
    if _struct_Q31B is None:
        _struct_Q31B = struct.Struct("<Q31B")
    return _struct_Q31B
