# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/VehicleVisualOdometry.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class VehicleVisualOdometry(genpy.Message):
  _md5sum = "e3a42e7afc5aa5a320595631fc161f04"
  _type = "px4_msgs/VehicleVisualOdometry"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Vehicle odometry data. Fits ROS REP 147 for aerial vehicles
uint64 timestamp		# time since system start (microseconds)

# Covariance matrix index constants
uint8 COVARIANCE_MATRIX_X_VARIANCE=0
uint8 COVARIANCE_MATRIX_Y_VARIANCE=6
uint8 COVARIANCE_MATRIX_Z_VARIANCE=11
uint8 COVARIANCE_MATRIX_ROLL_VARIANCE=15
uint8 COVARIANCE_MATRIX_PITCH_VARIANCE=18
uint8 COVARIANCE_MATRIX_YAW_VARIANCE=20
uint8 COVARIANCE_MATRIX_VX_VARIANCE=0
uint8 COVARIANCE_MATRIX_VY_VARIANCE=6
uint8 COVARIANCE_MATRIX_VZ_VARIANCE=11
uint8 COVARIANCE_MATRIX_ROLLRATE_VARIANCE=15
uint8 COVARIANCE_MATRIX_PITCHRATE_VARIANCE=18
uint8 COVARIANCE_MATRIX_YAWRATE_VARIANCE=20

# Position and linear velocity frame of reference constants
uint8 LOCAL_FRAME_NED=0         # NED earth-fixed frame
uint8 LOCAL_FRAME_ENU=1         # ENU earth-fixed frame
uint8 LOCAL_FRAME_OTHER=2       # Not aligned with the std frames of reference

# Position and linear velocity local frame of reference
uint8 local_frame

# Position in meters. Frame of reference defined by local_frame. NaN if invalid/unknown
float32 x			# North position
float32 y			# East position
float32 z			# Down position

# Orientation quaternion. First value NaN if invalid/unknown
float32[4] q			# Quaternion rotation from FRD body frame to refernce frame
float32[4] q_offset		# Quaternion rotation from odometry reference frame to navigation frame

# Row-major representation of 6x6 pose cross-covariance matrix URT.
# NED earth-fixed frame.
# Order: x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis
# If position covariance invalid/unknown, first cell is NaN
# If orientation covariance invalid/unknown, 16th cell is NaN
float32[21] pose_covariance

# Velocity in meters/sec. Frame of reference defined by local_frame. NaN if invalid/unknown
float32 vx 			# North velocity
float32 vy			# East velocity
float32 vz			# Down velocity

# Angular rate in body-fixed frame (rad/s). NaN if invalid/unknown
float32 rollspeed		# Angular velocity about X body axis
float32 pitchspeed		# Angular velocity about Y body axis
float32 yawspeed		# Angular velocity about Z body axis

# Row-major representation of 6x6 velocity cross-covariance matrix URT.
# Linear velocity in NED earth-fixed frame. Angular velocity in body-fixed frame.
# Order: vx, vy, vz, rotation rate about X axis, rotation rate about Y axis, rotation rate about Z axis
# If linear velocity covariance invalid/unknown, first cell is NaN
# If angular velocity covariance invalid/unknown, 16th cell is NaN
float32[21] velocity_covariance

"""
  # Pseudo-constants
  COVARIANCE_MATRIX_X_VARIANCE = 0
  COVARIANCE_MATRIX_Y_VARIANCE = 6
  COVARIANCE_MATRIX_Z_VARIANCE = 11
  COVARIANCE_MATRIX_ROLL_VARIANCE = 15
  COVARIANCE_MATRIX_PITCH_VARIANCE = 18
  COVARIANCE_MATRIX_YAW_VARIANCE = 20
  COVARIANCE_MATRIX_VX_VARIANCE = 0
  COVARIANCE_MATRIX_VY_VARIANCE = 6
  COVARIANCE_MATRIX_VZ_VARIANCE = 11
  COVARIANCE_MATRIX_ROLLRATE_VARIANCE = 15
  COVARIANCE_MATRIX_PITCHRATE_VARIANCE = 18
  COVARIANCE_MATRIX_YAWRATE_VARIANCE = 20
  LOCAL_FRAME_NED = 0
  LOCAL_FRAME_ENU = 1
  LOCAL_FRAME_OTHER = 2

  __slots__ = ['timestamp','local_frame','x','y','z','q','q_offset','pose_covariance','vx','vy','vz','rollspeed','pitchspeed','yawspeed','velocity_covariance']
  _slot_types = ['uint64','uint8','float32','float32','float32','float32[4]','float32[4]','float32[21]','float32','float32','float32','float32','float32','float32','float32[21]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,local_frame,x,y,z,q,q_offset,pose_covariance,vx,vy,vz,rollspeed,pitchspeed,yawspeed,velocity_covariance

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleVisualOdometry, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.local_frame is None:
        self.local_frame = 0
      if self.x is None:
        self.x = 0.
      if self.y is None:
        self.y = 0.
      if self.z is None:
        self.z = 0.
      if self.q is None:
        self.q = [0.] * 4
      if self.q_offset is None:
        self.q_offset = [0.] * 4
      if self.pose_covariance is None:
        self.pose_covariance = [0.] * 21
      if self.vx is None:
        self.vx = 0.
      if self.vy is None:
        self.vy = 0.
      if self.vz is None:
        self.vz = 0.
      if self.rollspeed is None:
        self.rollspeed = 0.
      if self.pitchspeed is None:
        self.pitchspeed = 0.
      if self.yawspeed is None:
        self.yawspeed = 0.
      if self.velocity_covariance is None:
        self.velocity_covariance = [0.] * 21
    else:
      self.timestamp = 0
      self.local_frame = 0
      self.x = 0.
      self.y = 0.
      self.z = 0.
      self.q = [0.] * 4
      self.q_offset = [0.] * 4
      self.pose_covariance = [0.] * 21
      self.vx = 0.
      self.vy = 0.
      self.vz = 0.
      self.rollspeed = 0.
      self.pitchspeed = 0.
      self.yawspeed = 0.
      self.velocity_covariance = [0.] * 21

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_QB3f().pack(_x.timestamp, _x.local_frame, _x.x, _x.y, _x.z))
      buff.write(_get_struct_4f().pack(*self.q))
      buff.write(_get_struct_4f().pack(*self.q_offset))
      buff.write(_get_struct_21f().pack(*self.pose_covariance))
      _x = self
      buff.write(_get_struct_6f().pack(_x.vx, _x.vy, _x.vz, _x.rollspeed, _x.pitchspeed, _x.yawspeed))
      buff.write(_get_struct_21f().pack(*self.velocity_covariance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 21
      (_x.timestamp, _x.local_frame, _x.x, _x.y, _x.z,) = _get_struct_QB3f().unpack(str[start:end])
      start = end
      end += 16
      self.q = _get_struct_4f().unpack(str[start:end])
      start = end
      end += 16
      self.q_offset = _get_struct_4f().unpack(str[start:end])
      start = end
      end += 84
      self.pose_covariance = _get_struct_21f().unpack(str[start:end])
      _x = self
      start = end
      end += 24
      (_x.vx, _x.vy, _x.vz, _x.rollspeed, _x.pitchspeed, _x.yawspeed,) = _get_struct_6f().unpack(str[start:end])
      start = end
      end += 84
      self.velocity_covariance = _get_struct_21f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_QB3f().pack(_x.timestamp, _x.local_frame, _x.x, _x.y, _x.z))
      buff.write(self.q.tostring())
      buff.write(self.q_offset.tostring())
      buff.write(self.pose_covariance.tostring())
      _x = self
      buff.write(_get_struct_6f().pack(_x.vx, _x.vy, _x.vz, _x.rollspeed, _x.pitchspeed, _x.yawspeed))
      buff.write(self.velocity_covariance.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 21
      (_x.timestamp, _x.local_frame, _x.x, _x.y, _x.z,) = _get_struct_QB3f().unpack(str[start:end])
      start = end
      end += 16
      self.q = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=4)
      start = end
      end += 16
      self.q_offset = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=4)
      start = end
      end += 84
      self.pose_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=21)
      _x = self
      start = end
      end += 24
      (_x.vx, _x.vy, _x.vz, _x.rollspeed, _x.pitchspeed, _x.yawspeed,) = _get_struct_6f().unpack(str[start:end])
      start = end
      end += 84
      self.velocity_covariance = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=21)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_21f = None
def _get_struct_21f():
    global _struct_21f
    if _struct_21f is None:
        _struct_21f = struct.Struct("<21f")
    return _struct_21f
_struct_4f = None
def _get_struct_4f():
    global _struct_4f
    if _struct_4f is None:
        _struct_4f = struct.Struct("<4f")
    return _struct_4f
_struct_6f = None
def _get_struct_6f():
    global _struct_6f
    if _struct_6f is None:
        _struct_6f = struct.Struct("<6f")
    return _struct_6f
_struct_QB3f = None
def _get_struct_QB3f():
    global _struct_QB3f
    if _struct_QB3f is None:
        _struct_QB3f = struct.Struct("<QB3f")
    return _struct_QB3f
