# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/VtolVehicleStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class VtolVehicleStatus(genpy.Message):
  _md5sum = "a7009ed71cb9f3c2f149d831d10413cd"
  _type = "px4_msgs/VtolVehicleStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# VEHICLE_VTOL_STATE, should match 1:1 MAVLinks's MAV_VTOL_STATE
uint8 VEHICLE_VTOL_STATE_UNDEFINED = 0
uint8 VEHICLE_VTOL_STATE_TRANSITION_TO_FW = 1
uint8 VEHICLE_VTOL_STATE_TRANSITION_TO_MC = 2
uint8 VEHICLE_VTOL_STATE_MC = 3
uint8 VEHICLE_VTOL_STATE_FW = 4

uint64 timestamp			# time since system start (microseconds)

bool vtol_in_rw_mode			# true: vtol vehicle is in rotating wing mode
bool vtol_in_trans_mode
bool in_transition_to_fw		# True if VTOL is doing a transition from MC to FW
bool vtol_transition_failsafe		# vtol in transition failsafe mode
bool fw_permanent_stab			# In fw mode stabilize attitude even if in manual mode
"""
  # Pseudo-constants
  VEHICLE_VTOL_STATE_UNDEFINED = 0
  VEHICLE_VTOL_STATE_TRANSITION_TO_FW = 1
  VEHICLE_VTOL_STATE_TRANSITION_TO_MC = 2
  VEHICLE_VTOL_STATE_MC = 3
  VEHICLE_VTOL_STATE_FW = 4

  __slots__ = ['timestamp','vtol_in_rw_mode','vtol_in_trans_mode','in_transition_to_fw','vtol_transition_failsafe','fw_permanent_stab']
  _slot_types = ['uint64','bool','bool','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,vtol_in_rw_mode,vtol_in_trans_mode,in_transition_to_fw,vtol_transition_failsafe,fw_permanent_stab

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VtolVehicleStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.vtol_in_rw_mode is None:
        self.vtol_in_rw_mode = False
      if self.vtol_in_trans_mode is None:
        self.vtol_in_trans_mode = False
      if self.in_transition_to_fw is None:
        self.in_transition_to_fw = False
      if self.vtol_transition_failsafe is None:
        self.vtol_transition_failsafe = False
      if self.fw_permanent_stab is None:
        self.fw_permanent_stab = False
    else:
      self.timestamp = 0
      self.vtol_in_rw_mode = False
      self.vtol_in_trans_mode = False
      self.in_transition_to_fw = False
      self.vtol_transition_failsafe = False
      self.fw_permanent_stab = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q5B().pack(_x.timestamp, _x.vtol_in_rw_mode, _x.vtol_in_trans_mode, _x.in_transition_to_fw, _x.vtol_transition_failsafe, _x.fw_permanent_stab))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 13
      (_x.timestamp, _x.vtol_in_rw_mode, _x.vtol_in_trans_mode, _x.in_transition_to_fw, _x.vtol_transition_failsafe, _x.fw_permanent_stab,) = _get_struct_Q5B().unpack(str[start:end])
      self.vtol_in_rw_mode = bool(self.vtol_in_rw_mode)
      self.vtol_in_trans_mode = bool(self.vtol_in_trans_mode)
      self.in_transition_to_fw = bool(self.in_transition_to_fw)
      self.vtol_transition_failsafe = bool(self.vtol_transition_failsafe)
      self.fw_permanent_stab = bool(self.fw_permanent_stab)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q5B().pack(_x.timestamp, _x.vtol_in_rw_mode, _x.vtol_in_trans_mode, _x.in_transition_to_fw, _x.vtol_transition_failsafe, _x.fw_permanent_stab))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 13
      (_x.timestamp, _x.vtol_in_rw_mode, _x.vtol_in_trans_mode, _x.in_transition_to_fw, _x.vtol_transition_failsafe, _x.fw_permanent_stab,) = _get_struct_Q5B().unpack(str[start:end])
      self.vtol_in_rw_mode = bool(self.vtol_in_rw_mode)
      self.vtol_in_trans_mode = bool(self.vtol_in_trans_mode)
      self.in_transition_to_fw = bool(self.in_transition_to_fw)
      self.vtol_transition_failsafe = bool(self.vtol_transition_failsafe)
      self.fw_permanent_stab = bool(self.fw_permanent_stab)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q5B = None
def _get_struct_Q5B():
    global _struct_Q5B
    if _struct_Q5B is None:
        _struct_Q5B = struct.Struct("<Q5B")
    return _struct_Q5B
