# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from px4_msgs/WindEstimate.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class WindEstimate(genpy.Message):
  _md5sum = "58e0bfa192a8118f1f33d43ce7481905"
  _type = "px4_msgs/WindEstimate"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint64 timestamp		# time since system start (microseconds)
float32 windspeed_north		# Wind component in north / X direction (m/sec)
float32 windspeed_east		# Wind component in east / Y direction (m/sec)

float32 variance_north		# Wind estimate error variance in north / X direction (m/sec)**2 - set to zero (no uncertainty) if not estimated
float32 variance_east		# Wind estimate error variance in east / Y direction (m/sec)**2 - set to zero (no uncertainty) if not estimated

float32 tas_innov 		# True airspeed innovation
float32 tas_innov_var 		# True airspeed innovation variance
float32 tas_scale 		# Estimated true airspeed scale factor

float32 beta_innov 		# Sideslip measurement innovation
float32 beta_innov_var 		# Sideslip measurement innovation variance
"""
  __slots__ = ['timestamp','windspeed_north','windspeed_east','variance_north','variance_east','tas_innov','tas_innov_var','tas_scale','beta_innov','beta_innov_var']
  _slot_types = ['uint64','float32','float32','float32','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,windspeed_north,windspeed_east,variance_north,variance_east,tas_innov,tas_innov_var,tas_scale,beta_innov,beta_innov_var

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(WindEstimate, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = 0
      if self.windspeed_north is None:
        self.windspeed_north = 0.
      if self.windspeed_east is None:
        self.windspeed_east = 0.
      if self.variance_north is None:
        self.variance_north = 0.
      if self.variance_east is None:
        self.variance_east = 0.
      if self.tas_innov is None:
        self.tas_innov = 0.
      if self.tas_innov_var is None:
        self.tas_innov_var = 0.
      if self.tas_scale is None:
        self.tas_scale = 0.
      if self.beta_innov is None:
        self.beta_innov = 0.
      if self.beta_innov_var is None:
        self.beta_innov_var = 0.
    else:
      self.timestamp = 0
      self.windspeed_north = 0.
      self.windspeed_east = 0.
      self.variance_north = 0.
      self.variance_east = 0.
      self.tas_innov = 0.
      self.tas_innov_var = 0.
      self.tas_scale = 0.
      self.beta_innov = 0.
      self.beta_innov_var = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Q9f().pack(_x.timestamp, _x.windspeed_north, _x.windspeed_east, _x.variance_north, _x.variance_east, _x.tas_innov, _x.tas_innov_var, _x.tas_scale, _x.beta_innov, _x.beta_innov_var))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 44
      (_x.timestamp, _x.windspeed_north, _x.windspeed_east, _x.variance_north, _x.variance_east, _x.tas_innov, _x.tas_innov_var, _x.tas_scale, _x.beta_innov, _x.beta_innov_var,) = _get_struct_Q9f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Q9f().pack(_x.timestamp, _x.windspeed_north, _x.windspeed_east, _x.variance_north, _x.variance_east, _x.tas_innov, _x.tas_innov_var, _x.tas_scale, _x.beta_innov, _x.beta_innov_var))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 44
      (_x.timestamp, _x.windspeed_north, _x.windspeed_east, _x.variance_north, _x.variance_east, _x.tas_innov, _x.tas_innov_var, _x.tas_scale, _x.beta_innov, _x.beta_innov_var,) = _get_struct_Q9f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Q9f = None
def _get_struct_Q9f():
    global _struct_Q9f
    if _struct_Q9f is None:
        _struct_Q9f = struct.Struct("<Q9f")
    return _struct_Q9f
