// Auto-generated. Do not edit!

// (in-package px4_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class SensorBias {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.timestamp = null;
      this.gyro_bias = null;
      this.accel_bias = null;
      this.mag_bias = null;
    }
    else {
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = 0;
      }
      if (initObj.hasOwnProperty('gyro_bias')) {
        this.gyro_bias = initObj.gyro_bias
      }
      else {
        this.gyro_bias = new Array(3).fill(0);
      }
      if (initObj.hasOwnProperty('accel_bias')) {
        this.accel_bias = initObj.accel_bias
      }
      else {
        this.accel_bias = new Array(3).fill(0);
      }
      if (initObj.hasOwnProperty('mag_bias')) {
        this.mag_bias = initObj.mag_bias
      }
      else {
        this.mag_bias = new Array(3).fill(0);
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SensorBias
    // Serialize message field [timestamp]
    bufferOffset = _serializer.uint64(obj.timestamp, buffer, bufferOffset);
    // Check that the constant length array field [gyro_bias] has the right length
    if (obj.gyro_bias.length !== 3) {
      throw new Error('Unable to serialize array field gyro_bias - length must be 3')
    }
    // Serialize message field [gyro_bias]
    bufferOffset = _arraySerializer.float32(obj.gyro_bias, buffer, bufferOffset, 3);
    // Check that the constant length array field [accel_bias] has the right length
    if (obj.accel_bias.length !== 3) {
      throw new Error('Unable to serialize array field accel_bias - length must be 3')
    }
    // Serialize message field [accel_bias]
    bufferOffset = _arraySerializer.float32(obj.accel_bias, buffer, bufferOffset, 3);
    // Check that the constant length array field [mag_bias] has the right length
    if (obj.mag_bias.length !== 3) {
      throw new Error('Unable to serialize array field mag_bias - length must be 3')
    }
    // Serialize message field [mag_bias]
    bufferOffset = _arraySerializer.float32(obj.mag_bias, buffer, bufferOffset, 3);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SensorBias
    let len;
    let data = new SensorBias(null);
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.uint64(buffer, bufferOffset);
    // Deserialize message field [gyro_bias]
    data.gyro_bias = _arrayDeserializer.float32(buffer, bufferOffset, 3)
    // Deserialize message field [accel_bias]
    data.accel_bias = _arrayDeserializer.float32(buffer, bufferOffset, 3)
    // Deserialize message field [mag_bias]
    data.mag_bias = _arrayDeserializer.float32(buffer, bufferOffset, 3)
    return data;
  }

  static getMessageSize(object) {
    return 44;
  }

  static datatype() {
    // Returns string type for a message object
    return 'px4_msgs/SensorBias';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'b14b5028fc8331296d26ee796820c252';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    #
    # Sensor readings and in-run biases in SI-unit form. Sensor readings are compensated for static offsets,
    # scale errors, in-run bias and thermal drift (if thermal compensation is enabled and available).
    #
    
    uint64 timestamp		# time since system start (microseconds)
    
    # In-run bias estimates (subtract from uncorrected data)
    
    float32[3] gyro_bias		# gyroscope in-run bias in body frame (rad/s)
    
    float32[3] accel_bias		# accelerometer in-run bias in body frame (m/s^2)
    
    float32[3] mag_bias		# magnetometer in-run bias in body frame (Gauss)
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SensorBias(null);
    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = 0
    }

    if (msg.gyro_bias !== undefined) {
      resolved.gyro_bias = msg.gyro_bias;
    }
    else {
      resolved.gyro_bias = new Array(3).fill(0)
    }

    if (msg.accel_bias !== undefined) {
      resolved.accel_bias = msg.accel_bias;
    }
    else {
      resolved.accel_bias = new Array(3).fill(0)
    }

    if (msg.mag_bias !== undefined) {
      resolved.mag_bias = msg.mag_bias;
    }
    else {
      resolved.mag_bias = new Array(3).fill(0)
    }

    return resolved;
    }
};

module.exports = SensorBias;
